/**
 * SSH Server App
 * There are different ways implementing an App
 */
var surveillanceApp = surveillanceApp || {};  //Define App namespace, if you want.
/**
 * Constructor UNAS App
 */
surveillanceApp.App = function () {
    this.id = 'surveillance';
    this.name = 'surveillance';
    this.version = '6.0.30';
    this.active = false;
    this.menuIcon = '/apps/surveillance/images/logo.png?v=6.0.30&';
    this.shortcutIcon = '/apps/surveillance/images/logo.png?v=6.0.30&';
    this.entryUrl = '/apps/surveillance/index.html?v=6.0.30&';
    var self = this;
    this.surveillanceAppWindow = function () { //create app window
    	if(UNAS.CheckAppState('surveillance')){
            return false;
    	}
        self.window=new MUI.Window({
            id: 'surveillanceAppWindow',
            title: UNAS._('Surveillance'),
            icon: '/apps/surveillance/images/logo_small.png?v=6.0.30&',
            width: 820,
            height: 450,
            maximizable: false,
            resizable: true,
            scrollbars: false,
            resizeLimit: { 'x': [670, 2000], 'y': [500, 1500] },
            loadMethod: 'xhr',
            contentURL: '/apps/surveillance/index.html?v=6.0.30&',
            require: {  css: ['/apps/surveillance/css/style.css'] },
            onBeforeBuild: function(){UNAS.SetAppOpenedWindow("surveillance",'surveillanceAppWindow')}
        });
    };
    this.surveillanceAppUninstall = function (){
        UNAS.RemoveDesktopShortcut('surveillance');
        UNAS.RemoveMenu('surveillance');
        UNAS.RemoveAppFromGroups('surveillance', 'ControlPanel');
        // UNAS.RemoveAppFromGroups('surveillance', 'Help');
        UNAS.RemoveAppFromApps('surveillance');
    }
    new UNAS.Menu('UNAS_App_Multimedia_Menu', this.name, this.menuIcon, 'Surveillance', '', this.surveillanceAppWindow);
    new UNAS.DesktopShortcut(this.name, this.shortcutIcon, 'Surveillance', this.surveillanceAppWindow);
    var OnChangeLanguage = function (e) {
        UNAS.SetMenuTitle('surveillance', UNAS._('Surveillance')); //translate menu
        UNAS.SetShortcutTitle('surveillance', UNAS._('Surveillance')); //translate shortcut
        if (typeof self.window !== 'undefined') {
            UNAS.SetWindowTitle('surveillanceAppWindow', UNAS._('Surveillance'));
        }
    }
    UNAS.LoadTranslation('/apps/surveillance/languages/Translation?v='+this.version, OnChangeLanguage);
    UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
    UNAS.CreateApp(this.name,this.shortcutIcon,this.surveillanceAppWindow,this.surveillanceAppUninstall);
};

new surveillanceApp.App(); //Create app
