(function(){
    var _configStorageData=[];
    function init(){

        //为左侧选项卡的li元素注册点击事件
        $("#config-left-bar-ul li").on("click",function(){
            if($(this).hasClass("active")) return;
            //给激活样式之前先移除
            $("#config-left-bar-ul li").removeClass("active");
            $(this).addClass("active");

            //显示对应选项卡的内容
            $(".config-right-content-body").children("div").addClass("hide");
            $("[ref='"+this.id+"']").removeClass("hide");

            //最下方的保存按钮部分选项卡有特定的功能，如存储源
            if($(this).attr("id")=="config-li-storage"){
                $("#config-save-btn").addClass("hide");
                $("#config-new-storage-btn").removeClass("hide");
                $("#config-del-storage-btn").removeClass("hide");
            }
            else{
                $("#config-save-btn").removeClass("hide");
                $("#config-new-storage-btn").addClass("hide");
                $("#config-del-storage-btn").addClass("hide");
            }
        });

        //设置滚动条
        $(".config-li-table-content-scroll").mCustomScrollbar({
            autoHideScrollbar:false,
            theme:"minimal-dark",
            scrollInertia: 200
        });

        //第二列描述与第三列数值交换位置(由于html开发时将第二列和三列弄反，手动修改麻烦)
        $("tr:not(.config-li-storage tr)").each(function(){
            var tr1=$(this).children()[1];
            var tr2=$(this).children()[2];
            $(tr2).after(tr1);
        })

        //配置保存功能,仅保存被修改过的值，根据配置初始化时通过data方法绑定originValue的值来区分哪些值被修改过
        $("#config-save-btn").off('click').on("click",function(){
            //保存过滤器设置项
            if ($('#config-li-filter').hasClass('active')) {
                var modifiedFilterConfigData={};
                $(".config-right-content-body input[type=checkbox]").each(function(){
                    if ($(this).attr('name') == 'ZM_FILTER_STATUS[]') {
                        var id = $(this).attr('data-id');
                        modifiedFilterConfigData[id]=$(this).prop("checked")*1;
                    }
                });
                $.ajax({
                    url: "/zm/api/events/filterEdit.json?token="+window.zm.access_token,
                    type: "PUT",
                    dataType: "text",
                    async: true,
                    data: modifiedFilterConfigData,
                    success: function(data){
                        Message.success(myUNAS._('Saved'));
                    },
                    error:function(xhr, ajaxOptions, thrownError){
                        //console.log(xhr);
                        //console.log(ajaxOptions);
                        //console.log(thrownError);
                    }
                });

                return false;
            }

            var modifiedConfigData={};

            $(".config-right-content-body input[type=text],.config-right-content-body input[type=number],.config-right-content-body input[type=radio]:checked,.config-right-content-body textarea,.config-right-content-body select").each(function(){
                var originValue=!$(this).data("originValue")?"":$(this).data("originValue");

                if(originValue!=this.value){
                    modifiedConfigData[this.name]=this.value;
                }
            });

            //复选框处理
            $(".config-right-content-body input[type=checkbox]").each(function(){
                if ($(this).attr('name') != 'ZM_FILTER_STATUS[]') {
                    var originValue=!!$(this).data("originValue");
                    if($(this).prop("checked")!=originValue){
                        modifiedConfigData[this.id]=$(this).prop("checked")*1;
                    }
                }
            });

            //skin，css，apiUids[]这3项先移除
            //delete modifiedConfigData.skin
            //delete modifiedConfigData.css
            delete modifiedConfigData["apiUids[]"];
            //console.log(modifiedConfigData);

            var keyNum=Object.keys(modifiedConfigData).length;
            var count=0;                //对修改完成数量进行计数，每完成一次ajax请求则count++,所有配置项均保存成功后出现提示信息

            for(var item in modifiedConfigData){
                var _data={ "Config[Value]":modifiedConfigData[item] };
                //console.log(_data);
                $.ajax({
                    url: "/zm/api/configs/edit/"+item+".json?token="+window.zm.access_token,
                    type: "PUT",
                    dataType: "text",
                    async: true,
                    data: _data,
                    success: function(data){
                        //console.log(data);
                        //保存成功后更新其对应的data数据
                        $("[name='"+item+"']").data("originValue",_data["Config[Value]"]);

                        count++;
                        if(count==keyNum){
                            Message.success(myUNAS._('Saved'));
                            // Message.success(myUNAS._('Saved'), function(){
                                //若修改了语言这一配置项，完成修改后需要执行翻译
                            if (modifiedConfigData.ZM_LANG_DEFAULT) {
                                window.unasTranslation(modifiedConfigData.ZM_LANG_DEFAULT);
                                //修改url的language参数值,但不能刷新页面
                                var lang = '';
                                if (modifiedConfigData.ZM_LANG_DEFAULT == "简体中文" || modifiedConfigData.ZM_LANG_DEFAULT == "cn_zh" || modifiedConfigData.ZM_LANG_DEFAULT == "cn") {
                                    lang = 'cn';
                                } else if (modifiedConfigData.ZM_LANG_DEFAULT == "한국어" || modifiedConfigData.ZM_LANG_DEFAULT == "kr_ko" || modifiedConfigData.ZM_LANG_DEFAULT == "kr") {
                                    lang = 'kr';
                                } else if (modifiedConfigData.ZM_LANG_DEFAULT == "日本語" || modifiedConfigData.ZM_LANG_DEFAULT == "jp") {
                                    lang = 'jp';
                                } else {
                                    lang = 'en';
                                }
                                history.replaceState({}, "", window.location.href.replace("language=cn", "language=" + lang));
                                history.replaceState({}, "", window.location.href.replace("language=en", "language=" + lang));
                                history.replaceState({}, "", window.location.href.replace("language=kr", "language=" + lang));
                                history.replaceState({}, "", window.location.href.replace("language=jp", "language=" + lang));

                                setCookie("language", lang);
                                window.location.reload();
                            }
                            // });
                        }
                    },
                    error:function(xhr, ajaxOptions, thrownError){
                        //console.log(xhr);
                        //console.log(ajaxOptions);
                        //console.log(thrownError);
                    }
                });
            }
        });

        //重置功能，回到最初的设置
        $("#config-reset-btn").on("click",function(){
            //console.log("reset");
        });

        //存储源-删除
        $("#config-del-storage-btn").on("click",function(){
            // console.log("config-del-storage-btn");
            showConfirmDelete(function(){
                // console.log("test");
            });
        })

        //存储源-保存
        $("#config-storage-saveBtn").on("click",function(){
            // console.log("config-storage-saveBtn");
        })

        //初始化配置值
        initConfig();

        //初始化存储源的内容
        initStorage();

        initFilter();

        //存储源中的复选框，关联删除按钮，有选中的则可操作删除按钮
        $(document).on("change","[id^='markIds_']",function(){
            if($("[id^='markIds_']:checked").length>0){
                $("#config-del-storage-btn").removeClass("disable");
            }
            else{
                $("#config-del-storage-btn").addClass("disable");
            }
        });
        //新建存储源按钮
        $("#config-new-storage-btn").on("click",function(){
            showStorageConfig();
        });
        //编辑存储源按钮
        $(document).on("click","[id^='config-li-storage-edit-btn-']",function(){
            showStorageConfig({});
        });

        //执行翻译
        window.unasTranslation(myUNAS.CurrentLanguage);
    }

    function initConfig(){
        var _data={};
        $.ajax({
            url: "/zm/api/configs.json?token="+window.zm.access_token,
            type: "GET",
            dataType: "json",
            async: true,
            data: _data,
            success: function(data){
                if(data && data.configs){
                    $.each(data.configs,function(){
                        var _data=$("[name='"+this.Config.Name+"']");
                        if(_data.length==0){
                            return;
                        }


                        //文本框text，数字框number，下拉框select,textarea框赋值
                        //同时为其绑定一个同value的data属性，用于确认值是否被用户修改
                        if(_data.attr("type")=="text"
                            || _data.attr("type")=="number"
                            || _data[0].tagName=="SELECT"
                            || _data[0].tagName=="TEXTAREA"){
                            if(this.Config.Value!=""){
                                _data.val(this.Config.Value.replace(/ZoneMinder/gi,"Surveillance"));
                                _data.data("originValue",this.Config.Value.replace(/ZoneMinder/gi,"Surveillance"));
                            }
                            else{
                                _data.val(this.Config.DefaultValue.replace(/ZoneMinder/gi,"Surveillance"));
                                _data.data("originValue",this.Config.DefaultValue.replace(/ZoneMinder/gi,"Surveillance"));
                            }
                        }
                        //复选框赋值(由于配置项复选框都只有一个，所以可以这么写)
                        if(_data.attr("type")=="checkbox"){
                            if(this.Config.Value=="1"){
                                _data.prop("checked",true);
                                _data.data("originValue",true);
                            }
                            else{
                                _data.prop("checked",false);
                                _data.data("originValue",false);
                            }
                        }
                        //单选框赋值
                        if(_data.attr("type")=="radio"){
                            if(this.Config.Value!=""){
                                $("#"+this.Config.Name+"_"+this.Config.Value).prop("checked",true);
                                $("[name='"+this.Config.Name+"']").data("originValue",this.Config.Value);
                            }
                            else{
                                $("#"+this.Config.Name+"_"+this.Config.DefaultValue).prop("checked",true);
                                $("[name='"+this.Config.Name+"']").data("originValue",this.Config.DefaultValue);
                            }
                        }
                    });
                }else{
                    Message.error(myUNAS._('Failed to obtain configuration data'))
                }
            },
            error:function(xhr, ajaxOptions, thrownError){
            }
        });
    }

    function initFilter(){
        var _data={};
        $.ajax({
            url: "/zm/api/events/filter.json?token="+window.zm.access_token,
            type: "GET",
            dataType: "json",
            async: true,
            data: _data,
            success: function(data){
                var html = '';
                if (data.filters) {
                    for (var i=0; i<data.filters.length; i++) {
                        var item = data.filters[i];

                        var description = '';
                        if (item.name == 'PurgeWhenFull') {
                            description = myUNAS._('Configured to delete events if you reach 95% of disk space.');
                        }
                        if (item.name == 'Update DiskSpace') {
                            description = myUNAS._('Calculates how much disk space is currently taken by the event and updates the db record.');
                        }

                        var checked = '';
                        if (item.runInBackground == 1) {
                            checked = 'checked';
                        }

                        html += '<tr>' +
                            '<td width="25%">'+item.name+'</td>' +

                            '<td width="30%">' +
                            '<input type="checkbox" data-id="'+item.id+'" name="ZM_FILTER_STATUS[]" value="1" '+checked+'>' +
                            '</td>' +

                            '<td width="35%">'+description+'</td>' +
                            '</tr>'
                    }
                    $('.config-li-filter-content .config-li-table-content-scroll table').html(html);
                    $('#config-li-filter').removeClass('hide');
                }
            },
            error:function(xhr, ajaxOptions, thrownError){
            }
        });
    }

    function initStorage(){
        // console.log("initStorage");
        return;
        $.ajax({
            url: "/zm/api/configs.json?token="+window.zm.access_token,
            type: "GET",
            dataType: "json",
            async: true,
            data: _data,
            success: function(data){
                // console.log(data);
            },
            error:function(xhr, ajaxOptions, thrownError){
                Message.error(myUNAS._('Failed to obtain configuration data'))
            }
        });
    }
    //配置页面卸载
    function destroy(){
        console.log('destroy config');
        $("#main_container").children().remove();
    }
    //token过期并重新获取后,且当前选项卡处于配置页面时调用，一般用于刷新数据
    function update(){
        initConfig();
    }



    //设置某个配置项的值
    function setConfigItem(item, value, callback){
        $.ajax({
            url: "/zm/api/configs/edit/"+item+".json?token="+window.zm.access_token,
            type: "PUT",
            dataType: "text",
            async: true,
            data: { "Config[Value]":value },
            success: function(data){
                if(callback && typeof callback=="function"){
                    callback();
                }
            },
            error:function(xhr, ajaxOptions, thrownError){
            }
        });
    }
    //设置配置中的语言信息
    function setConfigLanguage(language){
        if (language == "简体中文" || language == "cn_zh" || language == "cn") {
            language = "cn";
        } else if (language == "한국어" || language == "kr_ko" || language == "kr") {
            language = "kr";
        } else if (language == "日本語" || language == 'jp') {
            language = 'jp'
        } else {
            language = "en";
        }
        setConfigItem('ZM_LANG_DEFAULT', language, null);
    }
    //获取配置中的语言信息
    function getConfigLanguage(){
        //console.log(window.zm.configs);
        var result = "English";
        if (window.zm.configs) {
            var configs = window.zm.configs;

            $.each(configs, function () {
                if (this.Config.Name == 'ZM_LANG_DEFAULT') {
                    // console.log('config name:'+this.Config.Name);
                    // console.log('config value:'+this.Config.Value);
                    if (this.Config.Value == "cn") {
                        result = "简体中文";
                    } else if (this.Config.Value == "kr") {
                        result = "한국어";
                    } else if (this.Config.Value == "jp") {
                        result = "日本語"
                    }
                    return false;
                }
            });
        }
        return result;
    }

    function getConfig(){
        $.ajax({
            url: "/zm/api/configs.json?token="+getCookie("access_token"),
            type: "GET",
            dataType: "json",
            async: true,
            success: function(data){
                if(data && data.configs){
                    window.zm.configs = data.configs;
                }
            },
            error:function(xhr, ajaxOptions, thrownError){
                //console.log('config getall error ajaxOptions:' + ajaxOptions);
            }
        });
    }
    //getConfig();

    //显示存储源页面
    function showStorageConfig(obj){
        if(obj){

        }
        else{

        }
        $("#popup_config_storage").show();
    }

    window.zm = window.zm || {};
    window.zm.init = window.zm.init || [];
    window.zm.init['config'] = init;
    window.zm.destroy = window.zm.destroy || [];
    window.zm.destroy['config'] = destroy;
    window.zm.update = window.zm.update || [];
    window.zm.update["config"]=update;

    window.zm.setConfigItem=setConfigItem;
    window.zm.setConfigLanguage=setConfigLanguage;
    window.zm.getConfigLanguage=getConfigLanguage;
})();



