(function () {
    var debug = 0;
    var _isLocalDebug = getParameterURL('localDebug');
    var _records;
    var _recordsPrev = [];
    var _recordIndexReset = -1;
    var _targetRecordIndex;
    var _recordId;

    var _pageCount = 0; //总页数
    var _pageNum = 1; //当前页号（下标从1开始）
    var _$pagination;
    var PAGE_SIZE = 25;

    var _startGetStatusTimer;
    var REFRESH_INTERVAL = 2000; //获取监视器状态 轮询请求间隔（单位：毫秒）
    var _forceStopStatusTimer = false;

    var _monitor_ratio = 16 / 9; //监视器宽高比
    var _monitorThumbWidth;
    var _monitorThumbHeight;

    var _foldRecordListTimer;
    var _getRecordListTimer;
    var FOLD_INTERVAL = 3000; //初始加载时，缩回右边回访列表的时间间隔（单位：毫秒）

    var _seekingTime = 1; //单步后退与单步前进的秒数
    var _seekingFastTime = 5; //快退与快进的秒数

    //若播放视频，则控制视频操作的video插件将被赋给player，否则该值无用
    var player;

    var MILLISECONDS_PER_DAY = 24 * 60 * 60 * 1000;
    var SECONDS_PER_HOUR = 60 * 60;
    var WIDTH_EXTRA = 40;
    var WIDTH_POINTER = 2;
    var WIDTH_HOUR_1 = 79;
    var WIDTH_HOUR_24 = WIDTH_HOUR_1 * 24;

    var $timelineCurrentTime;
    var $timelinePointer;
    var isMouseDownPointer = null;
    var forceSeekOffset = 0; //保存当前时间轴指针停留位置计算出的在对应回放上的seek位置（秒）

    var monitorName;
    var monitorLoading;
    var monitorServerId;
    var monitorImageObject;
    var monitorImageURL;
    var monitorLoadingStageURL;
    var monitorLoadStartTimems;
    var monitorLoadEndTimems;
    var monitorColour;
    var monitorWidth;
    var monitorHeight;
    var monitorIndex;
    var monitorNormalizeScale;
    var monitorZoomScale;
    var monitorCanvasObj;
    var monitorCanvasCtx;
    var monitorPtr;
    var numMonitors;
    var minTimeSecs;
    var maxTimeSec;
    var currentTimeSecs;
    var cHeight;
    var timeLabelsFractOfRow;
    var currentDisplayInterval;
    var currentScale;
    var currentSpeed;
    var speedIndex;
    var speeds;
    var liveMode;
    var fitMode;
    var reverseSpeeds;
    var playerIntervalTimer;

    var playSecsPerInterval; // How many seconds of recorded image we play per refresh determined by speed (replay rate) and display interval; (default=1 if coming from live)
    var timerInterval; // milliseconds between interrupts
    var timerObj;

    var aTimeline;
    var canvas;
    var rangeTimeSecs;
    var events_by_monitor_id;
    var events;
    var moveX;
    var displayTime;
    var selectMonitorId;
    var tunnerTimer = null;
    var snapshotTimer = null;
    var tunnerTimerInterval = 1000;
    var snapshotTimerInterval = 2000;
    var snapshotTimestamp;
    var playTime;
    var timeParts;
    var getrecordlisttimer = null;
    var currentPlaySec;
    var videoDuration;
    var playerPaused;
    var isPlayReverse;
    var getRecordListTimeInterval = 1000 * 10 //每隔 10s 获取一下事件列表
    // var recordMode;
    var codeFlg;
    var currentPlayTime;
    var timeLineCurrentTime;
    var page;
    var getRecordListEnd;
    var streamRecordId;
    var streamRecordData;
    var thumbTimeFlag;

    function init() {
        monitorName = [];
        monitorLoading = [];
        monitorServerId = [];
        monitorImageObject = [];
        monitorImageURL = [];
        monitorLoadingStageURL = [];
        monitorLoadStartTimems = [];
        monitorLoadEndTimems = [];
        monitorColour = [];
        monitorWidth = [];
        monitorHeight = [];
        monitorIndex = [];
        monitorNormalizeScale = [];
        monitorZoomScale = [];
        monitorCanvasObj = [];
        monitorCanvasCtx = [];
        monitorPtr = [];
        liveMode = 1;
        fitMode = 1;
        numMonitors = 0;
        minTimeSecs = Math.round(new Date().getTime() / 1000) - 3600;
        maxTimeSecs = Math.round(new Date().getTime() / 1000);
        currentTimeSecs = parseInt((minTimeSecs + maxTimeSecs) / 2);
        cHeight;
        currentDisplayInterval = 1000;
        currentScale = 1;
        currentSpeed = 1;
        speedIndex = 3;
        // speeds = [1/8, 1/4, 1/2, 1, 2, 4, 8, 16, 32, 64, 100];
        speeds = [{
            speed: 1 / 8,
            label: '1/8x'
        }, {
            speed: 1 / 4,
            label: '1/4x'
        }, {
            speed: 1 / 2,
            label: '1/2x'
        }, {
            speed: 1,
            label: '1x'
        }, {
            speed: 2,
            label: '2x'
        }, {
            speed: 4,
            label: '4x'
        }, {
            speed: 8,
            label: '8x'
        }, {
            speed: 16,
            label: '16x'
        },
            // {
            //     speed: 32,
            //     label: '32x'
            // }, {
            //     speed: 64,
            //     label: '64x'
            // }, {
            //     speed: 100,
            //     label: '100x'
            // }
        ];
        reverseSpeeds = [{
            speed: 1 / 8,
            label: '-1/8x'
        }, {
            speed: 1 / 4,
            label: '-1/4x'
        }, {
            speed: 1 / 2,
            label: '-1/2x'
        }, {
            speed: 1,
            label: '-1x'
        }, {
            speed: 2,
            label: '-2x'
        }, {
            speed: 4,
            label: '-4x'
        }, {
            speed: 8,
            label: '-8x'
        }, {
            speed: 16,
            label: '-16x'
        }];
        isPlayReverse = false;

        rangeTimeSecs = maxTimeSecs - minTimeSecs + 1;
        events_by_monitor_id = {};
        events = {};
        playSecsPerInterval = 1;

        freeTimeLastIntervals = [];
        imageLoadTimesEvaluated = 0;
        imageLoadTimesNeeded = 15;
        timeLabelsFractOfRow = 0.9;
        displayTime = 0;
        moveX = 0;
        timeParts = [];
        playTime = 0;
        snapshotTimestamp = 0;
        currentPlaySec = 0;
        videoDuration = 0;
        if (player) {
            player.dispose();
            player = null;
        }
        playerPaused = false;
        playerIntervalTimer = null;
        codeFlg = true; //图片模式暂时不做 默认true mp4模式
        currentPlayTime = 0;
        timeLineCurrentTime = null;
        page = 1;
        getRecordListEnd = false;
        streamRecordId = 0;
        streamRecordData = [];
        thumbTimeFlag = false;



        _records = [];
        _pageCount = 0; //总页数
        _pageNum = 1; //当前页号（下标从1开始）
        _$pagination = jQuery('#record_pagination');

        _monitor_ratio = 16 / 9;

        recordSelReset();
        initYearMonthDate();

        //获取监视器列表
        getMonitorList(function (monitorDatas) {
            // console.log(monitorDatas)
            // var monitorDatas = [];//test
            $('#record_sel_monitor').empty();
            // var str = '<option value="">' + myUNAS._('All') + '</option>';
            var str = '';

            var ZM_Monitor_Select_Monitor_Id = localStorage.getItem('ZM_Monitor_Select_Monitor_Id');
            var checkSelectMonitorIdIn = false;
            for (var i = 0, len = monitorDatas.length; i < len; ++i) {
                // str += '<option value="' + monitorDatas[i].Monitor.Id + '">' + monitorDatas[i].Monitor.Name + '-' + monitorDatas[i].Monitor.Function + '</option>';
                str += '<option value="' + monitorDatas[i].Monitor.Id + '">' + monitorDatas[i].Monitor.Name + '</option>';

                var item = monitorDatas[i].Monitor;
                var id = item.Id;

                if (ZM_Monitor_Select_Monitor_Id == id) {
                    checkSelectMonitorIdIn = true;
                }

                monitorLoading[id] = false;
                // monitorImageURL[id] = item.url + '&token=' + window.zm.access_token + '&connkey=' + item.connkey;
                monitorImageURL[id] = item.url + '&token=' + window.zm.access_token;
                monitorLoadingStageURL[id] = '';
                monitorColour[id] = item.WebColour;
                monitorWidth[id] = item.Width;
                monitorHeight[id] = item.Height;
                monitorIndex[id] = numMonitors;
                monitorServerId[id] = item.ServerId;
                monitorName[id] = item.Name;
                monitorLoadStartTimems[id] = 0;
                monitorLoadEndTimems[id] = 0;
                monitorNormalizeScale[id] = 1;
                monitorZoomScale[id] = 1;
                monitorPtr[numMonitors] = id;

                numMonitors += 1;
            }
            if (str == '') {
                str = '<option value="">' + myUNAS._('Select monitor') + '</option>';
            }
            $('#record_sel_monitor').append(str);

            //监控id不存在 监控被删除或者其他情况 重新设置
            if (!checkSelectMonitorIdIn && monitorDatas.length != 0) {
                localStorage.setItem('ZM_Monitor_Select_Monitor_Id', monitorDatas[0]['Monitor']['Id']);
            }

            doGetRecordList(page);

            $("#record_table_scroll_container").mCustomScrollbar({
                autoHideScrollbar: false,
                theme: "minimal-dark",
                scrollInertia: 200,
                callbacks: {
                    onTotalScroll: function () {
                        doGetRecordList(++page);
                    }
                }
            });
        });

        //注册页面翻译函数
        window.addTranslationEvent(function () {
            if (myUNAS.CurrentLanguage == 'English') {
                $('.wrapper-record').removeClass('en').addClass('en');
            } else {
                $('.wrapper-record').removeClass('en');
            }
        });

        //执行翻译
        window.unasTranslation(myUNAS.CurrentLanguage);


        //控制播放 正向/逆向播放 播放速度 快进 快退 前一个事件 后一个事件
        playClickControl()

        // console.log('init event end')
    }

    function playClickControl() {
        $('.v-icon-prev-event').attr('title', myUNAS._('Previous event'));
        $('.v-icon-prev-10').attr('title', myUNAS._('Playback for 10 seconds'));
        $('.v-icon-prev-frame').attr('title', myUNAS._('Last second'));
        $('.v-icon-backward').attr('title', myUNAS._('Play in reverse'));
        $('.v-icon-play').attr('title', myUNAS._('Play'));
        $('.v-icon-forward').attr('title', myUNAS._('Play forward'));
        $('.v-icon-next-frame').attr('title', myUNAS._('Next second'));
        $('.v-icon-next-10').attr('title', myUNAS._('Fast forward 10 seconds'));
        $('.v-icon-next-event').attr('title', myUNAS._('Next event'));
        $('.v-speed-text').attr('title', myUNAS._('Reset'));
        $('.v-speed-sub').attr('title', myUNAS._('Slow'));
        $('.v-speed-add').attr('title', myUNAS._('Fast forward'));

        //暂停播放
        $('.v-icon-play').click(function () {
            //暂停
            if ($(this).hasClass('press')) {
                playerPaused = true;

                if (liveMode == 1) {
                    doPauseStreamMjpeg(streamRecordId);
                } else {
                    if (player) {
                        // player[0].pause();
                        player.pause();
                    }
                    if (playerIntervalTimer) {
                        clearInterval(playerIntervalTimer);
                    }
                }

                $(this).removeClass('press');
                $(this).prop('title', myUNAS._('Play'))

                $('.v-icon-prev-frame').show();
                $('.v-icon-next-frame').show();
                $('.v-icon-backward').hide();
                $('.v-icon-forward').hide();

                if (tunnerTimer) {
                    clearInterval(tunnerTimer);
                    tunnerTimer = null;
                }
                if (timerObj) {
                    clearInterval(timerObj);
                    timerObj = null;
                }
                if (liveMode == 0) {
                    stopMove(aTimeline);
                }
            } else {
                //播放
                playerPaused = false;

                $(this).addClass('press');
                $(this).prop('title', myUNAS._('Pause'))

                $('.v-icon-prev-frame').hide();
                $('.v-icon-next-frame').hide();
                $('.v-icon-backward').show();
                $('.v-icon-forward').show();

                if (liveMode == 1) {
                    doPlayStreamMjpeg(streamRecordId);
                } else {
                    if (player) {
                        // player[0].play();
                        // console.log('player.paused:' + player.paused())
                        player.play();
                    }
                }

                // currentPlayTime = player[0].currentTime == 0 ? 0 : player[0].currentTime;
                if (player) {
                    currentPlayTime = player.currentTime() == 0 ? 0 : player.currentTime();
                }

                if (liveMode == 0) {
                    beginMove(aTimeline, currentSpeed)
                }
            }
        })

        //快转
        $('.v-speed-add').click(function () {
            if ($(this).hasClass('disable')) {
                return false;
            }

            if (speeds[speedIndex + 1] == undefined) {
                return false;
            }

            speedIndex += 1;
            if (isPlayReverse) {
                setReverseSpeed(speedIndex);
            } else {
                setSpeed(speedIndex);
            }
        })

        //放慢
        $('.v-speed-sub').click(function () {
            if ($(this).hasClass('disable')) {
                return false;
            }
            if (speeds[speedIndex - 1] == undefined) {
                return false;
            }

            speedIndex -= 1;
            if (isPlayReverse) {
                setReverseSpeed(speedIndex);
            } else {
                setSpeed(speedIndex);
            }
        })

        //重置
        $('.v-speed-text').click(function () {
            if ($(this).hasClass('disable')) {
                return false;
            }
            speedIndex = 3;

            if (isPlayReverse) {
                setReverseSpeed(speedIndex);
            } else {
                setSpeed(speedIndex);
            }
        })

        //逆向播放
        $('.v-icon-backward').click(function () {
            if ($(this).hasClass('disable') || $(this).hasClass('press')) {
                return false;
            }
            $(this).addClass('press');
            $('.v-icon-forward').removeClass('press');

            isPlayReverse = true;

            setReverseSpeed(speedIndex, 'play');
        })

        //正向播放
        $('.v-icon-forward').click(function () {
            if ($(this).hasClass('disable') || $(this).hasClass('press')) {
                return false;
            }
            $(this).addClass('press');
            $('.v-icon-backward').removeClass('press');

            isPlayReverse = false;

            setSpeed(speedIndex, 'play');
        })

        //live
        $('.LiveBtn').click(function () {
            setLiveMode(1);

            if (aTimeline) {
                stopMove(aTimeline);
                aTimeline.destroy();
                aTimeline = null;
                clearInterval(tunnerTimer)
            }
            attachMonitorRecord()
        })

        //下一秒
        $('.v-icon-next-frame').click(function () {
            if (codeFlg) {
                // var time = player[0].currentTime + 1;
                // player[0].currentTime = time;
                if (player) {
                    var time = player.currentTime() + 1;
                    player.currentTime(time);
                }

                setTunner(playTime + 1);
                if (!isPlayReverse) {
                    setSpeed(speedIndex)
                } else {
                    setReverseSpeed(speedIndex);
                }
            } else {
                currentTimeSecs += 1;
                outputUpdate(currentTimeSecs);
                setTunner(playSecsPerInterval + currentTimeSecs);
            }
        })

        //上一秒
        $('.v-icon-prev-frame').click(function () {
            if (codeFlg) {
                // var time = player[0].currentTime - 1;
                // player[0].currentTime = time;
                var time = player.currentTime() - 1;
                player.currentTime(time);

                setTunner(playTime - 1);
                if (!isPlayReverse) {
                    setSpeed(speedIndex)
                } else {
                    setReverseSpeed(speedIndex);
                }
            } else {
                currentTimeSecs -= 1;
                outputUpdate(currentTimeSecs);
                setTunner(playSecsPerInterval + currentTimeSecs);
            }
        })

        //快进10秒
        $('.v-icon-next-10').click(function () {
            if (codeFlg) {
                // var time = player[0].currentTime + 10;
                // player[0].currentTime = time;
                var time = player.currentTime() + 10;
                player.currentTime(time);

                setTunner(playTime + 10);
                if (!isPlayReverse) {
                    setSpeed(speedIndex)
                } else {
                    setReverseSpeed(speedIndex);
                }
            } else {
                currentTimeSecs += 10;
                timerFire();
            }
        })

        //回放10秒
        $('.v-icon-prev-10').click(function () {
            if (liveMode == 0) {
                if (codeFlg) {
                    // var time = player[0].currentTime - 10;
                    var time = player.currentTime() - 10;
                    //到达事件起点，从上一个事件的倒数10秒开始播
                    if (time <= 0) {
                        var eid = 0;
                        var index = 0;
                        var startTimeSec = 0;
                        var time = 0;
                        var recordData = [];

                        for (var i = 0; i < _records.length; i++) {
                            if (_recordId == _records[i].Id) {
                                if (_records[i + 1]) {
                                    index = i + 1;
                                    eid = _records[index].Id;
                                    time = _records[index].EndTimeSecs - 10;
                                    startTimeSec = time - _records[index].StartTimeSecs <= 0 ? 0 : time - _records[index].StartTimeSecs
                                    recordData = _records[index];
                                    break;
                                }
                            }
                        }

                        if (player) {
                            player.dispose();
                            player = null;
                        }

                        if (!player && eid != 0) {
                            doPlayVideo(eid, index, startTimeSec, time, recordData)
                        } else {
                            if (player) {
                                player.dispose();
                                player = null;
                            }

                            if (aTimeline) {
                                stopMove(aTimeline);
                                aTimeline.destroy();
                                aTimeline = null;
                                clearInterval(tunnerTimer)
                            }

                            Message.error(myUNAS._('No other events were found at this time point'));

                            attachMonitorRecord()
                        }
                        return false;
                    }
                    // player[0].currentTime = time;
                    player.currentTime(time);

                    setTunner(playTime - 10);
                    if (!isPlayReverse) {
                        setSpeed(speedIndex)
                    } else {
                        setReverseSpeed(speedIndex);
                    }
                } else {
                    currentTimeSecs -= 10;
                    timerFire();
                }
            } else {
                var info = aTimeline.getTimeLineInfo();
                var sec = info.currentTime - 1000;

                var time = parseInt(sec / 1000);
                setLiveMode(0);

                var eid = 0;
                var index = 0;
                var startTimeSec = 0;
                var recordData = [];

                for (var i = 0; i < _records.length; i++) {
                    if ((time > _records[i].StartTimeSecs && time < _records[i].EndTimeSecs) || (time > _records[i].StartTimeSecs && _records[i].EndTimeSecs == null)) {
                        eid = _records[i].Id;
                        index = i;
                        startTimeSec = time - _records[i].StartTimeSecs
                        recordData = _records[i];
                        break;
                    }
                }
                if (player) {
                    player.dispose();
                    player = null;
                }

                if (!player && eid != 0) {
                    doPlayVideo(eid, index, startTimeSec, time, recordData)
                } else {
                    if (player) {
                        player.dispose();
                        player = null;
                    }

                    if (aTimeline) {
                        var timelineinfo = aTimeline.getTimeLineInfo();
                        timeLineCurrentTime = timelineinfo.currentTime

                        stopMove(aTimeline);
                        aTimeline.destroy();
                        aTimeline = null;
                        clearInterval(tunnerTimer)
                    }

                    Message.error(myUNAS._('No other events were found at this time point'));

                    attachMonitorRecord();
                }
            }
        })

        //前一个事件
        $('.v-icon-prev-event').click(function () {
            if ($(this).hasClass('disable')) {
                return false;
            }

            if (player) {
                player.dispose();
                player = null;
            }

            var id = 0;
            for (var i = 0; i < _records.length; i++) {
                if (_recordId == 0) {
                    if (_records[i].Name != 'New Event') {
                        id = _records[i].Id;
                        break;
                    }
                } else {
                    if (_recordId == _records[i].Id && _records[i + 1]) {
                        id = _records[i + 1].Id
                        break;
                    }
                }
            }
            // console.log(id);

            attachMonitorRecord(id, 'auto', 'eventChange');
        })

        //后一个事件
        $('.v-icon-next-event').click(function () {
            if ($(this).hasClass('disable')) {
                return false;
            }

            if (player) {
                player.dispose();
                player = null;
            }

            var id = 0;
            for (var i = 0; i < _records.length; i++) {
                if (_recordId == _records[i].Id && _records[i - 1]) {
                    id = _records[i - 1].Id
                    break;
                }
            }

            attachMonitorRecord(id, 'auto', 'eventChange');
        })

    }

    function doPlayVideo(eid, index, startTimeSec, time, recordData = []) {
        if (tunnerTimer) {
            clearInterval(tunnerTimer);
            tunnerTimer = null;
        }
        var str = '<video id="video_record" data-ref="' + index + '" class="video-js vjs-big-play-centered" autoplay width="100%" height="100%">';
        var videoUrl = '/zm/index.php?view=view_video' + '&eid=' + eid + '&token=' + window.zm.access_token;
        // str += '<source src="' + videoUrl + '" type="video/mp4" />';
        str += '</video>';

        $('.video-player-record').find('#video_record').remove();
        $('.video-player-record').append(str);

        // $('.video-player-record').find('canvas').hide();
        $('.td_record_name').removeClass('active');
        $('#tr_record_' + index).find('.td_record_name').addClass('active');

        currentPlayTime = startTimeSec;

        showLoading();
        // fetch(fetchUrl).then(response => response.blob()).then(blob => {
        // 在这里你可以使用blob对象，例如创建一个视频URL并在video元素中播放
        // const videoUrl = URL.createObjectURL(blob);

        player = videojs('video_record');

        player.ready(function () {
            updateAndPlayNextVideo(videoUrl);
        })

        player.on("play", function () {
            // console.log('doPlayVideo play event id:' + eid);
            hideLoading();
            playerPaused = false;
            setTunner(time);
            // player[0].currentTime = currentPlayTime;
            player.currentTime(currentPlayTime);
            if (isPlayReverse) {
                setReverseSpeed(speedIndex);
            } else {
                setSpeed(speedIndex)
            }
            $('.td_record_name').removeClass('active');
            $('#tr_record_' + eid).find('.td_record_name').addClass('active');
        });

        player.on("timeupdate", function() {
            // 修正tunner time
            var time = recordData.StartTimeSecs+Math.round(player.currentTime());
            if (playTime - time > 2 || player - time < -2) {
                setTunner(time);
            }
        });

        player.on("ended", function () {
            if (player) {
                player.dispose();
                player = null;
            }
            var id = 0;
            for (var i = 0; i < _records.length; i++) {
                if (eid == _records[i].Id) {
                    if (_records[i - 1]) {
                        id = _records[i - 1].Id;
                        break;
                    }
                }
            }

            if (tunnerTimer) {
                clearInterval(tunnerTimer);
                tunnerTimer = null;
                stopMove(aTimeline);
            }

            // console.log('doPlayVideo play ended event id:' + eid);

            attachMonitorRecord(id, 'auto', 'playEnd');
        });

        player.on("error", function () {
            if (player) {
                player.dispose();
                player = null;
            }
            if (tunnerTimer) {
                clearInterval(tunnerTimer);
                tunnerTimer = null;
                stopMove(aTimeline);
            }
            var id = 0;
            for (var i = 0; i < _records.length; i++) {
                if (_recordId == _records[i].Id) {
                    if (_records[i - 1]) {
                        id = _records[i - 1].Id;
                        break;
                    }
                }
            }
            console.log('_recordId:' + _recordId, 'attachMonitorRecord play error, play next id:' + id);

            showLoading();
            setTimeout(function () {
                hideLoading();
                attachMonitorRecord(id, 'auto', 'playEnd');
            }, 1000)

            // console.log('播放出错重试 _recordId:' + _recordId, 'doPlayVideo play error')
            // attachMonitorRecord(_recordId, 'auto', 'playEnd');
        });
    }

    function recordSelReset() {
        //左上方监视器选择
        $('#record_sel_monitor').on('change', function () {
            // updateMonitor();
            selectMonitorId = $(this).val();

            localStorage.setItem('ZM_Monitor_Select_Monitor_Id', selectMonitorId);

            _records = [];
            _recordId = 0;
            events = [];
            events_by_monitor_id = [];
            isPlayReverse = false;
            speedIndex = 3;

            freeTimeLastIntervals = [];
            imageLoadTimesEvaluated = 0;
            imageLoadTimesNeeded = 15;
            timeLabelsFractOfRow = 0.9;
            displayTime = 0;
            moveX = 0;
            timeParts = [];
            playTime = 0;
            snapshotTimestamp = 0;
            currentPlaySec = 0;
            if (player) {
                player.dispose();
                player = null;
            }
            playerPaused = false;
            isPlayReverse = false;

            clearInterval(playerIntervalTimer)
            playerIntervalTimer = null;

            update();
        });

        //右上方编码选择
        $('#record_sel_codec').on('change', function () {
            //停止所有监视器的状态轮询请求
            stopGetStatus();
            //停止播放'流静帧'
            stopStreamMjpeg();

            if (player) {
                player.dispose();
                player = null;
            }

            var codec = $(this).val();
            attachMonitorRecord(_recordId, codec);
        });

        //右上方宽高比选择
        $('#record_sel_ratio').on('change', function () {
            var value = $(this).val();

            if (value == '16/9') {
                _monitor_ratio = 16 / 9;
            } else if (value == '4/3') {
                _monitor_ratio = 4 / 3;
            } else if (value == '1/1') {
                _monitor_ratio = 1;
            }
        });

        //右上方清晰度选择
        $('#record_sel_scale').on('change', function () {
            if (_records.length == 0) {
                return;
            }
            _records[_recordId].scale = $(this).val();
            var streamMjpegSrc = window.zm.cgiBinUrl + '?mode=jpeg&frame=1&rate=100&maxfps=30&replay=single&source=event' +
                '&scale=' + _records[_recordId].scale +
                '&event=' + _records[_recordId].Id +
                '&token=' + window.zm.access_token +
                '&connkey=' + _records[_recordId].connkey +
                '&rand=' + Math.random() +
                '&wid=' + window.zm.windowId +
                '&rnd=' + Math.random().toString(36).slice(-6);
            $('#screen_mjpeg_' + _recordId).attr('src', streamMjpegSrc);
        });

        //右上方尺寸选择
        $('#record_sel_size').on('change', function () {
            var value = Number($(this).val());

            //停止所有监视器的状态轮询请求
            stopGetStatus();
            //停止播放'流静帧'
            stopStreamMjpeg();

            if (player) {
                player.dispose();
                player = null;
            }

            attachMonitorRecord(_recordId, 'auto');
        });

        //右上方刷新按钮
        $("#event-refreshBtn").on("click", function () {
            update();
        }).mousedown(function () {
            $(this).addClass("pressed");
        }).mouseup(function () {
            $(this).removeClass("pressed");
        });

        //切换事件列表显示隐藏
        $('#btn_handler').on('click', function () {
            $('#record_list_container').toggleClass('unfolded');
            $('.record-main-container').toggleClass('unfolded');
            $('.canvas-content').toggleClass('unfolded');
            resizeDiv();
        });

        //设置滚动条
        // $("#record_table_scroll_container").mCustomScrollbar({
        //     autoHideScrollbar: false,
        //     theme: "minimal-dark",
        //     scrollInertia: 200
        // });

        //初始化下拉框控件
        $('.js-example-basic-single').select2({
            minimumResultsForSearch: -1, //移除下拉选项中的搜索框
            dropdownCssClass: "select2OptionCss"
        });

        if (_foldRecordListTimer) {
            clearTimeout(_foldRecordListTimer);
        }

    }

    function formatDateTime(int, str = 'y-m-d h:i:s', bol = true) {
        let date = new Date(int);
        let year = date.getFullYear();
        let month = date.getMonth() + 1;
        let day = date.getDate();
        let hours = date.getHours();
        let minutes = date.getMinutes();
        let seconds = date.getSeconds();
        if (bol) {
            month = month < 10 ? '0' + month : month
            day = day < 10 ? '0' + day : day
            hours = hours < 10 ? '0' + hours : hours
            minutes = minutes < 10 ? '0' + minutes : minutes
            seconds = seconds < 10 ? '0' + seconds : seconds
        }
        let strtoLowerCase = str.toLowerCase(); //把传入的转换成小写
        switch (strtoLowerCase) {
            case 'y-m-d h:i:s':
                return year + '-' + month + '-' + day + ' ' + hours + ':' + minutes + ':' + seconds;
                break;
            case 'ymdhis':
                return year + '' + month + '' + day + '' + hours + '' + minutes + '' + seconds;
                break;
            case 'y-m-d':
                return year + '-' + month + '-' + day;
                break;
            case 'y-m':
                return year + '-' + month;
                break;
            case 'm-d':
                return month + '-' + day;
                break;
            case 'ymd':
                return year + '' + month + '' + day;
                break;
            case 'h:i:s':
                return hours + ':' + minutes + ':' + seconds;
                break;
            case 'his':
                return hours + '' + minutes + '' + seconds;
                break;
            case 'y年m月d日 h时i分s秒':
                return year + '年' + month + '月' + day + '日' + ' ' + hours + '时' + minutes + '分' + seconds + '秒';
                break;
            case 'y年m月d日':
                return year + '年' + month + '月' + day + '日';
                break;
            case 'h时i分s秒':
                return hours + '时' + minutes + '分' + seconds + '秒';
                break;
            case 'y年m月':
                return year + '年' + month + '月';
                break;
            case 'm月d日':
                return month + '月' + day + '日';
                break;
        }
    }

    function setTimeline(type = '') {
        var width = $('.canvas-content-inner').width();
        if (aTimeline != undefined) {
            stopMove(aTimeline);
        }

        var ZM_Monitor_Select_Monitor_Id = localStorage.getItem('ZM_Monitor_Select_Monitor_Id');
        if (ZM_Monitor_Select_Monitor_Id) {
            aTimeline = new TimeLine("canvas1", new Date().getTime(), [], true, changeCallback, mousedownupCallback, mouseoverCallback, mouseleaveCallback, mouseupCallback, width, 26, 'canvas2');
            if (type == 'resize' && timeLineCurrentTime != null) {
                //点击事件切换 让时间刻度还原
                aTimeline.setCurrentTime(timeLineCurrentTime)
            }
            beginMove(aTimeline);
        }
    }

    function changeCallback(sec = '', mousedownX = 0, onemoveX = '') {
        // console.log('changeCallback')
        var time = parseInt(sec / 1000);
        // liveMode = 0;
        // moveX = onemoveX;
        // var formatTime1 = formatDateTime(sec, 'y-m-d');
        // var formatTime2 = formatDateTime(sec, 'h:i:s');
        // $('.tuner-date').html(formatTime1);
        // $('.tuner-time').html(formatTime2);
        // if (mousedownX != 0) {
        //     $('.tuner-ct').css({'left': mousedownX, 'visibility': 'visible'});
        // }
        setLiveMode(0);

        var eid = 0;
        var recordData = [];
        var startTimeSec = 0;
        for (var i = 0; i < _records.length; i++) {
            if ((time > _records[i].StartTimeSecs && time < _records[i].EndTimeSecs) || (time > _records[i].StartTimeSecs && _records[i].EndTimeSecs == null)) {
                eid = _records[i].Id;
                startTimeSec = time - _records[i].StartTimeSecs
                recordData = _records[i];
                break;
            }
        }

        if (player) {
            // console.log('changecallback player null')
            player.dispose();
            player = null;
        }

        if (codeFlg) {
            if (!player && eid != 0) {
                if (tunnerTimer) {
                    clearInterval(tunnerTimer);
                    tunnerTimer = null;
                }

                if (timerObj) {
                    clearInterval(timerObj);
                    timerObj = null;
                }

                _recordId = eid;

                // var str = '<video id="video_record" data-ref="' + index + '" class="video-js vjs-big-play-centered" autoplay width="100%" height="100%">';
                var str = '<video id="video_record" data-ref="' + eid + '" class="video-js vjs-big-play-centered" autoplay width="100%" height="100%">';
                var videoUrl = '/zm/index.php?view=view_video' + '&eid=' + eid + '&token=' + window.zm.access_token;
                // str += '<source src="' + videoUrl + '" type="video/mp4" />';
                str += '</video>';

                $('.video-player-record').find('#video_record').remove();
                $('.video-player-record').find('img').remove();
                $('.video-player-record').append(str);

                // var videoUrl = '/zm/index.php?view=view_video' + '&eid=' + eid + '&token=' + window.zm.access_token;
                // $('#video_record').attr('src', videoUrl);

                // $('.video-player-record').find('canvas').hide();

                $('.td_record_name').removeClass('active');
                $('#tr_record_' + eid).find('.td_record_name').addClass('active');

                currentPlayTime = startTimeSec;
                playTime = time;

                showLoading();
                // fetch(fetchUrl).then(response => response.blob()).then(blob => {
                // 在这里你可以使用blob对象，例如创建一个视频URL并在video元素中播放
                // const videoUrl = URL.createObjectURL(blob);

                player = videojs('video_record');

                player.ready(function () {
                    updateAndPlayNextVideo(videoUrl);
                })

                player.on("play", function () {
                    // console.log('changeCallback play')
                    hideLoading();
                    playerPaused = false;

                    setTunner(playTime);
                    // player[0].currentTime = currentPlayTime;
                    player.currentTime(currentPlayTime);
                    if (isPlayReverse) {
                        setReverseSpeed(speedIndex);
                    } else {
                        setSpeed(speedIndex)
                    }

                    $('.v-icon-play').addClass('press');
                    $('.v-icon-play').prop('title', myUNAS._("Pause"));
                    $('.v-icon-prev-frame').hide();
                    $('.v-icon-next-frame').hide();
                    $('.v-icon-backward').show();
                    $('.v-icon-forward').show();

                    beginMove(aTimeline, currentSpeed)
                });

                player.on("timeupdate", function() {
                    // 修正tunner time
                    var time = recordData.StartTimeSecs+Math.round(player.currentTime());
                    if (playTime - time > 2 || player - time < -2) {
                        setTunner(time);
                    }
                });

                player.on("ended", function () {
                    if (player) {
                        player.dispose();
                        player = null;
                    }
                    var id = 0;
                    for (var i = 0; i < _records.length; i++) {
                        if (eid == _records[i].Id) {
                            if (_records[i - 1]) {
                                id = _records[i - 1].Id;
                                break;
                            }
                        }
                    }

                    if (tunnerTimer) {
                        clearInterval(tunnerTimer);
                        tunnerTimer = null;
                        stopMove(aTimeline);
                    }

                    // console.log('id:' + id, 'changecallback playEnd');
                    attachMonitorRecord(id, 'auto', 'playEnd');
                });

                player.on("error", function () {
                    if (player) {
                        console.log('player error dispose null')
                        player.dispose();
                        player = null;
                    }
                    if (tunnerTimer) {
                        clearInterval(tunnerTimer);
                        tunnerTimer = null;
                        stopMove(aTimeline);
                    }

                    var id = 0;
                    for (var i = 0; i < _records.length; i++) {
                        if (_recordId == _records[i].Id) {
                            if (_records[i - 1]) {
                                id = _records[i - 1].Id;
                                break;
                            }
                        }
                    }
                    console.log('_recordId:' + _recordId, 'attachMonitorRecord play error, play next id:' + id);

                    showLoading();
                    setTimeout(function () {
                        hideLoading();
                        attachMonitorRecord(id, 'auto', 'playEnd');
                    }, 1000)

                    // console.log('播放出错重试 _recordId:' + _recordId, 'changeCallback play error')
                    // attachMonitorRecord(_recordId, 'auto', 'playEnd');
                });


            } else {
                if (aTimeline) {
                    var timelineinfo = aTimeline.getTimeLineInfo();
                    timeLineCurrentTime = timelineinfo.currentTime

                    aTimeline.destroy();
                    aTimeline = null;
                    clearInterval(tunnerTimer)
                }

                attachMonitorRecord()
            }
        } else {
            // console.log(time)
            if (tunnerTimer) {
                clearInterval(tunnerTimer);
                tunnerTimer = null;
            }

            $('.video-player-record').find('img').remove();
            $('.video-player-record').find('canvas').show();

            outputUpdate(time, 1);
            timerFire();
        }
    }

    function showLoading() {
        var html = '<div class="loading-event"><img class="loading-icon" src="./images/ajax-loader.gif?v=6.0.30&"></div>';
        $('.video-player-record').append(html);
    }

    function hideLoading() {
        $('.video-player-record').find('.loading-event').remove();
    }

    function mousedownupCallback(width, zoom, currentTime, displayTime) {
        $('.snapshot-ct').hide();
        var onePxsMS = width / (zoom * 60 * 60 * 1000);
        let startTimestamp = currentTime - (zoom * 60 * 60 * 1000);
        var mousedownX = (displayTime - startTimestamp) * onePxsMS;
        if (mousedownX != 0) {
            $('.tuner-ct').css({'left': mousedownX, 'visibility': 'visible'});
        }
    }

    function mouseoverCallback(width, zoom, x, time) {
        var timestamp = new Date(time).getTime()
        if (snapshotTimer) {
            clearInterval(snapshotTimer);
        }
        var monitorId = $('#record_sel_monitor').val();
        var frameId = getFrameId(monitorId, timestamp / 1000);

        var eid = 0;
        // var index = 0;
        var startTimeSec = 0;
        var time1 = timestamp / 1000;
        for (var i = 0; i < _records.length; i++) {
            if ((time1 > _records[i].StartTimeSecs && time1 < _records[i].EndTimeSecs) || (time1 > _records[i].StartTimeSecs && _records[i].EndTimeSecs == null)) {
                eid = _records[i].Id;
                break;
            }
        }

        if (!debug) {
            if (!thumbTimeFlag) {
                getImageBase64(eid, frameId);
            }
        }

        setSnapshop(x, timestamp);
        snapshotTimer = setInterval(function () {
            setSnapshop(x, snapshotTimestamp + 1000);
        }, snapshotTimerInterval)
    }

    function getImageBase64(eid, frameId) {
        if (eid != 0 && frameId != 0) {
            thumbTimeFlag = true;
            var url = '/zm/api/events/imagebase64' + '?eid=' + eid + '&fid=' + frameId + '&token=' + window.zm.access_token;
            jQuery.ajax({
                url: url,
                type: "GET",
                async: true,
                dataType: 'json',
                success: function (data) {
                    setTimeout(function () {
                        thumbTimeFlag = false;
                    }, 300);
                    if (data.thumbnail) {
                        var base64ImageData = "data:image/jpeg;base64," + data.thumbnail;
                        $('.snapshot-img-ct').css("background-image", "url('" + base64ImageData + "')");
                    }
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    setTimeout(function () {
                        thumbTimeFlag = false;
                    }, 300);

                    // console.log('event event_list error textStatus:' + textStatus);
                },
                complete: function () {
                    setTimeout(function () {
                        thumbTimeFlag = false;
                    }, 300);
                }
            });
        } else {
            var base64ImageData = '';
            $('.snapshot-img-ct').css("background-image", "url('" + base64ImageData + "')");
        }
    }

    function mouseleaveCallback() {
        $('.snapshot-ct').hide();
        clearInterval(snapshotTimer)
    }

    function mouseupCallback() {
        var timelineinfo = aTimeline.getTimeLineInfo();
        // console.log(timelineinfo)
        let startTimestamp = timelineinfo.currentTime - (this.zoom * 60 * 60 * 1000);
        let currentDayTimestamp = getStartOfDayTimestamp();
        if (startTimestamp < currentDayTimestamp) {
            doGetLastRecordList(startTimestamp, currentDayTimestamp);
        }
    }

    function doGetLastRecordList(startTimestamp, currentDayTimestamp) {
        // console.log('doGetLastRecordList');
        var startTimestamp2 = startTimestamp - (5 * 60 * 60 * 1000); //开始时间的前5个小时
        var startTime = formatDate(startTimestamp2, true)
        var endTime = formatDate(currentDayTimestamp, true);
        var monitorId = $('#record_sel_monitor').val();
        reqUrl = "/zm/api/events/index/MonitorId:" + monitorId + "/StartTime >=:" + startTime + "/EndTime <=:" + endTime + ".json" + "?token=" + window.zm.access_token + "&page=1&sort=StartTime&direction=desc";

        jQuery.ajax({
            url: reqUrl,
            type: "GET",
            async: true,
            dataType: 'json',
            success: function (data) {
                for (var i = 0, len = data.events.length; i < len; ++i) {
                    var mid = data.events[i].Event.MonitorId;
                    var eid = data.events[i].Event.Id;

                    if (!checkInArr('Id', eid, _records)) {
                        // console.log('doGetLastRecordList _records push')
                        _records.push(data.events[i].Event);
                    }
                    if (events_by_monitor_id[mid] == undefined) {
                        events_by_monitor_id[mid] = [];
                    }
                    events_by_monitor_id[mid].push(eid);

                    if (!events[eid]) {
                        events[eid] = data.events[i].Event;
                    }
                }
                var hasNewEvent = false;
                for (var i = 0; i < _records.length; i++) {
                    if (parseInt(_records[i].Videoed) == 0 && parseInt(_records[i].SaveJPEGs) == 0) {
                        continue;
                    }

                    if (_records[i].EndTime != null && _records[i].StartTime != null) {
                        var end = _records[i].EndTimeSecs * 1000;
                        var start = _records[i].StartTimeSecs * 1000;
                        var obj = {
                            id: _records[i].Id,
                            start: start,
                            end: end,
                            style: {
                                background: "#475059"
                            }
                        }
                        var checkObjIn = false;
                        timeParts.forEach(item => {
                            if (item.id == obj.id) {
                                checkObjIn = true;
                            }
                        })
                        if (!checkObjIn) {
                            timeParts.push(obj);
                            hasNewEvent = true;
                        }
                    }
                }
                if (hasNewEvent) {
                    setTimeParts(aTimeline, timeParts);
                }
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                // console.log('event event_list error textStatus:' + textStatus);
            },
            complete: function () {
                hideWaiting();
            }
        });
    }

    function getStartOfDayTimestamp() {
        const now = new Date();
        now.setHours(0, 0, 0, 0);
        return now.getTime();
    }

    function setSnapshop(x, time) {
        var formatTime1 = formatDateTime(time, 'y-m-d');
        var formatTime2 = formatDateTime(time, 'h:i:s');
        // console.log(formatTime1, formatTime2)
        $('.snapshot-ct').css('left', x);
        $('.snapshot-date').html(formatTime1);
        $('.snapshot-time').html(formatTime2);
        $('.snapshot-ct').show();

        snapshotTimestamp = time;
    }

    function stopMove(timeline) {
        timeline.setIsMove(false);
    }

    function beginMove(timeline, speed = 1, reverse = false) {
        timeline.setIsMove(true, speed, reverse);
    }

    function readyTimelinePointer(dataIndex) {
        var recordData = _records[dataIndex];
        var $recordThumb = $('#rbt_recordthumb_' + recordData.Id);

        var currentTimeTimestamp = new Date(recordData.StartTime).getTime();
        $timelineCurrentTime.text(formatDate(currentTimeTimestamp, true));

        if ($recordThumb.length > 0) {
            var left = $recordThumb.position().left + WIDTH_EXTRA;
            $timelinePointer.css('left', left);
        }
    }

    //播放流静帧时更新时间轴
    function updateTimeline(dataIndex, statusData) {
        //如果正在拖动时间轴指针，则不更新时间轴
        if (isMouseDownPointer) return;

        var recordData = _records[dataIndex];
        var $recordThumb = $('#rbt_recordthumb_' + recordData.Id);

        //当前播放时间
        var currentTimeTimestamp = new Date(recordData.StartTime).getTime() + statusData.progress * 1000;
        $timelineCurrentTime.text(formatDate(currentTimeTimestamp, true));

        if ($recordThumb.length > 0) {
            var left = $recordThumb.position().left + WIDTH_EXTRA;
            if (Number(statusData.duration) > 0) {
                left += $recordThumb.width() * statusData.progress / statusData.duration;
            }
            //console.log('left:'+left);
            $timelinePointer.css('left', left);
        }
    }

    //播放视频时更新时间轴
    function updatePlayerTimeline(dataIndex, vjPlayer) {
        // //如果正在拖动时间轴指针，则不更新时间轴
        // if (isMouseDownPointer) return;
        //
        // var recordData = _records[dataIndex];
        // var $recordThumb = $('#rbt_recordthumb_' + recordData.Id);
        //
        // //当前播放时间
        // var currentTimeTimestamp = new Date(recordData.StartTime).getTime() + vjplayer[0].currentTime * 1000;
        // $timelineCurrentTime.text(formatDate(currentTimeTimestamp, true));
        //
        // if ($recordThumb.length > 0) {
        //     var left = $recordThumb.position().left + WIDTH_EXTRA;
        //
        //     if (vjPlayer.duration() > 0) {
        //         left += $recordThumb.width() * vjplayer[0].currentTime / vjPlayer.duration();
        //     }
        //     //console.log('left:'+left);
        //     $timelinePointer.css('left', left);
        // }


    }

    function resetTimeline() {
        var monitorId = $('#record_sel_monitor').val();
        if (monitorId) {
            $('#wrapper_record').removeClass('with-bottom-timeline').addClass('with-bottom-timeline');

            var $onedayWrapper = $('.rbt-oneday-wrapper');

            var datetimestamp = getStartDate().getTime();
            var id = 'rbt_oneday_' + datetimestamp;
            $onedayWrapper.empty();
            var str = '';
            str += '<div class="rbt-oneday" id="' + id + '" data-datetimestamp="' + datetimestamp + '">';
            str += '<div class="rbt-timeline-cover"></div>';
            str += '<div class="rbt-hourthumb-wrapper">';
            str += generateHourThumbs();
            str += '</div>';
            str += '<div class="rbt-recordthumb-wrapper">';
            str += generateRecordThumbs();
            str += '</div>';
            str += '</div>';
            $onedayWrapper.append(str);

            $('.record-bottom-timeline-wrapper').width(WIDTH_HOUR_24 + WIDTH_EXTRA);
            $('#' + id).width(WIDTH_HOUR_24);

            $('.record-bottom-timeline-pointer').css('left', WIDTH_EXTRA);
            isMouseDownPointer = null;
            forceSeekOffset = 0;
        } else {
            $('#wrapper_record').removeClass('with-bottom-timeline');
            $('.rbt-oneday-wrapper').empty();
            $('.record-bottom-timeline-pointer').css('left', WIDTH_EXTRA);
            isMouseDownPointer = null;
            forceSeekOffset = 0;
        }
    }

    function attachRecordThumbs() {
        $('.rbt-recordthumb-wrapper').empty();
        $('.rbt-recordthumb-wrapper').html(generateRecordThumbs());
    }

    function generateRecordThumbs() {
        var timestampOfStart = getStartDate().getTime();
        var timestampOfEnd = timestampOfStart + MILLISECONDS_PER_DAY;
        var recordTimestampOfStart;
        var _left, _width;
        var str = '';
        for (var i = 0, len = _records.length; i < len; ++i) {
            recordTimestampOfStart = new Date(_records[i].StartTime).getTime();
            //console.log('date:'+new Date(_records[i].StartTime));
            _left = WIDTH_HOUR_24 * (recordTimestampOfStart - timestampOfStart) / (timestampOfEnd - timestampOfStart);
            _width = WIDTH_HOUR_1 * (_records[i].Length / SECONDS_PER_HOUR);
            str += '<div class="rbt-recordthumb" id="rbt_recordthumb_' + _records[i].Id + '" title="' + _records[i].Name + '" style="left:' + _left + 'px; width:' + _width + 'px;"></div>';
        }
        return str;
    }

    function generateHourThumbs() {
        var str = '';
        for (var i = 0; i <= 23; ++i) {
            str += '<div class="rbt-hourthumb"><span class="rbt-hourthumb-hour">' + i + '.00</span></div>';
        }
        return str;
    }

    function destroy() {
        if (timerObj) {
            clearInterval(timerObj);
            timerObj = null;
        }

        if (_foldRecordListTimer) {
            clearTimeout(_foldRecordListTimer);
        }

        //停止所有监视器的状态轮询请求
        stopGetStatus();
        //停止播放'流静帧'
        stopStreamMjpeg();

        if (player) {
            player.dispose();
            console.log('destroy player null')
            player = null;
        }

        if (aTimeline) {
            stopMove(aTimeline);
            aTimeline.destroy();
            aTimeline = null;
        }

        if (tunnerTimer) {
            clearInterval(tunnerTimer);
            tunnerTimer = null;
        }

        if (playerIntervalTimer) {
            clearInterval(playerIntervalTimer);
            playerIntervalTimer = null;
        }
    }

    //刷新页面显示
    //token过期并重新获取后,且当前选项卡处于配置页面时调用
    function update() {
        // console.log('update event');

        timeParts = [];
        // resetTimeline();
        if (aTimeline) {
            stopMove(aTimeline);
            aTimeline.destroy();
            aTimeline = null;
        }

        if (tunnerTimer) {
            clearInterval(tunnerTimer);
            tunnerTimer = null;
        }

        if (timerObj) {
            clearInterval(timerObj);
            timerObj = null;
        }

        if (playerIntervalTimer) {
            clearInterval(playerIntervalTimer);
            playerIntervalTimer = null;
        }

        if (_foldRecordListTimer) {
            clearTimeout(_foldRecordListTimer);
        }

        //停止所有监视器的状态轮询请求
        stopGetStatus();
        //停止播放'流静帧'
        stopStreamMjpeg();

        if (player) {
            player.dispose();
            console.log('update player null')
            player = null;
        }

        _records = [];
        _recordId = 0;

        $("input[name='selectAll']").prop('checked', false);

        doGetRecordList();
    }

    function setTimeParts(timeline = '', timeParts = []) {
        if (timeline) {
            timeline.addTimeParts(timeParts);
        }
    }

    //年月日筛选
    function initYearMonthDate() {
        var dateCurrent = new Date();
        var yearCurrent = dateCurrent.getFullYear();
        var monthCurrent = dateCurrent.getMonth();
        var dateCurrent = dateCurrent.getDate();
        var yearSelected = yearCurrent;
        var monthSelected = monthCurrent;
        var dateSelected = dateCurrent;

        //初始化年选项
        $('#record_sel_year').html(generateYearOptions(2020, yearCurrent));
        selectOptionByValue(document.getElementById('record_sel_year'), yearSelected);

        //设置月日选项
        setMonthAndDate();

        //设置月日选项
        function setMonthAndDate() {
            //初始化月日选项
            if (yearSelected == yearCurrent) {
                $('#record_sel_month').html(generateMonthOptions(monthCurrent));

                if (monthSelected == monthCurrent) {
                    $('#record_sel_date').html(generateDateOptions(dateCurrent));
                } else {
                    $('#record_sel_date').html(generateDateOptions(getMonthDay(monthSelected, yearSelected)));
                }
            } else {
                $('#record_sel_month').html(generateMonthOptions(11));
                $('#record_sel_date').html(generateDateOptions(getMonthDay(monthSelected, yearSelected)));
            }

            //选择年月日选项
            if (!selectOptionByValue(document.getElementById('record_sel_month'), monthSelected)) {
                monthSelected = 0;
            }
            if (!selectOptionByValue(document.getElementById('record_sel_date'), dateSelected)) {
                dateSelected = 0;
            }
        }

        $('#record_sel_year').on('change', function () {
            yearSelected = $(this).val();
            setMonthAndDate();

            var dateCurrent = new Date();
            var yearCurrent = dateCurrent.getFullYear();
            var monthCurrent = dateCurrent.getMonth();
            var dateCurrent = dateCurrent.getDate();
            if (yearCurrent != yearSelected || monthCurrent != monthSelected || dateCurrent != dateSelected) {
                _recordIndexReset = 0;
            } else {
                _recordIndexReset = -1;
            }

            update();
        });
        $('#record_sel_month').on('change', function () {
            monthSelected = $(this).val();
            setMonthAndDate();

            var dateCurrent = new Date();
            var yearCurrent = dateCurrent.getFullYear();
            var monthCurrent = dateCurrent.getMonth();
            var dateCurrent = dateCurrent.getDate();
            if (yearCurrent != yearSelected || monthCurrent != monthSelected || dateCurrent != dateSelected) {
                _recordIndexReset = 0;
            } else {
                _recordIndexReset = -1;
            }

            update();
        });
        $('#record_sel_date').on('change', function () {
            dateSelected = $(this).val();

            var dateCurrent = new Date();
            var yearCurrent = dateCurrent.getFullYear();
            var monthCurrent = dateCurrent.getMonth();
            var dateCurrent = dateCurrent.getDate();
            if (yearCurrent != yearSelected || monthCurrent != monthSelected || dateCurrent != dateSelected) {
                _recordIndexReset = 0;
            } else {
                _recordIndexReset = -1;
            }

            update();
        });

        //将值为value的option设为选中状态
        function selectOptionByValue(select, value) {
            if (select == null) {
                return;
            }
            var found = false;
            for (var i = 0, len = select.options.length; i < len; i++) {
                if (select.options[i].value == value) {
                    select.options[i].selected = true;
                    found = true;
                    break;
                }
            }
            if (!found && select.options[0]) {
                //如果找不到对应值，默认选择第一个选项
                select.options[0].selected = true;
                return false;
            }

            return true;
        }

        //拼接年份选项字符串
        function generateYearOptions(start, end) {
            var _str = '';
            for (var i = start; i <= end; i++) {
                if (myUNAS.CurrentLanguage == '简体中文') {
                    _str += '<option value="' + i + '">' + i + '年</option>';
                } else {
                    _str += '<option value="' + i + '">' + i + '</option>';
                }
            }
            return _str;
        }

        //拼接月份选项字符串
        function generateMonthOptions(end) {
            var _str = '';
            for (var i = 0; i <= end; i++) {
                if (myUNAS.CurrentLanguage == '简体中文') {
                    _str += '<option value="' + i + '">' + (i + 1) + '月</option>';
                } else {
                    _str += '<option value="' + i + '">' + (i + 1) + '</option>';
                }
            }
            return _str;
        }

        //拼接日期选项字符串
        function generateDateOptions(end) {
            var _str = '';
            for (var i = 1; i <= end; i++) {
                if (myUNAS.CurrentLanguage == '简体中文') {
                    _str += '<option value="' + i + '">' + i + '日</option>';
                } else {
                    _str += '<option value="' + i + '">' + i + '</option>';
                }
            }
            return _str;
        }

        //是否闰年
        function isLeapYear(year) {
            return (year % 4 === 0 && year % 100 !== 0) || year % 400 === 0;
        };

        //获取每月天数
        //month are zero indexed
        function getMonthDay(month, year) {
            var monthDay = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
            if (month == 1 && isLeapYear(year)) {
                return 29;
            } else {
                return monthDay[month];
            }
        }
    }

    function getStartDate() {
        var year = $('#record_sel_year').val();
        var month = $('#record_sel_month').val();
        var date = $('#record_sel_date').val();
        var startDate = new Date(year, month, date);

        return startDate;
    }

    function getEndDate() {
        var year = $('#record_sel_year').val();
        var month = $('#record_sel_month').val();
        var date = $('#record_sel_date').val();
        var endDate = new Date(year, month, date, 23, 59, 59);

        return endDate;
    }

    function updateMonitor(type = '') {
        getMonitorSize();
        $('.monitor-thumb-record').css({
            'width': _monitorThumbWidth,
            'height': _monitorThumbHeight
        });
        $('.video-player-record').css({
            'width': _monitorThumbWidth,
            'height': _monitorThumbHeight
        });

        var width = $(document).width() - 233;
        // $('.v-seekbar-time-scale').width(width);
        $('#canvas1').hide();
        $('#canvas2').hide();

        if (type == 'resize') {
            if (aTimeline) {
                setTimeline(type);
            }
        } else {
            setTimeline(type);
        }

        $('#canvas1').show();
        $('#canvas2').show();
        // redrawScreen();
    }

    function getMonitorSize() {
        var value = $('#record_sel_size').length == 0 ? 0 : Number($('#record_sel_size').val());
        // console.log(value);
        if (value == 0) {
            var _width = $('#monitor_left_view').width();
            var _height = $('#monitor_left_view').height();
            // console.log('_width:' + _width, '_height:' + _height, '_monitor_ratio:' + _monitor_ratio, _width / _height)
            if (_width / _height >= _monitor_ratio) {
                _monitorThumbHeight = _height;
                _monitorThumbWidth = _height * _monitor_ratio;
                // console.log(_monitorThumbWidth, _monitorThumbHeight)
            } else {
                _monitorThumbWidth = _width;
                _monitorThumbHeight = _width / _monitor_ratio;
                // console.log(_monitorThumbWidth, _monitorThumbHeight)
            }
        } else {
            var recordData = _records[_recordId];
            if (recordData) {
                _monitorThumbWidth = parseInt(recordData.Width) * value / 100;
                _monitorThumbHeight = parseInt(recordData.Height) * value / 100;
            } else {
                var _width = $('#monitor_left_view').width();
                var _height = $('#monitor_left_view').height();
                if (_width / _height >= _monitor_ratio) {
                    _monitorThumbHeight = _height;
                    _monitorThumbWidth = _height * _monitor_ratio;
                } else {
                    _monitorThumbWidth = _width;
                    _monitorThumbHeight = _width / _monitor_ratio;
                }
            }
        }
    }

    //获取回放列表
    function doGetRecordList(page = 1) {
        if (page == 1) {
            showWaiting();
        }

        var startDate = getStartDate();
        var startTime = formatDate(startDate.getTime(), false) + ' 00:00:00';

        var endDate = getEndDate();
        var endTime = formatDate(endDate.getTime(), true);

        var reqUrl;

        var ZM_Monitor_Select_Monitor_Id = localStorage.getItem('ZM_Monitor_Select_Monitor_Id');
        var monitorId = ZM_Monitor_Select_Monitor_Id ? ZM_Monitor_Select_Monitor_Id : $('#record_sel_monitor').val();

        $('#record_sel_monitor').val(monitorId);
        //默认第一个摄像机
        if (!monitorId && monitorPtr.length > 0) {
            monitorId = monitorPtr[0];
        }
        selectMonitorId = monitorId;
        if (!selectMonitorId) {
            hideWaiting();
            showNoticeEmpty();
            return false;
        }

        if (_recordIndexReset == -1) {
            if (monitorId) {
                // reqUrl = "/zm/api/events/index/MonitorId:" + monitorId + "/StartTime >=:" + startTime + "/EndTime <=:" + endTime + ".json" + "?token=" + window.zm.access_token + "&page=1&sort=StartTime&direction=desc";
                reqUrl = "/zm/api/events/index/MonitorId:" + monitorId + "/StartTime >=:" + startTime + ".json" + "?token=" + window.zm.access_token + "&page=" + page + "&sort=StartTime&direction=desc";
            } else {
                // reqUrl = "/zm/api/events/index/StartTime >=:" + startTime + "/EndTime <=:" + endTime + ".json" + "?token=" + window.zm.access_token + "&page=1&sort=StartTime&direction=desc";
                reqUrl = "/zm/api/events/index/StartTime >=:" + startTime + ".json" + "?token=" + window.zm.access_token + "&page=" + page + "&sort=StartTime&direction=desc";
            }
        } else {
            if (monitorId) {
                reqUrl = "/zm/api/events/index/MonitorId:" + monitorId + "/StartTime >=:" + startTime + "/EndTime <=:" + endTime + ".json" + "?token=" + window.zm.access_token + "&page=" + page + "&sort=StartTime&direction=desc";
                // reqUrl = "/zm/api/events/index/MonitorId:" + monitorId + "/StartTime >=:" + startTime + ".json" + "?token=" + window.zm.access_token + "&page=1&sort=StartTime&direction=desc";
            } else {
                reqUrl = "/zm/api/events/index/StartTime >=:" + startTime + "/EndTime <=:" + endTime + ".json" + "?token=" + window.zm.access_token + "&page=" + page + "&sort=StartTime&direction=desc";
                // reqUrl = "/zm/api/events/index/StartTime >=:" + startTime + ".json" + "?token=" + window.zm.access_token + "&page=1&sort=StartTime&direction=desc";
            }
        }

        getRecordListEnd = false;
        jQuery.ajax({
            url: reqUrl,
            type: "GET",
            async: true,
            dataType: 'json',
            success: function (data) {
                // console.log(data)
                var arr = _records.length != 0 ? _records : [];
                // console.log(events_by_monitor_id)
                for (var i = 0, len = data.events.length; i < len; ++i) {
                    var mid = data.events[i].Event.MonitorId;
                    var eid = data.events[i].Event.Id;
                    if (i == 0 && _recordIndexReset == -1) {
                        streamRecordId = eid;
                        streamRecordData = data.events[i].Event;
                    }

                    if (!checkInArr('Id', eid, _records)) {
                        // console.log('doGetRecordList _records push');
                        arr.push(data.events[i].Event);
                    }
                    if (events_by_monitor_id[mid] == undefined) {
                        events_by_monitor_id[mid] = [];
                    }
                    events_by_monitor_id[mid].push(eid);

                    if (!events[eid]) {
                        events[eid] = data.events[i].Event;
                    }
                }

                addUniqueRecordConnkey(arr);

                _records = arr;

                attachRecords(_records);
                //每隔10秒获取事件列表，用于追加时间线和右侧事件列表
                if (getrecordlisttimer) {
                    clearInterval(getrecordlisttimer);
                }
                getrecordlisttimer = setInterval(function () {
                    refreshTimeParts(reqUrl);
                }, getRecordListTimeInterval)

                getRecordListEnd = true;
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                getRecordListEnd = true;
                hideWaiting();
                showNoticeEmpty();
                console.log('event event_list error textStatus:' + textStatus);
            },
            complete: function () {
                getRecordListEnd = true;
                hideWaiting();
            }
        });
    }

    function checkInArr(key = 'id', value, arr = []) {
        var exist = false;
        for (var i = 0; i < arr.length; i++) {
            if (value == arr[i][key]) {
                exist = true;
                break;
            }
        }
        return exist;
    }

    function refreshTimeParts(reqUrl) {
        if (!getRecordListEnd) {
            return false;
        }
        var reqUrl1 = reqUrl.replace('&page=' + page, '&page=1');
        jQuery.ajax({
            url: reqUrl1,
            type: "GET",
            async: true,
            dataType: 'json',
            success: function (data) {
                if (!getRecordListEnd) {
                    return false;
                }

                var records = [];
                for (var i = 0, len = data.events.length; i < len; ++i) {
                    records.push(data.events[i].Event);

                    var mid = data.events[i].Event.MonitorId;
                    var eid = data.events[i].Event.Id;

                    if (events_by_monitor_id[mid] == undefined) {
                        events_by_monitor_id[mid] = [];
                    }
                    events_by_monitor_id[mid].push(eid);

                    if (!events[eid]) {
                        events[eid] = data.events[i].Event;
                    }

                    var eventItem = data.events[i].Event;
                    for (var j = 0; j < _records.length; j++) {
                        if (_records[j].Name == 'New Event') {
                            if (eid == _records[j].Id && eventItem.Name != 'New Event') {
                                // console.log(_records[j], eventItem)
                                _records[j]['EndDateTime'] = eventItem.EndDateTime;
                                _records[j]['EndTime'] = eventItem.EndTime;
                                _records[j]['EndTimeSecs'] = eventItem.EndTimeSecs;
                                _records[j]['Length'] = eventItem.Length;
                                _records[j]['Name'] = eventItem.Name;
                            }
                        }
                    }

                    if (!checkInArr('Id', eid, _records) && getRecordListEnd) {
                        // console.log('refreshTimeParts _records unshift');
                        _records.unshift(data.events[i].Event);
                    }
                }

                var hasNewEvent = false;
                for (var i = 0; i < records.length; i++) {
                    if (parseInt(records[i].Videoed) == 0 && parseInt(records[i].SaveJPEGs) == 0) {
                        continue;
                    }

                    // console.log(timeParts, records[i].EndTime)
                    if (records[i].EndTime == null) {
                        var end = records[i].EndTimeSecs * 1000;

                        var obj = {
                            // startTime: records[i].StartTime,
                            // endTime: records[i].EndTime,
                            id: records[i].Id,
                            start: records[i].StartTimeSecs * 1000,
                            end: end,
                            style: {
                                background: "#475059"
                            }
                        }

                        // console.log(obj)
                        var checkObjIn = false;
                        timeParts.forEach(item => {
                            // console.log(item.id, obj.id)
                            if (item.id == obj.id) {
                                checkObjIn = true;
                                item.end = end;
                            }
                        })

                        // console.log('checkObjIn', checkObjIn);
                        if (!checkObjIn) {
                            timeParts.push(obj);
                            hasNewEvent = true;
                        }
                    }

                    //修改New Event为Event-id
                    var id = records[i].Id;
                    if ($('#tr_record_' + id).length) {
                        if ($('#tr_record_' + id).find('.td_record_name').attr('title') == 'New Event') {
                            if (records[i].Name != 'New Event') {
                                var html = '';
                                var title = '';
                                if (records[i].EndTime && debug) {
                                    html += '<td class="td_record_time" title="' + myUNAS._('开始-结束时间') + '">' + records[i].StartTime.substring(10) + ' - ' + records[i].EndTime.substring(10) + '</td>';
                                    title = myUNAS._('开始-结束时间');
                                } else {
                                    html += '<td class="td_record_time" title="' + myUNAS._('开始时间') + '">' + records[i].StartTime.substring(10) + '</td>';
                                    title = myUNAS._('开始时间');
                                }
                                $('#tr_record_' + id).find('.td_record_name').attr('title', records[i].Name).html(records[i].Name);
                                $('#tr_record_' + id).find('.td_record_time').attr('title', title).html(html);
                                $('#tr_record_' + id).find('.td_record_length').attr('title', myUNAS._('时长')).html(convertSeconds(records[i].Length));

                                for (var j = 0; j < _records.length; j++) {
                                    if (id == _records[j].Id) {
                                        //修改New Event end
                                        var end = records[i].EndTimeSecs * 1000 + 999;
                                        hasNewEvent = true;
                                        timeParts.forEach(item => {
                                            // console.log(item.id, obj.id)
                                            if (item.id == id) {
                                                item.end = end;
                                            }
                                        })
                                    }
                                }
                            } else {
                                $('#tr_record_' + id).find('.td_record_length').attr('title', myUNAS._('时长')).html(convertSeconds(records[i].Length));
                            }
                        }
                    }

                    //追加New Event
                    if (!$('#tr_record_' + id).length) {
                        var str = '';
                        str += '<tr class="tr_record" id="tr_record_' + records[i].Id + '" data-ref="' + records[i].Id + '">';
                        str += '<td class="recordInput"><input class="jvc-checkbox" data-ref="' + i + '" type="checkbox" name="" value="' + records[i].Id + '"></td>';

                        // str += '<td class="td_record_monitor_name" title="' + getMonitorNameById(records[i].MonitorId) + '">' + getMonitorNameById(records[i].MonitorId) + '</td>';
                        str += '<td class="td_record_name" title="' + records[i].Name + '">' + records[i].Name + '</td>';

                        if (records[i].EndTime && debug) {
                            str += '<td class="td_record_time" title="' + myUNAS._('开始-结束时间') + '">' + records[i].StartTime.substring(10) + ' - ' + records[i].EndTime.substring(10) + '</td>';
                        } else {
                            str += '<td class="td_record_time" title="' + myUNAS._('开始时间') + '">' + records[i].StartTime.substring(10) + '</td>';
                        }
                        str += '<td class="td_record_length" title="' + myUNAS._('时长') + '">' + convertSeconds(records[i].Length) + '</td>';

                        str += '<td class="td_record_operation">';
                        str += '<div class="td_icon td_record_delete" data-ref="' + records[i].Id + '"></div>';
                        str += '</td>';
                        str += '</tr>';

                        $('#record_table').prepend(str);
                        addEvents();

                        $("input[name='selectAll']").prop('checked', false);
                    }
                }

                if (hasNewEvent) {
                    // console.log('hasNewEvent', hasNewEvent, timeParts);
                    setTimeParts(aTimeline, timeParts);
                }

            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                // console.log('event event_list error textStatus:' + textStatus);
            },
            complete: function () {
                hideWaiting();
            }
        });
    }

    function convertSeconds(totalSeconds) {
        let hours = Math.floor(totalSeconds / 3600); // 计算小时数
        let minutes = Math.floor((totalSeconds % 3600) / 60); // 计算分钟数
        let seconds = parseInt(totalSeconds % 60); // 计算剩余的秒数

        // 如果小时、分钟或秒为0，则不显示
        hours = hours > 0 ? hours + 'h' : '';
        minutes = minutes > 0 ? minutes + 'm' : '';
        seconds = seconds > 0 ? seconds + 's' : '';

        return hours + ' ' + minutes + ' ' + seconds;
    }

    function showNoticeEmpty() {
        //alert('当前选择日期没有回放记录');
        $('#record_notice_empty').show();
        $('#monitor_left_view').hide();

        removeEvents();
        $('#record_table').empty();

        $('#setting_item_codec').hide();

        var $monitorContainer = $('#monitor_thumb_record_container');
        $monitorContainer.hide();
        removeMonitorEvents();
        $monitorContainer.empty();

        var $videoPlayerContainer = $('#monitor_video_player_container');
        $videoPlayerContainer.hide();
        $videoPlayerContainer.empty();
    }

    function attachRecords(records) {
        // if (_records.length == 0) return;

        //填充时间轴回放对象
        // attachRecordThumbs();

        if (page == 1) {
            $('#record_notice_empty').hide();
            $('#monitor_left_view').show();
        }

        var $recordTable = $('#record_table');

        removeEvents();
        $recordTable.empty();

        // var timeParts = [];
        var str = '';
        // console.log(records)
        for (var i = 0; i < records.length; i++) {
            //至少在Storage设置页选择了'保存为视频'或者'保存为JPEGs'，才会生成回放数据
            //console.log(i+' records[i].Videoed:'+records[i].Videoed);
            //console.log(i+' records[i].SaveJPEGs:'+records[i].SaveJPEGs);
            if (parseInt(records[i].Videoed) == 0 && parseInt(records[i].SaveJPEGs) == 0) {
                continue;
            }

            str += '<tr class="tr_record" id="tr_record_' + records[i].Id + '" data-ref="' + records[i].Id + '">';
            str += '<td class="recordInput"><input class="jvc-checkbox" data-ref="' + i + '" type="checkbox" name="" value="' + records[i].Id + '"></td>';

            // str += '<td class="td_record_monitor_name" title="' + getMonitorNameById(records[i].MonitorId) + '">' + getMonitorNameById(records[i].MonitorId) + '</td>';
            str += '<td class="td_record_name" title="' + records[i].Name + '">' + records[i].Name + '</td>';

            //test
            if (records[i].EndTime && debug) {
                str += '<td class="td_record_time" title="' + myUNAS._('开始-结束时间') + '">' + records[i].StartTime.substring(10) + ' - ' + records[i].EndTime.substring(10) + '</td>';
            } else {
                str += '<td class="td_record_time" title="' + myUNAS._('开始时间') + '">' + records[i].StartTime.substring(10) + '</td>';
            }
            str += '<td class="td_record_length" title="' + myUNAS._('时长') + '">' + convertSeconds(records[i].Length) + '</td>';

            str += '<td class="td_record_operation">';
            str += '<div class="td_icon td_record_delete" data-ref="' + records[i].Id + '"></div>';
            str += '</td>';
            str += '</tr>';

            if (records[i].StartTimeSecs && records[i].EndTimeSecs) {
                var end = records[i].EndTimeSecs * 1000;
                // console.log(records[i].StartTimeSecs, records[i].EndTimeSecs, records[i-1].StartTimeSecs, records[i-1].EndTimeSecs);

                if (records[i - 1] != undefined) {
                    if (records[i - 1].StartTimeSecs - records[i].EndTimeSecs < 2) {
                        end = records[i].EndTimeSecs * 1000 + 999;
                    }
                }

                var obj = {
                    id: records[i].Id,
                    // startTime: records[i].StartTime,
                    // endTime: records[i].EndTime,
                    start: records[i].StartTimeSecs * 1000,
                    end: end,
                    style: {
                        background: "#475059"
                    }
                }
                timeParts.push(obj);
            }
        }

        $recordTable.append(str);
        addEvents();

        var id = $('#record_table').children().first().attr('data-ref');
        $('#tr_record_' + id).find('.td_record_name').addClass('active');

        if (page == 1) {
            attachMonitorRecord();
        }
    }

    //获取MonitorId对应的MonitorName(在monitor.js中有保存所有监视器信息的全局变量window.zm._monitorsOriginal，这里可直接使用)
    function getMonitorNameById(monitorId) {
        var monitors = window.zm._monitorsOriginal;
        if (monitors) {
            for (var i = 0, len = monitors.length; i < len; ++i) {
                if (monitors[i].Monitor.Id == monitorId) {
                    return monitors[i].Monitor.Name;
                }
            }
        }
        return '';
    }

    function getRecordLength(record) {
        return parseInt((new Date(record.EndTime) - new Date(record.StartTime)) / 10) / 100;
    }

    function addEvents() {
        $('.tr_record .td_record_name').off('click').on('click', function () {
            if ($(this).hasClass('active')) return;

            // //停止所有监视器的状态轮询请求
            // stopGetStatus();
            // //停止播放'流静帧'
            // stopStreamMjpeg();

            // if (player) {
            //     player.dispose();
            //     player = null;
            // }

            if (tunnerTimer) {
                clearInterval(tunnerTimer);
                tunnerTimer = null;
            }
            if (playerIntervalTimer) {
                clearInterval(playerIntervalTimer);
                playerIntervalTimer = null;
            }

            var lastRecordId = _recordId;
            var $that = $(this).parent('.tr_record');
            var index = $that.data('ref');
            _recordId = index;
            $('.td_record_name').removeClass('active');
            $('#tr_record_' + _recordId).find('.td_record_name').addClass('active');

            monitorCanvasObj = [];
            monitorCanvasCtx = [];
            monitorImageObject = [];
            // console.log(monitorImageObject)

            // if (!codeFlg) {
            //     if (timerObj) {
            //         clearInterval(timerObj);
            //         timerObj = null;
            //     }
            //     if (lastRecordId != 0) {
            //         doPauseStreamMjpeg(lastRecordId);
            //     }
            // }

            // console.log('_recordId:'+_recordId)
            attachMonitorRecord(_recordId, 'auto', 'eventChange');
        });

        $('.td_record_delete').off('click').on('click', function (e) {
            e.stopPropagation();
            _targetRecordIndex = $(this).data('ref');

            $(".td_record_delete").removeClass("pressed");
            $(this).addClass("pressed");

            showConfirmDelete(deleteRecord);
        });
        $('.td_record_delete').mousedown(function () {
            $(this).addClass("pressed");
        }).mouseup(function () {
            $(this).removeClass("pressed");
        }).mouseout(function () {
            $(this).removeClass("pressed");
        });

        $('.jvc-checkbox').off('click').on('click', function (event) {
            event.stopPropagation();
        })

        $("input[name='selectAll']").off('click').on('click', function () {
            var checked = $(this).is(":checked");
            $('.jvc-checkbox').prop('checked', checked);
        });
    }

    function removeEvents() {
        $('.td_record_delete').off();
        $('.tr_record .td_record_name').off();
    }

    // 删除记录
    function deleteRecord() {
        showWaiting();

        jQuery.ajax({
            url: "/zm/api/events/" + _targetRecordIndex + ".json?token=" + window.zm.access_token,
            type: "DELETE",
            async: true,
            dataType: 'text',
            success: function (data) {
                // console.log(data);
                //promptShow('删除成功');
                // promptShow({
                //   text: "删除成功", //提示文字
                //   width: "390px", //提示框宽度
                //   height: "246px", //提示框高度
                //   icon: "images/icon_delete02.png", //提示图标
                //   iconWidth: "80px", //提示图标的大小
                //   textLineHeight: "360px" //提示文字的行高
                // });
                Message.success(myUNAS._('Delete Success'));

                $('#tr_record_' + _targetRecordIndex).remove();
                if (_recordId == _targetRecordIndex) {
                    update();
                } else {
                    hideWaiting();
                }
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                //console.log('event delete error textStatus:' + textStatus);
                // promptShow('删除失败');
                Message.success(myUNAS._('Delete Failed'));
                hideWaiting();
            }
        });
    }

    function attachMonitorRecord(index = 0, codec = 'auto', type = '') {
        if (codec == 'auto') {
            $('#setting_item_codec').hide();
        }

        // getMonitorSize();
        removeMonitorEvents();

        var $monitorContainer = $('#monitor_thumb_record_container');
        $monitorContainer.hide();
        $monitorContainer.empty();

        var $videoPlayerContainer = $('#monitor_video_player_container');
        $videoPlayerContainer.hide();
        $videoPlayerContainer.empty();

        var recordData = [];
        var indexrecord = 0;
        for (var i = 0; i < _records.length; i++) {
            if (index == 0) {
                recordData = _records[0];
                indexrecord = 0
            } else if (index == _records[i].Id && i != 0) {

                recordData = _records[i];
                indexrecord = i + 1;
                break;
            }
        }
        _recordId = index;
        // console.log('_recordId:' +_recordId)

        // console.log('indexrecord:'+indexrecord, '_recordId:'+_recordId)
        if (indexrecord == 0) {
            setLiveMode(1);
            speedIndex = 3;
        } else {
            setLiveMode(0, true);
        }

        // console.log(codec, recordData.Videoed)
        // if (codec == 'MP4' || (codec == 'auto' && parseInt(recordData.Videoed) != 0)) {
        //     codeFlg = true;
        // } else {
        //     codeFlg = false;
        // }

        var str = '';
        str += '<div class="video-player-record" data-ref="' + index + '" style="width:' + _monitorThumbWidth + 'px; height:' + _monitorThumbHeight + 'px">';

        recordData = recordData.length != 0 ? recordData : streamRecordData;
        // console.log('index:' + index, 'indexrecord:' + indexrecord, recordData);
        if (indexrecord == 0) {
            var monId = selectMonitorId;
            var streamMjpegSrc = window.zm.cgiBinUrl + '?mode=jpeg&maxfps=30' +
                '&scale=' + recordData.scale +
                // '&width=' + _monitorThumbWidth +
                // '&heigth=' + _monitorThumbHeight +
                '&monitor=' + monId +
                '&token=' + window.zm.access_token +
                '&connkey=' + recordData.connkey +
                '&rand=' + Math.random() +
                '&wid=' + window.zm.windowId +
                '&rnd=' + Math.random().toString(36).slice(-6);
            str += '<img src="' + streamMjpegSrc + '" id="Monitor' + monId + '" monitor_id="' + monId + '" style="height: 100%"/>';
            str += '</div>';

            $videoPlayerContainer.append(str);
            $videoPlayerContainer.show();

            updateMonitor();

            if (aTimeline != undefined) {
                if (timeParts.length > 0) {
                    timeParts.reverse();
                    setTimeParts(aTimeline, timeParts);
                }

                var timelineinfo = aTimeline.getTimeLineInfo();
                var start = timelineinfo.currentTime - timelineinfo.zoom * 60 * 60 * 1000;
                var end = timelineinfo.currentTime;

                if (recordData.StartTimeSecs < start / 1000 || recordData.StartTimeSecs > end / 1000) {
                    var currentTime = recordData.StartTimeSecs + timelineinfo.zoom * 60 * 60;
                    aTimeline.setCurrentTime((currentTime - timelineinfo.zoom * 60) * 1000)
                } else {
                    if (timeLineCurrentTime) {
                        aTimeline.setCurrentTime(timeLineCurrentTime);
                    }
                }
            }

            playerPaused = false;

            // //对视频的控制元素阻止冒泡，防止其调用相关事件造成干扰
            // $(".vjs-control-bar").click(function () {
            //     stopPropagation();
            // });

            var label = isPlayReverse ? reverseSpeeds[speedIndex]['label'] : speeds[speedIndex]['label'];
            $('.v-speed-text').html(label);

            return false;
        }


        if (indexrecord != 0) {
            clearInterval(timerObj)
            if (player) {
                player.dispose();
                player = null;
            }

            videoDuration = recordData['Length'];

            str += '<video id="video_record" data-ref="' + index + '" class="video-js vjs-big-play-centered" preload="auto" width="100%" height="100%">';
            var videoUrl = '/zm/index.php?view=view_video' + '&eid=' + recordData.Id + '&token=' + window.zm.access_token;
            // console.log(videoUrl)
            // str += '<source src="'+videoUrl+'" type="video/mp4" />';
            str += '</video>';

            str += '</div>';

            $videoPlayerContainer.append(str);
            $videoPlayerContainer.show();

            showLoading();
            // fetch(fetchUrl).then(response => response.blob()).then(blob => {
            // 在这里你可以使用blob对象，例如创建一个视频URL并在video元素中播放
            // const videoUrl = URL.createObjectURL(blob);

            if (type != 'playEnd') {
                //getMonitorSize setTimeline
                updateMonitor();
            }

            if (aTimeline != undefined) {
                if (timeParts.length > 0) {
                    timeParts.reverse();
                    setTimeParts(aTimeline, timeParts);
                }

                var timelineinfo = aTimeline.getTimeLineInfo();
                var start = timelineinfo.currentTime - timelineinfo.zoom * 60 * 60 * 1000;
                var end = timelineinfo.currentTime;
                if (isPlayReverse) {
                    //点击事件切换 让时间刻度显示在正中间
                    if (type == 'eventChange') {
                        var currentTime = recordData.StartTimeSecs + (timelineinfo.zoom * 60 * 60 / 2);
                        aTimeline.setCurrentTime(currentTime * 1000)
                    } else if (type == 'playEnd') {
                        // console.log(timelineinfo);
                        aTimeline.setCurrentTime(timelineinfo.currentTime)
                    } else {
                        if (recordData.EndTimeSecs < start / 1000 || recordData.EndTimeSecs > end / 1000) {
                            var currentTime = recordData.StartTimeSecs + timelineinfo.zoom * 60 * 60;
                            aTimeline.setCurrentTime((currentTime - timelineinfo.zoom * 60) * 1000)
                        }
                    }
                } else {
                    //点击事件切换 让时间刻度显示在正中间
                    if (type == 'eventChange') {
                        var currentTime = recordData.StartTimeSecs + (timelineinfo.zoom * 60 * 60 / 2);
                        aTimeline.setCurrentTime(currentTime * 1000)
                    } else if (type == 'playEnd') {
                        // console.log(timelineinfo);
                        aTimeline.setCurrentTime(timelineinfo.currentTime)
                    } else {
                        if (recordData.StartTimeSecs < start / 1000 || recordData.StartTimeSecs > end / 1000) {
                            var currentTime = recordData.StartTimeSecs + timelineinfo.zoom * 60 * 60;
                            aTimeline.setCurrentTime((currentTime - timelineinfo.zoom * 60) * 1000)
                        }
                    }
                }

                currentTimeSecs = recordData.StartTimeSecs;

                if (isPlayReverse) {
                    setTunner(recordData.EndTimeSecs);
                } else {
                    setTunner(recordData.StartTimeSecs + 1);
                }
            }

            player = videojs('video_record');

            player.ready(function () {
                updateAndPlayNextVideo(videoUrl);
            })

            player.on("play", function () {
                // console.log('event：' + _recordId + ' start play');

                // console.log('_recordId:' + _recordId, 'attachMonitorRecord play')
                hideLoading();
                playerPaused = false;

                // console.log('speedIndex:'+speedIndex)
                if (isPlayReverse) {
                    setReverseSpeed(speedIndex);
                } else {
                    setSpeed(speedIndex);
                }

                $('.td_record_name').removeClass('active');
                $('#tr_record_' + _recordId).find('.td_record_name').addClass('active');
            });

            player.on("timeupdate", function() {
                // 修正tunner time
                var time = recordData.StartTimeSecs+Math.round(player.currentTime());
                if (playTime - time > 2 || player - time < -2) {
                    setTunner(time);
                }
            });
            player.on("ended", function () {
                if (player) {
                    player.dispose();
                    player = null;
                }
                var id = 0;
                for (var i = 0; i < _records.length; i++) {
                    if (_recordId == _records[i].Id) {
                        if (_records[i - 1]) {
                            id = _records[i - 1].Id;
                            break;
                        }
                    }
                }

                if (tunnerTimer) {
                    clearInterval(tunnerTimer);
                    tunnerTimer = null;
                    stopMove(aTimeline);
                }
                console.log('event：' + _recordId + ' play ended');

                if (aTimeline) {
                    var timelineinfo = aTimeline.getTimeLineInfo();
                    timeLineCurrentTime = timelineinfo.currentTime
                }

                // console.log('_recordId:' + _recordId, 'attachMonitorRecord playEnd')
                showLoading();
                setTimeout(function () {
                    hideLoading();
                    attachMonitorRecord(id, codec, 'playEnd');
                }, 1000)
            });

            player.on("error", function () {
                if (player) {
                    console.log('player error dispose null')
                    player.dispose();
                    player = null;
                }
                if (tunnerTimer) {
                    clearInterval(tunnerTimer);
                    tunnerTimer = null;
                    stopMove(aTimeline);
                }
                var id = 0;
                for (var i = 0; i < _records.length; i++) {
                    if (_recordId == _records[i].Id) {
                        if (_records[i - 1]) {
                            id = _records[i - 1].Id;
                            break;
                        }
                    }
                }

                // console.log('_recordId:' + _recordId, 'attachMonitorRecord play error, play next id:' + id);

                showLoading();
                setTimeout(function () {
                    hideLoading();
                    attachMonitorRecord(id, 'auto', 'playEnd');
                }, 1000)

                // console.log('播放出错重试 _recordId:' + _recordId, 'attachMonitorRecord play error')
                // attachMonitorRecord(_recordId, 'auto', 'playEnd');
            });

            // })

            // //对视频的控制元素阻止冒泡，防止其调用相关事件造成干扰
            // $(".vjs-control-bar").click(function () {
            //     stopPropagation();
            // });

            var label = isPlayReverse ? reverseSpeeds[speedIndex]['label'] : speeds[speedIndex]['label'];
            $('.v-speed-text').html(label);

            return false;

            // }).catch(error => {
            //     hideLoading();
            //     console.error('Error fetching video data:', error);
            // });
        }
    }

    function updateAndPlayNextVideo(videoUrl) {
        if (player) {
            // 更新视频源
            player.src({type: 'video/mp4', src: videoUrl});

            // 播放新视频
            // console.log('player.paused:'+player.paused())
            player.play();
        }
    }

    //播放视频时更新缩放按钮状态
    function updatePlayerZoomButton(vjPlayer) {
        $('.zm-btn-media-zoomout').removeClass('active, inactive');

        if (player.getZoom() == 1) {
            $('.zm-btn-media-zoomout').addClass('inactive');
        }
    }

    //播放视频时更新底部操作按钮状态
    function updatePlayerControlButtons(dataIndex, vjPlayer) {
        //重置所有底部操作按钮状态
        $('#zm_btn_media_back_record_' + dataIndex).removeClass('active, inactive');
        $('#zm_btn_media_last_record_' + dataIndex).removeClass('active, inactive');
        $('#zm_btn_media_pause_record_' + dataIndex).removeClass('active, inactive');
        $('#zm_btn_media_play_record_' + dataIndex).removeClass('active, inactive');
        $('#zm_btn_media_next_record_' + dataIndex).removeClass('active, inactive');
        $('#zm_btn_media_fastforward_record_' + dataIndex).removeClass('active, inactive');

        //如果处于暂停状态
        if (vjPlayer.paused()) {
            $('#zm_btn_media_pause_record_' + dataIndex).addClass('inactive');

            //回放暂停时可以单步前进单步后退，不可快进快退
            $('#zm_btn_media_last_record_' + dataIndex).removeClass('active, inactive');
            $('#zm_btn_media_next_record_' + dataIndex).removeClass('active, inactive');
            $('#zm_btn_media_back_record_' + dataIndex).addClass('inactive');
            $('#zm_btn_media_fastforward_record_' + dataIndex).addClass('inactive');
        } else {
            $('#zm_btn_media_play_record_' + dataIndex).addClass('inactive');

            //播放状态时可以快进快退，不可单步前进单步后退
            $('#zm_btn_media_last_record_' + dataIndex).addClass('inactive');
            $('#zm_btn_media_next_record_' + dataIndex).addClass('inactive');
            $('#zm_btn_media_back_record_' + dataIndex).removeClass('active, inactive');
            $('#zm_btn_media_fastforward_record_' + dataIndex).removeClass('active, inactive');
        }
    }

    function addMonitorEvents() {
        // $('.monitor-thumb-record,.video-player-record').mouseenter(function () {
        //     $(this).find('.control-panel-container').removeClass('hide');
        //
        //     $('.vjs-control-bar').show();
        // });
        // $('.monitor-thumb-record,.video-player-record').mouseleave(function () {
        //     $(this).find('.control-panel-container').addClass('hide');
        //
        //     $('.vjs-control-bar').hide();
        // });

        $('.monitor-thumb-record .progress-bar').click(function (e) {
            var index = $(this).data('ref');
            //console.log('progress mjpeg index:'+index);
            $('#progress_thumb_' + index).css('width', e.offsetX);
            var percent = e.offsetX / $(this).width();
            //console.log('percent:'+percent);

            doSeekStreamMjpeg(index, percent);
        });

        //zoomin'流静帧'（点击'流静帧'，在点击处zoomin）
        $('.monitor-thumb-record .screen-mjpeg,.video-player-record #video_record').click(function (e) {
            var index = $(this).data('ref');
            //console.log('zoomin mjpeg index:'+index);
            //console.log('e.offsetX:'+e.offsetX+' e.offsetY:'+e.offsetY);

            doZoominStreamMjpeg(index, e.offsetX, e.offsetY);
        });
        //zoomout'流静帧'
        $('.monitor-thumb-record .zm-btn-media-zoomout,.video-player-record .zm-btn-media-zoomout').click(function (e) {
            var $that = $(this);
            if ($that.hasClass('active') || $that.hasClass('inactive')) return;

            var index = $that.data('ref');
            //console.log('zoomout mjpeg index:'+index);
            doZoomoutStreamMjpeg(index);
        });

        //pause'流静帧'
        $('.monitor-thumb-record .zm-btn-media-pause,.video-player-record .zm-btn-media-pause').click(function (e) {
            var $that = $(this);
            if ($that.hasClass('active') || $that.hasClass('inactive')) return;

            var index = $that.data('ref');
            //console.log('pause mjpeg index:'+index);
            doPauseStreamMjpeg(index, true);
        });

        //play'流静帧'
        $('.monitor-thumb-record .zm-btn-media-play,.video-player-record .zm-btn-media-play').click(function (e) {
            var $that = $(this);
            if ($that.hasClass('active') || $that.hasClass('inactive')) return;

            var index = $that.data('ref');
            //console.log('play mjpeg index:'+index);
            doPlayStreamMjpeg(index);
        });

        //last'流静帧',单步后退
        $('.monitor-thumb-record .zm-btn-media-last,.video-player-record .zm-btn-media-last').click(function (e) {
            var $that = $(this);
            if ($that.hasClass('inactive')) return;

            var index = $that.data('ref');
            //console.log('play mjpeg index:'+index);
            doLastStreamMjpeg(index);
        });

        //next'流静帧',单步前进
        $('.monitor-thumb-record .zm-btn-media-next,.video-player-record .zm-btn-media-next').click(function (e) {
            var $that = $(this);
            if ($that.hasClass('inactive')) return;

            var index = $that.data('ref');
            //console.log('play mjpeg index:'+index);
            doNextStreamMjpeg(index);
        });

        //fastforward'流静帧',快进
        $('.monitor-thumb-record .zm-btn-media-fastforward,.video-player-record .zm-btn-media-fastforward').click(function (e) {
            var $that = $(this);
            if ($that.hasClass('inactive')) return;

            var index = $that.data('ref');
            //console.log('play mjpeg index:'+index);
            doFastForwardStreamMjpeg(index);
        });

        //back'流静帧',快退
        $('.monitor-thumb-record .zm-btn-media-back,.video-player-record .zm-btn-media-back').click(function (e) {
            var $that = $(this);
            if ($that.hasClass('inactive')) return;

            var index = $that.data('ref');
            //console.log('play mjpeg index:'+index);
            doBackStreamMjpeg(index);
        });

        //上一个下一个（切换录像）
        $('.zm-btn-media-previous-event').off('click').on('click', function (e) {
            $(".tr_record .td_record_name.active").parent('.tr_record').prev().find('.td_record_name').trigger("click");
        });
        $('.zm-btn-media-next-event').off('click').on('click', function (e) {
            $(".tr_record .td_record_name.active").parent('.tr_record').next().find('.td_record_name').trigger("click");
        });
    }

    function removeMonitorEvents() {
        $('.monitor-thumb-record .zm-btn-media').off();
        $('.video-player-record .zm-btn-media').off();

        $('.monitor-thumb-record .screen-mjpeg').off();

        $('.monitor-thumb-record .progress-bar').off();

        $('.monitor-thumb-record').off();
        $('.video-player-record').off();
    }

    //拖动时间轴指针触发播放，跳转到对应时间
    //continueStartGetStatus: seek返回后，是否开始监视器的状态轮询请求
    function forceSeekStreamMjpeg(dataIndex, forceSeekOffset, continueStartGetStatus) {
        if (player) {
            //console.log("forceSeekStreamMjpeg");
            player[0].currentTime(forceSeekOffset);
        } else {
            var recordData = _records[dataIndex];

            //console.log('command-14 force seek offset:'+forceSeekOffset);

            var reqUrl = window.zm.streamUrl + '?view=request&request=stream' +
                '&connkey=' + recordData.connkey +
                '&token=' + window.zm.access_token +
                '&command=14' +
                '&offset=' + forceSeekOffset;
            jQuery.ajax({
                url: reqUrl,
                type: "GET",
                async: true,
                dataType: 'json',
                success: function (data) {
                    if (data.result && data.result.toLowerCase() == 'ok') {
                        if (data.status) {
                            updateMonitorStatus(dataIndex, data.status);
                        }
                    } else {
                        //console.log('event stream_mjpeg seek failed');
                    }
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    //console.log('event stream_mjpeg seek error textStatus:' + textStatus);
                },
                complete: function () {
                    if (continueStartGetStatus) {
                        //开始监视器的状态轮询请求
                        // startGetStatus();
                    }
                }
            });
        }
    }

    // seek'流静帧'（command=14）
    // /zm/index.php?view=request&request=stream&connkey=153831&token=f0a3a89dbc50b6bb5d709c231117f036&command=14&offset=7.406577516026112
    function doSeekStreamMjpeg(dataIndex, percent) {
        var recordData = _records[dataIndex];
        if (recordData.isStreamWaiting) return;

        //console.log('command-14 seek offset:'+recordData.Length*percent);

        recordData.isStreamWaiting = true;
        var reqUrl = window.zm.streamUrl + '?view=request&request=stream' +
            '&connkey=' + recordData.connkey +
            '&token=' + window.zm.access_token +
            '&command=14' +
            '&offset=' + recordData.Length * percent;
        jQuery.ajax({
            url: reqUrl,
            type: "GET",
            async: true,
            dataType: 'json',
            success: function (data) {
                if (data.result && data.result.toLowerCase() == 'ok') {
                    if (data.status) {
                        updateMonitorStatus(dataIndex, data.status);
                    }
                } else {
                    //console.log('event stream_mjpeg seek failed');
                }
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                //console.log('event stream_mjpeg seek error textStatus:' + textStatus);
            },
            complete: function () {
                recordData.isStreamWaiting = false;
            }
        });
    }

    // play'流静帧'（command=2）
    // /zm/index.php?view=request&request=stream&connkey=153831&token=f0a3a89dbc50b6bb5d709c231117f036&command=2
    function doPlayStreamMjpeg(dataIndex) {
        // if (player) {
        //     player[0].play();
        // } else {
        var recordData = [];
        for (var i = 0; i < _records.length; i++) {
            if (dataIndex == _records[i].Id) {
                recordData = _records[i];
                break;
            }
        }
        recordData = recordData.length == 0 ? streamRecordData : recordData;
        if (recordData.isStreamWaiting) return;

        //console.log('command-2 connkey:'+recordData.connkey);

        recordData.isStreamWaiting = true;
        var reqUrl = window.zm.streamUrl + '?view=request&request=stream' +
            '&connkey=' + recordData.connkey +
            '&token=' + window.zm.access_token +
            '&command=2';
        jQuery.ajax({
            url: reqUrl,
            type: "GET",
            async: true,
            dataType: 'json',
            success: function (data) {
                // if (data.result && data.result.toLowerCase() == 'ok') {
                //     if (data.status) {
                //         updateMonitorStatus(dataIndex, data.status);
                //     }
                // } else {
                //     //console.log('event stream_mjpeg play failed');
                // }
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                //console.log('event stream_mjpeg play error textStatus:' + textStatus);
            },
            complete: function () {
                recordData.isStreamWaiting = false;
            }
        });
        // }
    }

    // pause'流静帧'（command=1）
    // /zm/index.php?view=request&request=stream&connkey=153831&token=f0a3a89dbc50b6bb5d709c231117f036&command=1
    function doPauseStreamMjpeg(dataIndex, updateStatus) {
        // console.log('doPauseStreamMjpeg')
        // if (player) {
        //     // player[0].pause();
        // } else {

        var recordData = [];
        for (var i = 0; i < _records.length; i++) {
            if (dataIndex == _records[i].Id) {
                recordData = _records[i];
                break;
            }
        }
        recordData = recordData.length == 0 ? streamRecordData : recordData;
        if (recordData.isStreamWaiting) return;

        //console.log('doPauseStreamMjpeg dataIndex:'+dataIndex);
        recordData.isStreamWaiting = true;
        var reqUrl = window.zm.streamUrl + '?view=request&request=stream' +
            '&connkey=' + recordData.connkey +
            '&token=' + window.zm.access_token +
            '&command=1';
        jQuery.ajax({
            url: reqUrl,
            type: "GET",
            async: true,
            dataType: 'json',
            success: function (data) {
                if (data.result && data.result.toLowerCase() == 'ok') {
                    if (data.status && updateStatus) {
                        // updateMonitorStatus(dataIndex, data.status);
                    }
                } else {
                    //console.log('event stream_mjpeg pause failed');
                }
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                //console.log('event stream_mjpeg pause error textStatus:' + textStatus);
            },
            complete: function () {
                recordData.isStreamWaiting = false;
            }
        });
        // }
    }

    // 重绕'流静帧'（command=7）
    // /zm/index.php?view=request&request=stream&connkey=459594&auth=6c2911fa01f49dba708514acf180d816&command=7
    function doBackStreamMjpeg(dataIndex) {
        if (player) {
            player[0].currentTime(player[0].currentTime - _seekingFastTime);
        } else {
            var recordData = _records[dataIndex];
            if (recordData.isStreamWaiting) return;

            //console.log('command-2 connkey:'+recordData.connkey);

            recordData.isStreamWaiting = true;
            var reqUrl = window.zm.streamUrl + '?view=request&request=stream' +
                '&connkey=' + recordData.connkey +
                '&token=' + window.zm.access_token +
                '&command=7';
            jQuery.ajax({
                url: reqUrl,
                type: "GET",
                async: true,
                dataType: 'json',
                success: function (data) {
                    if (data.result && data.result.toLowerCase() == 'ok') {
                        if (data.status) {
                            updateMonitorStatus(dataIndex, data.status);
                        }
                    } else {
                        //console.log('event stream_mjpeg play failed');
                    }
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    //console.log('event stream_mjpeg play error textStatus:' + textStatus);
                },
                complete: function () {
                    recordData.isStreamWaiting = false;
                }
            });
        }
    }

    // 单步后退'流静帧'（command=6）
    // /zm/index.php?view=request&request=stream&connkey=459594&auth=6c2911fa01f49dba708514acf180d816&command=6
    function doLastStreamMjpeg(dataIndex) {
        if (player) {
            player[0].currentTime(Math.max(0, player[0].currentTime - _seekingTime));
        } else {
            var recordData = _records[dataIndex];
            if (recordData.isStreamWaiting) return;

            //console.log('command-2 connkey:'+recordData.connkey);

            recordData.isStreamWaiting = true;
            var reqUrl = window.zm.streamUrl + '?view=request&request=stream' +
                '&connkey=' + recordData.connkey +
                '&token=' + window.zm.access_token +
                '&command=6';
            jQuery.ajax({
                url: reqUrl,
                type: "GET",
                async: true,
                dataType: 'json',
                success: function (data) {
                    if (data.result && data.result.toLowerCase() == 'ok') {
                        if (data.status) {
                            updateMonitorStatus(dataIndex, data.status);
                        }
                    } else {
                        //console.log('event stream_mjpeg play failed');
                    }
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    //console.log('event stream_mjpeg play error textStatus:' + textStatus);
                },
                complete: function () {
                    recordData.isStreamWaiting = false;
                }
            });
        }
    }

    // 单步前进'流静帧'（command=5）
    // /zm/index.php?view=request&request=stream&connkey=459594&auth=6c2911fa01f49dba708514acf180d816&command=5
    function doNextStreamMjpeg(dataIndex) {
        if (player) {
            player[0].currentTime(player[0].currentTime + _seekingTime);
        } else {
            var recordData = _records[dataIndex];
            if (recordData.isStreamWaiting) return;

            //console.log('command-2 connkey:'+recordData.connkey);

            recordData.isStreamWaiting = true;
            var reqUrl = window.zm.streamUrl + '?view=request&request=stream' +
                '&connkey=' + recordData.connkey +
                '&token=' + window.zm.access_token +
                '&command=5';
            jQuery.ajax({
                url: reqUrl,
                type: "GET",
                async: true,
                dataType: 'json',
                success: function (data) {
                    if (data.result && data.result.toLowerCase() == 'ok') {
                        if (data.status) {
                            updateMonitorStatus(dataIndex, data.status);
                        }
                    } else {
                        //console.log('event stream_mjpeg play failed');
                    }
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    //console.log('event stream_mjpeg play error textStatus:' + textStatus);
                },
                complete: function () {
                    recordData.isStreamWaiting = false;
                }
            });
        }
    }

    // 快进'流静帧'（command=4）
    // /zm/index.php?view=request&request=stream&connkey=459594&auth=6c2911fa01f49dba708514acf180d816&command=4
    function doFastForwardStreamMjpeg(dataIndex) {
        if (player) {
            player[0].currentTime(player[0].currentTime + _seekingFastTime);
        } else {
            var recordData = _records[dataIndex];
            if (recordData.isStreamWaiting) return;

            //console.log('command-2 connkey:'+recordData.connkey);

            recordData.isStreamWaiting = true;
            var reqUrl = window.zm.streamUrl + '?view=request&request=stream' +
                '&connkey=' + recordData.connkey +
                '&token=' + window.zm.access_token +
                '&command=4';
            jQuery.ajax({
                url: reqUrl,
                type: "GET",
                async: true,
                dataType: 'json',
                success: function (data) {
                    if (data.result && data.result.toLowerCase() == 'ok') {
                        if (data.status) {
                            updateMonitorStatus(dataIndex, data.status);
                        }
                    } else {
                        //console.log('event stream_mjpeg play failed');
                    }
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    //console.log('event stream_mjpeg play error textStatus:' + textStatus);
                },
                complete: function () {
                    recordData.isStreamWaiting = false;
                }
            });
        }
    }

    // zoomout'流静帧'（command=9）缩小
    // /zm/index.php?view=request&request=stream&connkey=153831&token=f0a3a89dbc50b6bb5d709c231117&command=9
    function doZoomoutStreamMjpeg(dataIndex) {
        if (player) {
            if (player.getZoom() == 1) {
                return;
            } else {
                player.zoomrotate({
                    zoom: player.getZoom() - 0.5,
                    rotate: 0
                });
                updatePlayerZoomButton(player);
            }
        } else {
            var recordData = _records[dataIndex];
            if (recordData.isStreamWaiting) return;

            recordData.isStreamWaiting = true;
            var reqUrl = window.zm.streamUrl + '?view=request&request=stream' +
                '&connkey=' + recordData.connkey +
                '&token=' + window.zm.access_token +
                '&command=9';
            jQuery.ajax({
                url: reqUrl,
                type: "GET",
                async: true,
                dataType: 'json',
                success: function (data) {
                    if (data.result && data.result.toLowerCase() == 'ok') {
                        if (data.status) {
                            updateMonitorStatus(dataIndex, data.status);
                        }
                    } else {
                        //console.log('event stream_mjpeg zoomout failed');
                    }
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    //console.log('event stream_mjpeg zoomout error textStatus:' + textStatus);
                },
                complete: function () {
                    recordData.isStreamWaiting = false;
                }
            });
        }
    }

    // zoomin'流静帧'（command=8）放大
    // /zm/index.php?view=request&request=stream&connkey=153831&token=f0a3a89dbc50b6bb5d709c231117f036&command=8&x=182&y=149
    function doZoominStreamMjpeg(dataIndex, offsetX, offsetY) {
        if (player) {
            player.zoomrotate({
                zoom: player.getZoom() + 0.5,
                rotate: 0
            });
            updatePlayerZoomButton(player);
        } else {
            var recordData = _records[dataIndex];
            if (recordData.isStreamWaiting) return;

            recordData.isStreamWaiting = true;
            var reqUrl = window.zm.streamUrl + '?view=request&request=stream' +
                '&connkey=' + recordData.connkey +
                '&token=' + window.zm.access_token +
                '&command=8&x=' + offsetX + '&y=' + offsetY;
            jQuery.ajax({
                url: reqUrl,
                type: "GET",
                async: true,
                dataType: 'json',
                success: function (data) {
                    if (data.result && data.result.toLowerCase() == 'ok') {
                        if (data.status) {
                            updateMonitorStatus(dataIndex, data.status);
                        }
                    } else {
                        //console.log('event stream_mjpeg zoomin failed');
                    }
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    //console.log('event stream_mjpeg zoomin error textStatus:' + textStatus);
                },
                complete: function () {
                    recordData.isStreamWaiting = false;
                }
            });
        }
    }

    //停止播放'流静帧'
    function stopStreamMjpeg() {
        if (!codeFlg) {
            if (_records && _records[_recordId]) {
                doPauseStreamMjpeg(_recordId, false);
                //console.log('stopStreamMjpeg _recordId:'+_recordId+' connkey:'+_records[_recordId].connkey);
            }
        }
    }

    //停止所有监视器的状态轮询请求
    function stopGetStatus() {
        _forceStopStatusTimer = true;
        if (_startGetStatusTimer) {
            clearTimeout(_startGetStatusTimer);
        }

        if (_records && _records[_recordId]) {
            clearTimeout(_records[_recordId].lastGetStatusTimer);
            _records[_recordId].lastGetStatusTimer = null;

            //console.log('stopGetStatus _recordId:'+_recordId+' connkey:'+_records[_recordId].connkey);
        }
    }

    //开始所有监视器的状态轮询请求
    function startGetStatus() {
        _startGetStatusTimer = setTimeout(function () {
            _forceStopStatusTimer = false;

            doGetStatusMjpeg(_recordId);

        }, REFRESH_INTERVAL);
    }

    // get_status'流静帧'（command=99）
    // /zm/index.php?view=request&request=stream&connkey=153831&token=f0a3a89dbc50b6bb5d709c231117f036&command=99
    function doGetStatusMjpeg(dataIndex) {
        // var recordData = _records[dataIndex];
        var recordData = [];
        for (var i = 0; i < _records.length; i++) {
            if (dataIndex == _records[i].Id) {
                recordData = _records[i];
                break;
            }
        }


        //console.log('command-99 connkey:'+recordData.connkey);

        //记录请求发起事件
        recordData.lastGetStatusStartTime = new Date().getTime();
        var reqUrl = window.zm.streamUrl + '?view=request&request=stream' +
            '&connkey=' + recordData.connkey +
            '&token=' + window.zm.access_token +
            '&command=99';
        jQuery.ajax({
            url: reqUrl,
            type: "GET",
            async: true,
            timeout: 10000,
            dataType: 'json',
            success: function (data) {
                if (data.result && data.result.toLowerCase() == 'ok') {
                    if (data.status) {
                        // updateMonitorStatus(dataIndex, data.status);
                    }
                } else {
                    //console.log('event stream_mjpeg get_status failed');
                }
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                //console.log('event stream_mjpeg get_status error textStatus:' + textStatus);
            },
            complete: function () {
                // if (_forceStopStatusTimer) return;
                //
                // var endTime = new Date().getTime();
                // var timeout = endTime - recordData.lastGetStatusStartTime;
                // if (timeout > REFRESH_INTERVAL) {
                //     doGetStatusMjpeg(dataIndex);
                // } else {
                //     recordData.lastGetStatusTimer = setTimeout(function () {
                //         if (!_forceStopStatusTimer) {
                //             doGetStatusMjpeg(dataIndex);
                //         }
                //     }, REFRESH_INTERVAL - timeout);
                // }
            }
        });
    }

    //{ "type":3,"event":4,"duration":33.25,"progress":33.25,"rate":1,"zoom":1,"paused":1}
    function updateMonitorStatus(dataIndex, statusData) {
        //更新回放时长
        var recordData = _records[dataIndex];
        $("#progrss-bar-start-time").text(second2Time(statusData.progress));
        if (Number(statusData.duration) > 0) {
            $("#progrss-bar-end-time").text("-" + second2Time(statusData.duration - statusData.progress));
            recordData.Length = statusData.duration;

            var thumbWidth = (_monitorThumbWidth - 10) * statusData.progress / statusData.duration;
            $('#progress_thumb_' + dataIndex).css('width', thumbWidth);
        }


        //更新时间轴
        updateTimeline(dataIndex, statusData);


        //更新状态条
        var str = '';
        str += myUNAS._('模式：') + getModeStr(statusData.paused) + '　|　';
        str += myUNAS._('进度：') + getProgress(statusData.progress) + myUNAS._('秒') + '　|　';
        str += myUNAS._('缩放：') + statusData.zoom + 'X';
        $('#cp_status_record_' + dataIndex).html(str);


        //重置所有底部流操作按钮状态
        $('#zm_btn_media_back_record_' + dataIndex).removeClass('active, inactive');
        $('#zm_btn_media_last_record_' + dataIndex).removeClass('active, inactive');
        $('#zm_btn_media_pause_record_' + dataIndex).removeClass('active, inactive');
        $('#zm_btn_media_play_record_' + dataIndex).removeClass('active, inactive');
        $('#zm_btn_media_next_record_' + dataIndex).removeClass('active, inactive');
        $('#zm_btn_media_fastforward_record_' + dataIndex).removeClass('active, inactive');

        $('#zm_btn_media_zoomout_record_' + dataIndex).removeClass('active, inactive');
        //如果没有缩放
        if (Number(statusData.zoom) == 1) {
            $('#zm_btn_media_zoomout_record_' + dataIndex).addClass('inactive');
        }

        //如果处于暂停状态
        if (statusData.paused) {
            $('#zm_btn_media_pause_record_' + dataIndex).addClass('inactive');

            //回放暂停时可以单步前进单步后退，不可快进快退
            $('#zm_btn_media_last_record_' + dataIndex).removeClass('active, inactive');
            $('#zm_btn_media_next_record_' + dataIndex).removeClass('active, inactive');
            $('#zm_btn_media_back_record_' + dataIndex).addClass('inactive');
            $('#zm_btn_media_fastforward_record_' + dataIndex).addClass('inactive');
        } else {
            $('#zm_btn_media_play_record_' + dataIndex).addClass('inactive');

            //播放状态时可以快进快退，不可单步前进单步后退
            $('#zm_btn_media_back_record_' + dataIndex).removeClass('active, inactive');
            $('#zm_btn_media_fastforward_record_' + dataIndex).removeClass('active, inactive');
            $('#zm_btn_media_last_record_' + dataIndex).addClass('inactive');
            $('#zm_btn_media_next_record_' + dataIndex).addClass('inactive');
        }
    }

    function getProgress(progress) {
        var num = Number(progress);
        return parseInt(num * 100) / 100;
    }

    function getModeStr(paused) {
        var intPaused = parseInt(paused);
        var str = '';
        switch (intPaused) {
            case 1:
                str = myUNAS._('暂停');
                break;
            case 0:
                str = myUNAS._('回放');
                break;
        }
        return str;
    }

    //格式化日志时间的显示（YYYY-MM-DD HH:MM:SS）
    function formatDate(timestamp, widthHMS = false) {
        var date = new Date(timestamp);
        var arr = [];
        arr.push(date.getFullYear());
        arr.push(stuffZero((date.getMonth() + 1), 2));
        arr.push(stuffZero(date.getDate(), 2));
        var arr2 = [];
        arr2.push(stuffZero(date.getHours(), 2));
        arr2.push(stuffZero(date.getMinutes(), 2));
        arr2.push(stuffZero(date.getSeconds(), 2));

        if (widthHMS) {
            return arr.join('-') + ' ' + arr2.join(':');
        } else {
            return arr.join('-');
        }
    }

    //数字前置补零
    function stuffZero(num, length) {
        var str = '';
        num = String(num);
        length = length || 2;
        for (var i = num.length; i < length; i++) {
            str += '0';
        }
        return num < Math.pow(10, length) ? str + (num | 0) : num;
    };

    function showWaiting() {
        $('#loading_event').show();
    }

    function hideWaiting() {
        $('#loading_event').hide();
    }

    function evaluateLoadTimes() {
        // Only consider it a completed event if we load ALL monitors, then zero all and start again
        var start = 0;
        var end = 0;
        if (liveMode != 1 && currentSpeed == 0) return; // don't evaluate when we are not moving as we can do nothing really fast.
        for (var i = 0; i < monitorIndex.length; i++) {
            if (monitorName[i] > "") {
                if (monitorLoadEndTimems[i] == 0) return; // if we have a monitor with no time yet just wait
                if (start == 0 || start > monitorLoadStartTimems[i]) start = monitorLoadStartTimems[i];
                if (end == 0 || end < monitorLoadEndTimems[i]) end = monitorLoadEndTimems[i];
            }
        }
        if (start == 0 || end == 0) return; // we really should not get here
        for (var i = 0; i < numMonitors; i++) {
            var monId = monitorPtr[i];
            monitorLoadStartTimems[monId] = 0;
            monitorLoadEndTimems[monId] = 0;
        }

        freeTimeLastIntervals[imageLoadTimesEvaluated++] = 1 - ((end - start) / currentDisplayInterval);
        if (imageLoadTimesEvaluated < imageLoadTimesNeeded) return;
        var avgFrac = 0;
        for (var i = 0; i < imageLoadTimesEvaluated; i++) {
            avgFrac += freeTimeLastIntervals[i];
        }
        avgFrac = avgFrac / imageLoadTimesEvaluated;
        // The larger this is(positive) the faster we can go
        // if (avgFrac >= 0.9) currentDisplayInterval = (currentDisplayInterval * 0.50).toFixed(1); // we can go much faster
        // else if (avgFrac >= 0.8) currentDisplayInterval = (currentDisplayInterval * 0.55).toFixed(1);
        // else if (avgFrac >= 0.7) currentDisplayInterval = (currentDisplayInterval * 0.60).toFixed(1);
        // else if (avgFrac >= 0.6) currentDisplayInterval = (currentDisplayInterval * 0.65).toFixed(1);
        // else if (avgFrac >= 0.5) currentDisplayInterval = (currentDisplayInterval * 0.70).toFixed(1);
        // else if (avgFrac >= 0.4) currentDisplayInterval = (currentDisplayInterval * 0.80).toFixed(1);
        // else if (avgFrac >= 0.35) currentDisplayInterval = (currentDisplayInterval * 0.90).toFixed(1);
        // else if (avgFrac >= 0.3) currentDisplayInterval = (currentDisplayInterval * 1.00).toFixed(1);
        // else if (avgFrac >= 0.25) currentDisplayInterval = (currentDisplayInterval * 1.20).toFixed(1);
        // else if (avgFrac >= 0.2) currentDisplayInterval = (currentDisplayInterval * 1.50).toFixed(1);
        // else if (avgFrac >= 0.1) currentDisplayInterval = (currentDisplayInterval * 2.00).toFixed(1);
        // else currentDisplayInterval = (currentDisplayInterval * 2.50).toFixed(1);
        // // limit this from about 40fps to .1 fps
        // currentDisplayInterval = Math.min(Math.max(currentDisplayInterval, 40), 10000);

        imageLoadTimesEvaluated = 0;
        // console.log('setspeed1', speedIndex);

        setSpeed(speedIndex);
        $('#fps').text("Display refresh rate is " + (1000 / currentDisplayInterval).toFixed(1) + " per second, avgFrac=" + avgFrac.toFixed(3) + ".");
    } // end evaluateLoadTimes()

    function getFrame(monId, time, last_Frame, type = 0) {
        // console.log(monId)
        if (last_Frame) {
            if (
                (last_Frame.TimeStampSecs <= time) &&
                (last_Frame.EndTimeStampSecs >= time)
            ) {
                return last_Frame;
            }
        }

        var events_for_monitor = events_by_monitor_id[monId];
        // console.log(events_for_monitor);
        if (!events_for_monitor) {
            //console.log("No events for monitor " + monId);
            return;
        }

        // console.log(events)
        // console.log(events_for_monitor)

        var Frame = null;
        // console.log(events_for_monitor)
        for (var i = 0; i < events_for_monitor.length; i++) {
            //for ( var event_id_idx in events_for_monitor ) {
            var event_id = events_for_monitor[i];
            // Search for the event matching this time. Would be more efficient if we had events indexed by monitor
            // console.log(events, event_id);
            e = events[event_id];
            if (!e) {
                console.log("No event found for " + event_id);
                break;
            }

            if (type == 1) {
                // console.log(e, monId)
            }

            if (e.MonitorId != monId || e.StartTimeSecs > time || e.EndTimeSecs < time) {
                if (type == 1) {
                    // console.log("Event not for " + time);
                }
                continue;
            }

            // console.log(e);
            if (!e.FramesById) {
                console.log("No FramesById for event " + event_id);
                return;
            }
            var duration = e.EndTimeSecs - e.StartTimeSecs;

            // I think this is an estimate to jump near the desired frame.
            var frame = parseInt((time - e.StartTimeSecs) / (duration) * Object.keys(e.FramesById).length) + 1;
            //console.log("frame_id for " + time + " is " + frame);

            // Need to get frame by time, not some fun calc that assumes frames have the same length.
            // Frames are sorted in descreasing order (or not sorted).
            // This is likely not efficient.  Would be better to start at the last frame viewed, see if it is still relevant
            // Then move forward or backwards as appropriate

            // console.log(e.FramesById)
            for (var frame_id in e.FramesById) {
                if (0) {
                    if (frame == 0) {
                        console.log("Found frame for time " + time);
                        console.log(Frame);
                        Frame = e.FramesById[frame_id];
                        break;
                    }
                    frame--;
                    continue;
                }
                if (
                    e.FramesById[frame_id].TimeStampSecs == time ||
                    (
                        e.FramesById[frame_id].TimeStampSecs < time &&
                        (
                            (!e.FramesById[frame_id].NextTimeStampSecs) || // only if event.EndTime is null
                            (e.FramesById[frame_id].NextTimeStampSecs > time)
                        )
                    )
                ) {
                    Frame = e.FramesById[frame_id];
                    break;
                }
            } // end foreach frame in the event.
            if (!Frame) {
                // console.log("Didn't find frame for " + time);
                return null;
            }
        } // end foreach event
        return Frame;
    }

    // time is seconds since epoch
    function getImageSource(monId, time, type = 0) {
        // console.log('getImageSource', liveMode)
        if (liveMode == 1) {
            if (monitorImageObject[monId] == undefined) {
                return '';
            }
            var new_url = monitorImageObject[monId].src.replace(
                /rand=\d+/i,
                'rand=' + Math.floor(Math.random() * 1000000)
            );
            // if ( auth_hash ) {
            //   // update auth hash
            //   new_url = new_url.replace(/auth=[a-z0-9]+/i, 'auth='+auth_hash);
            // }
            return new_url;
        }
        var frame_id;

        // console.log('time', time);
        var Frame = getFrame(monId, time, '', type);
        if (Frame) {
            // Adjust for bulk frames
            if (Frame.NextFrameId) {
                var e = events[Frame.EventId];
                var NextFrame = e.FramesById[Frame.NextFrameId];
                if (!NextFrame) {
                    // console.log("No next frame for " + Frame.NextFrameId);
                } else if (NextFrame.Type == 'Bulk') {
                    // There is time between this frame and a bulk frame
                    var duration = Frame.NextTimeStampSecs - Frame.TimeStampSecs;
                    frame_id = parseInt(Frame.FrameId) + parseInt((NextFrame.FrameId - Frame.FrameId) * (time - Frame.TimeStampSecs) / duration);
                    //console.log("Have NextFrame: duration: " + duration + " frame_id = " + frame_id + " from " + NextFrame.FrameId + ' - ' + Frame.FrameId + " time: " + (time-Frame.TimeStampSecs)  );
                } else {
                    frame_id = Frame.FrameId;
                }
            } else {
                frame_id = Frame.FrameId;
                // console.log("No NextFrame");
            }
            Event = events[Frame.EventId];

            var storage = Storage[Event.StorageId];
            if (!storage) {
                // Storage[0] is guaranteed to exist as we make sure it is there in montagereview.js.php
                // console.log("No storage area for id " + Event.StorageId);
                storage = Storage[0];
            }
            // monitorServerId may be 0, which gives us the default Server entry
            // var server = storage.ServerId ? Servers[storage.ServerId] : Servers[monitorServerId[monId]];

            // var url = server.PathToIndex +
            // var url = '/zm/index.php' +
            //   '?view=image&eid=' + Frame.EventId + '&fid=' + frame_id +
            //   "&width=" + monitorCanvasObj[monId].width +
            //   "&height=" + monitorCanvasObj[monId].height;

            // console.log( monitorCanvasObj[monId])
            var url = '/zm/api/events/image' + '?eid=' + Frame.EventId + '&fid=' + frame_id + "&width=" + monitorCanvasObj[monId].width + "&height=" + monitorCanvasObj[monId].height + '&token=' + window.zm.access_token;
            if (type == 1) {
                // console.log('===', url);
            }
            return url;
        } // end found Frame
        return '';
        //return "no data";
    }

    function getFrameId(monId, time, type = 0) {
        var frame_id = 0;

        var Frame = getFrame(monId, time, '', type);
        if (Frame) {
            // Adjust for bulk frames
            if (Frame.NextFrameId) {
                var e = events[Frame.EventId];
                var NextFrame = e.FramesById[Frame.NextFrameId];
                if (!NextFrame) {
                    console.log("No next frame for " + Frame.NextFrameId);
                } else if (NextFrame.Type == 'Bulk') {
                    // There is time between this frame and a bulk frame
                    var duration = Frame.NextTimeStampSecs - Frame.TimeStampSecs;
                    frame_id = parseInt(Frame.FrameId) + parseInt((NextFrame.FrameId - Frame.FrameId) * (time - Frame.TimeStampSecs) / duration);
                    //console.log("Have NextFrame: duration: " + duration + " frame_id = " + frame_id + " from " + NextFrame.FrameId + ' - ' + Frame.FrameId + " time: " + (time-Frame.TimeStampSecs)  );
                } else {
                    frame_id = Frame.FrameId;
                }
            } else {
                frame_id = Frame.FrameId;
            }
        }
        return frame_id;
    }

    // callback when loading an image. Will load itself to the canvas, or draw no data
    function imagedone(obj, monId, success) {
        if (success) {
            var canvasCtx = monitorCanvasCtx[monId];
            var canvasObj = monitorCanvasObj[monId];
            // console.log(canvasObj)

            var width = $('.video-player-record').width();
            var height = $('.video-player-record').height();
            canvasObj.width = width;
            canvasObj.height = height;

            canvasCtx.drawImage(monitorImageObject[monId], 0, 0, canvasObj.width, canvasObj.height);
            var iconSize = (Math.max(canvasObj.width, canvasObj.height) * 0.10);
            canvasCtx.font = "600 " + iconSize.toString() + "px Arial";
            canvasCtx.fillStyle = "white";
            canvasCtx.globalCompositeOperation = "difference";
            // canvasCtx.fillText( "+", iconSize*0.2, iconSize*1.2 );
            // canvasCtx.fillText( "-", canvasObj.width - iconSize*1.2, iconSize*1.2 );
            canvasCtx.globalCompositeOperation = "source-over";
            monitorLoadEndTimems[monId] = new Date().getTime(); // elapsed time to load
            evaluateLoadTimes();
        }
        monitorLoading[monId] = false;
        if (!success) {
            // if we had a failrue queue up the no-data image
            //loadImage2Monitor(monId,"no data");  // leave the staged URL if there is one, just ignore it here.
            if (liveMode) {
                writeText(monId, "Camera Offline");
            } else {
                writeText(monId, "No Data");
            }
        } else {
            if (monitorLoadingStageURL[monId] == "") {
                //console.log("Not showing image for " + monId );
                // This means that there wasn't a loading image placeholder.
                // So we weren't actually loading an image... which seems weird.
                return;
            }
            //loadImage2Monitor(monId,monitorLoadingStageURL[monId] );
            //monitorLoadingStageURL[monId]="";
        }
        return;
    }

    function loadNoData(monId) {
        if (monId) {
            var canvasCtx = monitorCanvasCtx[monId];
            var canvasObj = monitorCanvasObj[monId];
            canvasCtx.fillStyle = "white";
            canvasCtx.fillRect(0, 0, canvasObj.width, canvasObj.height);
            var textSize = canvasObj.width * 0.15;
            var text = "No Data";
            canvasCtx.font = "600 " + textSize.toString() + "px Arial";
            canvasCtx.fillStyle = "black";
            var textWidth = canvasCtx.measureText(text).width;
            canvasCtx.fillText(text, canvasObj.width / 2 - textWidth / 2, canvasObj.height / 2);
        } else {
            console.log("No monId in loadNoData");
        }
    }

    function writeText(monId, text) {
        if (monId) {
            var canvasCtx = monitorCanvasCtx[monId];
            var canvasObj = monitorCanvasObj[monId];
            //canvasCtx.fillStyle="white";
            //canvasCtx.fillRect(0, 0, canvasObj.width, canvasObj.height);
            var textSize = canvasObj.width * 0.15;
            canvasCtx.font = "600 " + textSize.toString() + "px Arial";
            canvasCtx.fillStyle = "white";
            var textWidth = canvasCtx.measureText(text).width;
            canvasCtx.fillText(text, canvasObj.width / 2 - textWidth / 2, canvasObj.height / 2);
        } else {
            console.log("No monId in loadNoData");
        }
    }

    // Either draws the
    function loadImage2Monitor(monId, url) {
        // console.log(monitorLoading)
        if (monitorLoading[monId] && monitorImageObject[monId].src != url) {
            // never queue the same image twice (if it's loading it has to be defined, right?
            monitorLoadingStageURL[monId] = url; // we don't care if we are overriting, it means it didn't change fast enough
        } else {
            if (monitorImageObject[monId] == undefined) {
                return;
            }

            if (monitorImageObject[monId].src == url) return; // do nothing if it's the same
            if (url == 'no data') {
                writeText(monId, 'No Data');
            } else {
                //writeText(monId, 'Loading...');
                monitorLoading[monId] = true;
                monitorLoadStartTimems[monId] = new Date().getTime();
                monitorImageObject[monId].src = url; // starts a load but doesn't refresh yet, wait until ready
            }
        }
    }

    function timerFire() {
        // See if we need to reschedule
        if ((currentDisplayInterval != timerInterval) || (currentSpeed == 0)) {
            // zero just turn off interrupts
            clearInterval(timerObj);
            timerObj = null;
            // timerInterval = currentDisplayInterval;
            timerInterval = 1000;
            // console.log("Turn off interrupts timerInterfave" + timerInterval);
        }

        // console.log('currentSpeed:'+currentSpeed, 'liveMode:'+liveMode, 'timerObj:'+timerObj, (currentSpeed > 0 || liveMode != 0) && !timerObj);
        if ((currentSpeed > 0 || liveMode != 0) && !timerObj) {
            // console.log('setInterval timerObj')
            timerObj = setInterval(timerFire, timerInterval); // don't fire out of live mode if speed is zero
        }

        if (liveMode) {
            // console.log('liveMode', 'currentTimeSecs:' + currentTimeSecs);
            outputUpdate(currentTimeSecs); // In live mode we basically do nothing but redisplay
        } else if (currentTimeSecs + playSecsPerInterval >= maxTimeSecs) {
            // beyond the end just stop
            // console.log("notliveMode Current time " + currentTimeSecs + " + " + playSecsPerInterval + " >= " + maxTimeSecs + " so stopping");
            if (speedIndex) setSpeed(0);
            // console.log(3340, 'currentTimeSecs:'+currentTimeSecs);
            outputUpdate(currentTimeSecs);
        } else {
            var time = playSecsPerInterval + currentTimeSecs;
            // console.log('notliveMode playSecsPerInterval:' + playSecsPerInterval, 'currentTimeSecs:' + currentTimeSecs, 'time:' + time, 'formatTime:' + formatDate(time * 1000, true));
            outputUpdate(time);
            setTunner(time);
        }
    }

    function setTunner(time) {
        this.displayTime = time * 1000;
        aTimeline.setDisplayTime(this.displayTime);

        var timelineinfo = aTimeline.getTimeLineInfo();
        var start = timelineinfo.currentTime - timelineinfo.zoom * 60 * 60 * 1000;

        var onepxMS = timelineinfo.width / (timelineinfo.zoom * 60 * 60 * 1000);
        var moveX = (time * 1000 - start) * onepxMS;

        var formatTime1 = formatDateTime(time * 1000, 'y-m-d');
        var formatTime2 = formatDateTime(time * 1000, 'h:i:s');
        $('.tuner-date').html(formatTime1);
        $('.tuner-time').html(formatTime2);

        if (moveX < 30) {
            $('.tuner-ct').css({'visibility': 'hidden'});
        } else {
            $('.tuner-ct').css({'left': moveX, 'visibility': 'visible'});
        }

        playTime = time;
    }

    function setLiveMode(livemode = 1, resetBtn = false) {
        liveMode = livemode;

        if (livemode) {
            $('.LiveBtn').hide();
            $('.v-live-hint').show();

            $('.v-speed-text').addClass('disable');
            $('.v-speed-sub').addClass('disable');
            $('.v-speed-add').addClass('disable');
            $('.v-icon-backward').addClass('disable').show();
            $('.v-icon-forward').addClass('disable').show();
            $('.v-icon-next-10').addClass('disable');
            $('.v-icon-next-event').addClass('disable');

            $('.v-icon-prev-frame').addClass('disable').hide();
            $('.v-icon-next-frame').addClass('disable').hide();

            $('.td_record_name').removeClass('active');
            // $('#tr_record_0').find('.td_record_name').addClass('active');

            if (tunnerTimer) {
                clearInterval(tunnerTimer);
                tunnerTimer = null;
            }
            $('.tuner-ct').css({'visibility': 'hidden'});

            $('.v-icon-play').addClass('press');
            $('.v-icon-play').prop('title', '暂停')

        } else {
            $('.LiveBtn').show();
            $('.v-live-hint').hide();

            $('.v-speed-text').removeClass('disable');
            $('.v-speed-sub').removeClass('disable');
            $('.v-speed-add').removeClass('disable');
            $('.v-icon-backward').removeClass('disable');
            $('.v-icon-forward').removeClass('disable');
            $('.v-icon-next-10').removeClass('disable');
            $('.v-icon-next-event').removeClass('disable');

            $('.v-icon-prev-frame').removeClass('disable');
            $('.v-icon-next-frame').removeClass('disable');

            if (resetBtn) {
                $('.v-icon-play').addClass('press');
                $('.v-icon-play').prop('title', '暂停')

                $('.v-icon-prev-frame').hide();
                $('.v-icon-next-frame').hide();
                $('.v-icon-backward').show();
                $('.v-icon-forward').show();
            }
        }
    }

    // val is seconds?
    function drawSliderOnGraph(val) {
        var sliderWidth = 10;
        var sliderLineWidth = 1;
        var sliderHeight = cHeight;

        if (liveMode == 1) {
            val = Math.floor(Date.now() / 1000);
        }
        // Set some sizes

        var labelpx = Math.max(6, Math.min(20, parseInt(cHeight * timeLabelsFractOfRow / (numMonitors + 1))));
        var labbottom = parseInt(cHeight * 0.2 / (numMonitors + 1)).toString() + "px"; // This is positioning same as row labels below, but from bottom so 1-position
        var labfont = labelpx + "px"; // set this like below row labels

        if (numMonitors > 0) {
            // if we have no data to display don't do the slider itself
            var sliderX = parseInt((val - minTimeSecs) / rangeTimeSecs * cWidth - sliderWidth / 2); // position left side of slider
            if (sliderX < 0) sliderX = 0;
            if (sliderX + sliderWidth > cWidth) {
                sliderX = cWidth - sliderWidth - 1;
            }

            // If we have data already saved first restore it from LAST time

            if (typeof underSlider !== 'undefined') {
                ctx.putImageData(underSlider, underSliderX, 0, 0, 0, sliderWidth, sliderHeight);
                underSlider = undefined;
            }
            if (liveMode == 0) {
                // we get rid of the slider if we switch to live (since it may not be in the "right" place)
                // Now save where we are putting it THIS time
                underSlider = ctx.getImageData(sliderX, 0, sliderWidth, sliderHeight);
                // And add in the slider'
                ctx.lineWidth = sliderLineWidth;
                ctx.strokeStyle = 'black';
                // looks like strokes are on the outside (or could be) so shrink it by the line width so we replace all the pixels
                ctx.strokeRect(sliderX + sliderLineWidth, sliderLineWidth, sliderWidth - 2 * sliderLineWidth, sliderHeight - 2 * sliderLineWidth);
                underSliderX = sliderX;
            }
            var o = document.getElementById('scruboutput');
            if (liveMode == 1) {
                o.innerHTML = "Live Feed @ " + (1000 / currentDisplayInterval).toFixed(1) + " fps";
                o.style.color = "red";
            } else {
                o.innerHTML = secs2dbstr(val);
                o.style.color = "blue";
            }
            o.style.position = "absolute";
            o.style.bottom = labbottom;
            o.style.font = labfont;
            // try to get length and then when we get too close to the right switch to the left
            var len = o.offsetWidth;
            var x;
            if (sliderX > cWidth / 2) {
                x = sliderX - len - 10;
            } else {
                x = sliderX + 10;
            }
            o.style.left = x.toString() + "px";
        }

        // This displays (or not) the left/right limits depending on how close the slider is.
        // Because these change widths if the slider is too close, use the slider width as an estimate for the left/right label length (i.e. don't recalculate len from above)
        // If this starts to collide increase some of the extra space

        var o = document.getElementById('scrubleft');
        o.innerHTML = secs2dbstr(minTimeSecs);
        o.style.position = "absolute";
        o.style.bottom = labbottom;
        o.style.font = labfont;
        o.style.left = "5px";
        if (numMonitors == 0) { // we need a len calculation if we skipped the slider
            len = o.offsetWidth;
        }
        // If the slider will overlay part of this suppress (this is the left side)
        if (len + 10 > sliderX || cWidth < len * 4) {
            // that last check is for very narrow browsers
            o.style.display = "none";
        } else {
            o.style.display = "inline";
            o.style.display = "inline-flex"; // safari won't take this but will just ignore
        }

        var o = document.getElementById('scrubright');
        o.innerHTML = secs2dbstr(maxTimeSecs);
        o.style.position = "absolute";
        o.style.bottom = labbottom;
        o.style.font = labfont;
        // If the slider will overlay part of this suppress (this is the right side)
        o.style.left = (cWidth - len - 15).toString() + "px";
        if (sliderX > cWidth - len - 20 || cWidth < len * 4) {
            o.style.display = "none";
        } else {
            o.style.display = "inline";
            o.style.display = "inline-flex";
        }
    }

    function drawGraph() {
        var divWidth = document.getElementById('timelinediv').clientWidth;
        canvas.width = cWidth = divWidth; // Let it float and determine width (it should be sized a bit smaller percentage of window)
        cHeight = parseInt(window.innerHeight * 0.10);
        if (cHeight < numMonitors * 20) {
            cHeight = numMonitors * 20;
        }

        canvas.height = cHeight;

        if (events && (Object.keys(events).length == 0)) {
            ctx.globalAlpha = 1;
            ctx.font = "40px Georgia";
            ctx.fillStyle = "white";
            var t = "No data found in range - choose differently";
            var l = ctx.measureText(t).width;
            ctx.fillText(t, (cWidth - l) / 2, cHeight - 10);
            underSlider = undefined;
            return;
        }
        var rowHeight = parseInt(cHeight / (numMonitors + 1)); // Leave room for a scale of some sort

        // first fill in the bars for the events (not alarms)

        for (var event_id in events) {
            var Event = events[event_id];

            // round low end down
            var x1 = parseInt((Event.StartTimeSecs - minTimeSecs) / rangeTimeSecs * cWidth);
            var x2 = parseInt((Event.EndTimeSecs - minTimeSecs) / rangeTimeSecs * cWidth + 0.5); // round high end up to be sure consecutive ones connect
            ctx.fillStyle = monitorColour[Event.MonitorId];
            ctx.globalAlpha = 0.2; // light color for background
            ctx.clearRect(x1, monitorIndex[Event.MonitorId] * rowHeight, x2 - x1, rowHeight); // Erase any overlap so it doesn't look artificially darker
            ctx.fillRect(x1, monitorIndex[Event.MonitorId] * rowHeight, x2 - x1, rowHeight);

            for (var frame_id in Event.FramesById) {
                var Frame = Event.FramesById[frame_id];
                if (!Frame.Score) {
                    continue;
                }

                // Now put in scored frames (if any)
                var x1 = parseInt((Frame.TimeStampSecs - minTimeSecs) / rangeTimeSecs * cWidth); // round low end down
                var x2 = parseInt((Frame.TimeStampSecs - minTimeSecs) / rangeTimeSecs * cWidth + 0.5); // round up
                if (x2 - x1 < 2) x2 = x1 + 2; // So it is visible make them all at least this number of seconds wide
                ctx.fillStyle = monitorColour[Event.MonitorId];
                ctx.globalAlpha = 0.4 + 0.6 * (1 - Frame.Score / maxScore); // Background is scaled but even lowest is twice as dark as the background
                ctx.fillRect(x1, monitorIndex[Event.MonitorId] * rowHeight, x2 - x1, rowHeight);
            } // end foreach frame
        } // end foreach Event

        for (var i = 0; i < numMonitors; i++) {
            // Note that this may be a sparse array
            ctx.font = parseInt(rowHeight * timeLabelsFractOfRow).toString() + "px Georgia";
            ctx.fillStyle = "white";
            ctx.globalAlpha = 1;
            // This should roughly center font in row
            ctx.fillText(monitorName[monitorPtr[i]], 0, (i + 1 - (1 - timeLabelsFractOfRow) / 2) * rowHeight);
        }
        underSlider = undefined; // flag we don't have a slider cached
        // drawSliderOnGraph(currentTimeSecs);
        return;
    } // end function drawGraph

    function redrawScreen() {
        // console.log('redrawScreen')
        var dateTimeDiv = $('#DateTimeDiv');
        var speedDiv = $('#SpeedDiv');
        var timeLineDiv = $('#timelinediv');
        var liveButton = $('#liveButton');
        var zoomIn = $('#zoomin');
        var zoomOut = $('#zoomout');
        var panLeft = $('#panleft');
        var panRight = $('#panright');
        var downloadVideo = $('#downloadVideo');
        var scaleDiv = $('#ScaleDiv');
        var fit = $('#fit');

        if (liveMode == 1) {
            // if we are not in live view switch to history -- this has to come before fit in case we re-establish the timeline
            dateTimeDiv.hide();
            speedDiv.hide();
            timeLineDiv.hide();
            liveButton.text('History');
            zoomIn.hide();
            zoomOut.hide();
            panLeft.hide();
            panRight.hide();
            downloadVideo.hide();
        } else {
            // switch out of liveview mode
            dateTimeDiv.show();
            speedDiv.show();
            timeLineDiv.show();
            liveButton.text('Live');
            zoomIn.show();
            zoomOut.show();
            panLeft.show();
            panRight.show();
            downloadVideo.show();

            // drawGraph();
        }

        var monitors = $('.video-player-record');
        // console.log('fitMode:'+fitMode)
        fitMode = 0;
        if (fitMode == 1) {
            scaleDiv.hide();
            fit.text('Scale');
            // monitors.height(mh.toString() + 'px'); // leave a small gap at bottom
            if (maxfit2(monitors.outerWidth(), monitors.outerHeight()) == 0) { /// if we fail to fix we back out of fit mode -- ??? This may need some better handling
                // console.log("Failed to fit, dropping back to scaled mode");
                fitMode = 1 - fitMode;
            }
        } else {
            // switch out of fit mode
            // if we fit, then monitors were absolutely positioned already (or will be) otherwise release them to float
            // console.log('numMonitors:'+numMonitors, 'monitorPtr:'+monitorPtr)
            for (var i = 0; i < numMonitors; i++) {
                if (monitorCanvasObj[monitorPtr[i]] == undefined) {
                    continue;
                }
                monitorCanvasObj[monitorPtr[i]].style.position = "";
            }
            // console.log(monitorCanvasObj)
            // monitors.height('auto');
            scaleDiv.show();
            fit.text('fit');
            setScale(currentScale);
        }

        // console.log('redrawScreen 3577 liveMode:' + liveMode)
        // if (liveMode == 1 && !codeFlg) {
        //     outputUpdate(currentTimeSecs);
        //     timerFire(); // force a fire in case it's not timing
        // }
    }

    function outputUpdate(time, type = 0) {
        // drawSliderOnGraph(time);
        for (var i = 0; i < numMonitors; i++) {
            var src = getImageSource(monitorPtr[i], time, type);
            if (type == 1) {
                // console.log("New image src: " + src);
            }
            loadImage2Monitor(monitorPtr[i], src);
        }
        currentTimeSecs = time;
    }

    /// Found this here: http://stackoverflow.com/questions/55677/how-do-i-get-the-coordinates-of-a-mouse-click-on-a-canvas-element
    function relMouseCoords(event) {
        var totalOffsetX = 0;
        var totalOffsetY = 0;
        var canvasX = 0;
        var canvasY = 0;
        var currentElement = this;

        do {
            totalOffsetX += currentElement.offsetLeft - currentElement.scrollLeft;
            totalOffsetY += currentElement.offsetTop - currentElement.scrollTop;
        } while (currentElement = currentElement.offsetParent);

        canvasX = event.pageX - totalOffsetX;
        canvasY = event.pageY - totalOffsetY;

        return {x: canvasX, y: canvasY};
    }

    HTMLCanvasElement.prototype.relMouseCoords = relMouseCoords;

    function secs2inputstr(s) {
        if (!parseInt(s)) {
            console.log("Invalid value for " + s + " seconds");
            return '';
        }

        var m = moment(s * 1000);
        if (!m) {
            console.log("No valid date for " + s + " seconds");
            return '';
        }
        return m.format("YYYY-MM-DDTHH:mm:ss");
    }

    function secs2dbstr(s) {
        if (!parseInt(s)) {
            console.log("Invalid value for " + s + " seconds");
            return '';
        }
        var m = moment(s * 1000);
        if (!m) {
            console.log("No valid date for " + s + " milliseconds");
            return '';
        }
        return m.format("YYYY-MM-DD HH:mm:ss");
    }

    function setFit(value) {
        fitMode = value;
        redrawScreen();
    }

    function showScale(newscale) {
        // updates slider only
        $('#scaleslideroutput').text(parseFloat(newscale).toFixed(2).toString() + " x");
        return;
    }

    function setScale(newscale) {
        // console.log('setScale')
        // makes actual change
        showScale(newscale);
        for (var i = 0; i < numMonitors; i++) {
            if (monitorCanvasObj[monitorPtr[i]] == undefined) {
                continue;
            }
            monitorCanvasObj[monitorPtr[i]].width = monitorWidth[monitorPtr[i]] * monitorNormalizeScale[monitorPtr[i]] * monitorZoomScale[monitorPtr[i]] * newscale;
            monitorCanvasObj[monitorPtr[i]].height = monitorHeight[monitorPtr[i]] * monitorNormalizeScale[monitorPtr[i]] * monitorZoomScale[monitorPtr[i]] * newscale;
        }
        // console.log(monitorCanvasObj)
        currentScale = newscale;
    }

    function showSpeed(val) {
        // updates slider only
        // $('#speedslideroutput').text(parseFloat(speeds[val]).toFixed(2).toString() + " x");
        $('.v-speed-text').html(val);
    }

    function setSpeed(speed_index, type = '') {
        // console.log(liveMode, speeds[speed_index])
        if (liveMode == 1) {
            // console.log("setSpeed in liveMode?");
            return; // we shouldn't actually get here but just in case
        }
        if (speeds[speed_index] == undefined) {
            return false;
        }

        speedIndex = speed_index;
        currentSpeed = speeds[speedIndex]['speed'];

        showSpeed(speeds[speedIndex]['label']);

        // console.log('setSpeed playerPaused:'+playerPaused)
        if (codeFlg) {
            if (player) {
                if (!playerPaused) {
                    if (aTimeline) {
                        stopMove(aTimeline);
                        beginMove(aTimeline, currentSpeed)
                    }

                    if (tunnerTimer) {
                        clearInterval(tunnerTimer);
                        tunnerTimer = null;
                    }

                    // setTunner(playTime + 1);
                    tunnerTimer = setInterval(function () {
                        setTunner(playTime + 1);
                    }, tunnerTimerInterval / currentSpeed)

                    if (playerIntervalTimer) {
                        clearInterval(playerIntervalTimer);
                    }
                    // var currentPlayTime = player[0].currentTime == 0 ? 0 : player[0].currentTime;
                    var currentPlayTime = player.currentTime() == 0 ? 0 : player.currentTime();
                    // player[0].currentTime = currentPlayTime
                    player.currentTime(currentPlayTime);
                    if (type == 'play') {
                        // player[0].play();
                        // console.log('player.paused:' + player.paused())
                        player.play();
                    }
                    // player.prop('playbackRate', currentSpeed);
                    player.playbackRate(currentSpeed);
                }
            }
        } else {
            playSecsPerInterval = Math.floor(1000 * currentSpeed * currentDisplayInterval) / 1000000;
            timerFire();
        }

    }

    function setReverseSpeed(speed_index) {
        if (liveMode == 1) {
            // console.log("setSpeed in liveMode?");
            return; // we shouldn't actually get here but just in case
        }

        if (reverseSpeeds[speed_index] == undefined) {
            return false;
        }

        speedIndex = speed_index;
        currentSpeed = reverseSpeeds[speedIndex]['speed'];

        showSpeed(reverseSpeeds[speedIndex]['label']);

        // console.log('setSpeed playerPaused:'+playerPaused)
        if (codeFlg) {
            if (player) {
                if (!playerPaused) {
                    // player[0].pause();
                    player.pause();

                    if (aTimeline) {
                        stopMove(aTimeline);
                        beginMove(aTimeline, currentSpeed, true)
                    }

                    if (tunnerTimer) {
                        clearInterval(tunnerTimer);
                        tunnerTimer = null;
                    }
                    tunnerTimer = setInterval(function () {
                        setTunner(playTime - 1);
                    }, tunnerTimerInterval / currentSpeed)


                    if (playerIntervalTimer) {
                        clearInterval(playerIntervalTimer);
                        playerIntervalTimer = null;
                    }
                    // var currentPlayTime = player[0].currentTime == 0 && isPlayReverse ? videoDuration : player[0].currentTime;
                    var currentPlayTime = player.currentTime() == 0 && isPlayReverse ? videoDuration : player.currentTime();
                    playerIntervalTimer = setInterval(function () {
                        currentPlayTime = parseInt(currentPlayTime - 1);
                        //逆向播放通过播放时间为0判断播放完毕 跳到上一个事件
                        // console.log('currentPlayTime:'+currentPlayTime)
                        if (currentPlayTime == 0) {
                            clearInterval(playerIntervalTimer);
                            playerIntervalTimer = null;

                            if (player) {
                                player.dispose();
                                player = null;
                            }
                            var id = 0;
                            for (var i = 0; i < _records.length; i++) {
                                if (_recordId == _records[i].Id && _records[i + 1]) {
                                    id = _records[i + 1].Id
                                    break;
                                }
                            }

                            if (aTimeline) {
                                var timelineinfo = aTimeline.getTimeLineInfo();
                                timeLineCurrentTime = timelineinfo.currentTime
                            }

                            attachMonitorRecord(id, 'auto', 'playEnd');
                        } else {
                            if (player) {
                                // player[0].currentTime = currentPlayTime;
                                player.currentTime(currentPlayTime);
                            }
                        }
                    }, 1000 / currentSpeed)
                }
            }
        } else {
            currentSpeed = -currentSpeed;
            playSecsPerInterval = Math.floor(1000 * currentSpeed * currentDisplayInterval) / 1000000;
            timerFire();
        }
    }

    function clicknav(minSecs, maxSecs, live) {// we use the current time if we can
        var date = new Date();
        var now = Math.floor(date.getTime() / 1000);
        var tz_difference = (-1 * date.getTimezoneOffset() * 60) - server_utc_offset;
        now -= tz_difference;

        var minStr = "";
        var maxStr = "";
        var currentStr = "";
        if (minSecs > 0) {
            if (maxSecs > now) {
                maxSecs = parseInt(now);
            }
            maxStr = "&maxTime=" + secs2inputstr(maxSecs);
            $('#maxTime').val(secs2inputstr(maxSecs));
        }
        if (minSecs > 0) {
            $('#minTime').val(secs2inputstr(minSecs));
            minStr = "&minTime=" + secs2inputstr(minSecs);
        }
        if (maxSecs == 0 && minSecs == 0) {
            minStr = "&minTime=01/01/1950T12:00:00";
            maxStr = "&maxTime=12/31/2035T12:00:00";
        }
        var intervalStr = "&displayinterval=" + currentDisplayInterval.toString();
        if (minSecs && maxSecs) {
            if (currentTimeSecs > minSecs && currentTimeSecs < maxSecs) { // make sure time is in the new range
                currentStr = "&current=" + secs2dbstr(currentTimeSecs);
            }
        }

        var liveStr = "&live=0";
        if (live == 1) {
            liveStr = "&live=1";
        }

        var zoomStr = "";
        for (var i = 0; i < numMonitors; i++) {
            if (monitorZoomScale[monitorPtr[i]] < 0.99 || monitorZoomScale[monitorPtr[i]] > 1.01) { // allow for some up/down changes and just treat as 1 of almost 1
                zoomStr += "&z" + monitorPtr[i].toString() + "=" + monitorZoomScale[monitorPtr[i]].toFixed(2);
            }
        }

        var uri = "?view=" + currentView + '&fit=' + (fitMode == 1 ? '1' : '0') + minStr + maxStr + currentStr + intervalStr + liveStr + zoomStr + "&scale=" + $("#scaleslider")[0].value + "&speed=" + speeds[$("#speedslider")[0].value];
        window.location = uri;
    } // end function clicknav

    function click_lastHour() {
        var date = new Date();
        var now = Math.floor(date.getTime() / 1000);
        now -= -1 * date.getTimezoneOffset() * 60;
        now += server_utc_offset;
        clicknav(now - 3599, now, 0);
    }

    function click_lastEight() {
        var date = new Date();
        var now = Math.floor(date.getTime() / 1000);
        now -= -1 * date.getTimezoneOffset() * 60 - server_utc_offset;
        clicknav(now - 3600 * 8 + 1, now, 0);
    }

    function click_zoomin() {
        rangeTimeSecs = parseInt(rangeTimeSecs / 2);
        minTimeSecs = parseInt(currentTimeSecs - rangeTimeSecs / 2); // this is the slider current time, we center on that
        maxTimeSecs = parseInt(currentTimeSecs + rangeTimeSecs / 2);
        clicknav(minTimeSecs, maxTimeSecs, 0);
    }

    function click_zoomout() {
        rangeTimeSecs = parseInt(rangeTimeSecs * 2);
        minTimeSecs = parseInt(currentTimeSecs - rangeTimeSecs / 2); // this is the slider current time, we center on that
        maxTimeSecs = parseInt(currentTimeSecs + rangeTimeSecs / 2);
        clicknav(minTimeSecs, maxTimeSecs, 0);
    }

    function click_panleft() {
        minTimeSecs = parseInt(minTimeSecs - rangeTimeSecs / 2);
        maxTimeSecs = minTimeSecs + rangeTimeSecs - 1;
        clicknav(minTimeSecs, maxTimeSecs, 0);
    }

    function click_panright() {
        minTimeSecs = parseInt(minTimeSecs + rangeTimeSecs / 2);
        maxTimeSecs = minTimeSecs + rangeTimeSecs - 1;
        clicknav(minTimeSecs, maxTimeSecs, 0);
    }

    // Manage the DOWNLOAD VIDEO button
    function click_download() {
        $.getJSON(thisUrl + '?request=modal&modal=download')
            .done(function (data) {
                insertModalHtml('downloadModal', data.html);
                $('#downloadModal').modal('show');
                // Manage the GENERATE DOWNLOAD button
                $('#exportButton').click(exportEvent);
            })
            .fail(logAjaxFail);
    }

    function click_all_events() {
        clicknav(0, 0, 0);
    }

    function allnon() {
        clicknav(0, 0, 0);
    }

    /// >>>>>>>>>>>>>>>>> handles packing different size/aspect monitors on screen    <<<<<<<<<<<<<<<<<<<<<<<<

    function compSize(a, b) { // sort array by some size parameter  - height seems to work best.  A semi-greedy algorithm
        var a_value = monitorHeight[a] * monitorWidth[a] * monitorNormalizeScale[a] * monitorZoomScale[a] * monitorNormalizeScale[a] * monitorZoomScale[a];
        var b_value = monitorHeight[b] * monitorWidth[b] * monitorNormalizeScale[b] * monitorZoomScale[b] * monitorNormalizeScale[b] * monitorZoomScale[b];

        if (a_value > b_value) return -1;
        else if (a_value == b_value) return 0;
        else return 1;
    }

    function maxfit2(divW, divH) {
        var bestFitX = []; // how we arranged the so-far best match
        var bestFitX2 = [];
        var bestFitY = [];
        var bestFitY2 = [];

        var minScale = 0.05;
        var maxScale = 5.00;
        var bestFitArea = 0;
        var borders_width = -1;
        var borders_height = -1;

        //monitorPtr.sort(compSize); //Sorts monitors by size in viewport.  If enabled makes captions not line up with graphs.

        while (1) {
            if (maxScale - minScale < 0.01) break;
            var thisScale = (maxScale + minScale) / 2;
            var allFit = 1;
            var thisArea = 0;
            var thisX = []; // top left
            var thisY = [];
            var thisX2 = []; // bottom right
            var thisY2 = [];

            for (var m = 0; m < numMonitors; m++) {
                // this loop places each monitor (if it can)
                var monId = monitorPtr[m];

                function doesItFit(x, y, w, h, d) { // does block (w,h) fit at position (x,y) relative to edge and other nodes already done (0..d)
                    if (x + w >= divW) return 0;
                    if (y + h >= divH) return 0;
                    for (var i = 0; i <= d; i++) {
                        if (!(thisX[i] > x + w - 1 || thisX2[i] < x || thisY[i] > y + h - 1 || thisY2[i] < y)) return 0;
                    }
                    return 1; // it's OK
                }

                var monitor_div = $('#Monitor' + monId);
                if (borders_width <= 0) {
                    borders_width = parseInt(monitor_div.css('border-left-width')) + parseInt(monitor_div.css('border-right-width'));
                }
                if (borders_height <= 0) {
                    borders_height = parseInt(monitor_div.css('border-top-width')) + parseInt(monitor_div.css('border-bottom-width'));
                } // assume fixed size border, and added to both sides and top/bottom
                // try fitting over first, then down.  Each new one must land at either upper right or lower left corner of last (try in that order)
                // Pick the one with the smallest Y, then smallest X if Y equal
                var fitX = 999999999;
                var fitY = 999999999;
                for (adjacent = 0; adjacent < m; adjacent++) {
                    // try top right of adjacent
                    if (doesItFit(
                        thisX2[adjacent] + 1,
                        thisY[adjacent],
                        monitorWidth[monId] * thisScale * monitorNormalizeScale[monId] * monitorZoomScale[monId] + borders_width,
                        monitorHeight[monId] * thisScale * monitorNormalizeScale[monId] * monitorZoomScale[monId] + borders_height,
                        m - 1) == 1) {
                        if (thisY[adjacent] < fitY || (thisY[adjacent] == fitY && thisX2[adjacent] + 1 < fitX)) {
                            fitX = thisX2[adjacent] + 1;
                            fitY = thisY[adjacent];
                        }
                    }
                    // try bottom left
                    if (doesItFit(
                        thisX[adjacent],
                        thisY2[adjacent] + 1,
                        monitorWidth[monId] * thisScale * monitorNormalizeScale[monId] * monitorZoomScale[monId] + borders_width,
                        monitorHeight[monId] * thisScale * monitorNormalizeScale[monId] * monitorZoomScale[monId] + borders_height,
                        m - 1) == 1) {
                        if (thisY2[adjacent] + 1 < fitY || (thisY2[adjacent] + 1 == fitY && thisX[adjacent] < fitX)) {
                            fitX = thisX[adjacent];
                            fitY = thisY2[adjacent] + 1;
                        }
                    }
                } // end for adjacent < m
                if (m == 0) { // note for the very first one there were no adjacents so the above loop didn't run
                    if (doesItFit(
                        0, 0,
                        monitorWidth[monId] * thisScale * monitorNormalizeScale[monId] * monitorZoomScale[monId] + borders_width,
                        monitorHeight[monId] * thisScale * monitorNormalizeScale[monId] * monitorZoomScale[monId] + borders_height,
                        -1) == 1) {
                        fitX = 0;
                        fitY = 0;
                    }
                }
                if (fitX == 999999999) {
                    allFit = 0;
                    break; // break out of monitor loop flagging we didn't fit
                }
                thisX[m] = fitX;
                thisX2[m] = fitX + monitorWidth[monitorPtr[m]] * thisScale * monitorNormalizeScale[monitorPtr[m]] * monitorZoomScale[monitorPtr[m]] + borders_width;
                thisY[m] = fitY;
                thisY2[m] = fitY + monitorHeight[monitorPtr[m]] * thisScale * monitorNormalizeScale[monitorPtr[m]] * monitorZoomScale[monitorPtr[m]] + borders_height;
                thisArea += (thisX2[m] - thisX[m]) * (thisY2[m] - thisY[m]);
            } // end foreach monitor
            if (allFit == 1) {
                minScale = thisScale;
                if (bestFitArea < thisArea) {
                    bestFitArea = thisArea;
                    bestFitX = thisX;
                    bestFitY = thisY;
                    bestFitX2 = thisX2;
                    bestFitY2 = thisY2;
                    bestFitScale = thisScale;
                }
            } else {
                // didn't fit
                maxScale = thisScale;
            }
        }
        if (bestFitArea > 0) { // only rearrange if we could fit -- otherwise just do nothing, let them start coming out, whatever
            for (m = 0; m < numMonitors; m++) {
                c = document.getElementById('Monitor' + monitorPtr[m]);
                c.style.position = 'absolute';
                c.style.left = bestFitX[m].toString() + "px";
                c.style.top = bestFitY[m].toString() + "px";
                c.width = bestFitX2[m] - bestFitX[m] + 1 - borders_width;
                c.height = bestFitY2[m] - bestFitY[m] + 1 - borders_height;
            }
            return 1;
        } else {
            return 0;
        }
    }

    // >>>>>>>>>>>>>>>> Handles individual monitor clicks and navigation to the standard event/watch display

    function showOneMonitor(monId, event) {
        // link out to the normal view of one event's data
        // We know the monitor, need to determine the event based on current time
        let url = '';
        if (liveMode != 0) {
            url = '?view=watch&mid=' + monId.toString();
        } else {
            const Frame = getFrame(monId, currentTimeSecs);
            if (Frame) {
                url = '?view=event&eid=' + Frame.EventId + '&fid=' + Frame.FrameId;
            } else {
                url = '?view=watch&mid=' + monId.toString();
            }
        } // end if live/events

        if (event.ctrlKey) {
            window.open(url, '_blank');
        } else {
            window.location.assign(url);
        }
    }

    function zoom(monId, scale) {
        var lastZoomMonPriorScale = monitorZoomScale[monId];
        monitorZoomScale[monId] *= scale;
        if (redrawScreen() == 0) {// failure here is probably because we zoomed too far
            monitorZoomScale[monId] = lastZoomMonPriorScale;
            alert("You can't zoom that far -- rolling back");
            redrawScreen(); // put things back and hope it works
        }
    }

    function clickMonitor(event) {
        var element = event.target;
        //var monitor_element = document.getElementById('Monitor'+monId.toString());
        var monId = element.getAttribute('monitor_id');
        var pos_x = event.offsetX ? (event.offsetX) : event.pageX - element.offsetLeft;
        var pos_y = event.offsetY ? (event.offsetY) : event.pageY - element.offsetTop;
        if (pos_x < element.width / 4 && pos_y < element.height / 4) {
            zoom(monId, 1.15);
        } else if (pos_x > element.width * 3 / 4 && pos_y < element.height / 4) {
            zoom(monId, 1 / 1.15);
        } else {
            showOneMonitor(monId, event);
        }
        return;
    }

    function addUniqueRecordConnkey(arr) {
        for (var i = 0, len = arr.length; i < len; ++i) {
            arr[i].connkey = parseInt(Math.random() * 1000000);
            arr[i].scale = 60; //默认60%的显示质量
        }
    }

    function generateTestEvents(num) {
        var arr = [];
        var obj;
        for (var i = 1; i <= num; ++i) {
            obj = {};
            obj.AlarmFrames = "0"; //报警帧
            obj.Archived = "0";
            obj.AvgScore = "0"; //平均分数
            obj.Cause = "Continuous"; //原因
            obj.DefaultVideo = "3-video.mp4";
            obj.DiskSpace = "178206263";
            obj.Emailed = "0";
            obj.EndTime = "2021-07-20 14:14:05"; //结束时间
            obj.Executed = "0";
            obj.FileSystemPath = "/var/cache/zoneminder/events/1/2021-07-20/3";
            obj.Frames = "815"; //帧
            obj.Height = "1080";
            obj.Id = "3"; //事件ID
            obj.Length = "34.82"; //持续时长
            obj.Locked = false;
            obj.MaxScore = "0"; //最大分数
            obj.MaxScoreFrameId = "130";
            obj.Messaged = "0";
            obj.MonitorId = "1"; //监视器ID
            obj.Name = "Event- 3"; //名称
            obj.Notes = "";
            obj.Orientation = "ROTATE_0";
            obj.SaveJPEGs = "3"; //保存为JPEGs
            obj.Scheme = "Medium";
            obj.SecondaryStorageId = "0";
            obj.StartTime = "2021-07-20 14:13:31"; //开始时间
            obj.StateId = "1";
            obj.StorageId = "0";
            obj.TotScore = "0"; //总分数
            obj.Uploaded = "0";
            obj.Videoed = "1"; //保存为视频
            obj.Width = "1920";

            //以下是前端维护的属性
            obj.connkey = ''; //a random number which uniquely identifies a stream generated by ZM
            //can use connkey to “control” the stream (pause/resume etc.)
            obj.scale = 60; //监视器显示质量
            obj.isStreamWaiting = false; //是否正在进行视频流操作
            obj.lastGetStatusStartTime = 0; //上一次发出getStatus请求时的时间戳（单位：毫秒）
            obj.lastGetStatusTimer = null; //上一次发出getStatus请求的timer（用于后续调用clearTimeout）

            arr.push(obj);
        }

        return arr;
    }

    window.zm = window.zm || {};
    window.zm.init = window.zm.init || [];
    window.zm.init['event'] = init;
    window.zm.destroy = window.zm.destroy || [];
    window.zm.destroy['event'] = destroy;
    window.zm.update = window.zm.update || [];
    window.zm.update['event'] = update;

    // window.addEventListener("resize", updateMonitor, {passive: true});

    var resizeTimer;
    window.addEventListener('resize', function () {
        resizeDiv();
    });

    function resizeDiv() {
        clearTimeout(resizeTimer);
        resizeTimer = setTimeout(function () {
            if (aTimeline) {
                var timelineinfo = aTimeline.getTimeLineInfo();
                timeLineCurrentTime = timelineinfo.currentTime
            }
            updateMonitor('resize');
            if (aTimeline) {
                setTimeParts(aTimeline, timeParts);
            }
        }, 250);
    }

})();

// 批量删除记录
function batchDeleteRecord() {
    var checkedList = [];
    $('.jvc-checkbox').each(function (i, e) {
        if (e.checked) {
            let index = $(e).data('ref');
            // $('#tr_record_' + index).remove();
            checkedList.push($(e).val());
        }

    })

    if (!checkedList.length) {
        return;
    }

    showConfirmDelete(function () {
        let data = {
            ids: checkedList
        }
        jQuery('#loading_event').show();
        jQuery.ajax({
            url: "/zm/api/events/deleteAll.json?token=" + window.zm.access_token,
            type: "post",
            async: true,
            data: JSON.stringify(data),
            contentType: 'application/json',
            success: function (data) {
                // console.log(data);
                // promptShow({
                //   text: "删除成功", //提示文字
                //   width: "390px", //提示框宽度
                //   height: "246px", //提示框高度
                //   icon: "images/icon_delete02.png", //提示图标
                //   iconWidth: "80px", //提示图标的大小
                //   textLineHeight: "360px" //提示文字的行高
                // });
                Message.success(myUNAS._('Delete Success'));
                jQuery('#loading_event').hide();

                window.zm.update['event']();

                $("input[name='selectAll']").prop('checked', false);
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                // promptShow('删除失败');
                Message.error(myUNAS._('Delete Failed'));
                hideWaiting();
            }
        });

    })
}

function batchDownLoad() {
    var checkedList = [];
    $('.jvc-checkbox').each(function (i, e) {
        if (e.checked) {
            let index = $(e).data('ref');
            // $('#tr_record_' + index).remove();
            checkedList.push({id: $(e).val()});
        }

    })

    if (!checkedList.length) {
        return;
    }

    // showConfirmDelete(function () {
    let data = {
        ids: checkedList
    }
    // console.log(checkedList);
    // return false;
    // jQuery('#loading_event').show();

    var url = "/zm/api/events/download.json?token=" + window.zm.access_token + '&files=' + JSON.stringify(checkedList);
    // console.log(url);
    // return false;
    var link = document.createElement('a');
    link.setAttribute('href', url);
    link.setAttribute('download', '');
    document.body.appendChild(link);
    link.click();
    document.body.removeChild(link);

    // jQuery.ajax({
    //     url: "/zm/api/events/download.json?token=" + window.zm.access_token,
    //     type: "post",
    //     async: true,
    //     data: JSON.stringify(data),
    //     contentType: 'application/json',
    //     success: function (data) {
    //         // console.log(data);
    //         // promptShow({
    //         //   text: "删除成功", //提示文字
    //         //   width: "390px", //提示框宽度
    //         //   height: "246px", //提示框高度
    //         //   icon: "images/icon_delete02.png", //提示图标
    //         //   iconWidth: "80px", //提示图标的大小
    //         //   textLineHeight: "360px" //提示文字的行高
    //         // });
    //         // Message.success(myUNAS._('Delete Success'));
    //         jQuery('#loading_event').hide();
    //         window.zm.update['event']();
    //
    //         // $("input[name='selectAll']").prop('checked', false);
    //     },
    //     error: function (XMLHttpRequest, textStatus, errorThrown) {
    //         // promptShow('删除失败');
    //         // Message.error(myUNAS._('Delete Failed'));
    //         hideWaiting();
    //     }
    // });

    // })
}