(function(){
    window.zm = window.zm || {};
    window.zm.cgiBinUrl = '/zm/cgi-bin/nph-zms';
    window.zm.windowId = Math.random().toString(36).slice(-6);// 用于区别同一用户打开的不同窗口
    window.zm.streamUrl = '/zm/index.php';
    window.zm.reqUrl = '/zm/api/';

    window.zm.auth = getCookie("credentials");
    window.zm.access_token=getCookie("access_token");
    window.zm.refresh_token=getCookie("refresh_token");
    window.zm.username=getCookie("username");
    window.zm.access_token_expires=getCookie("access_token_expires");
    window.zm.refresh_token_expires=getCookie("refresh_token_expires");


    //用户点击  左侧预览-右侧某一视频图像右上角编辑时调用
    window.zm.showEditMonitorComprehensive=function(comprehensiveData){
        $("#operateType").val("edit");
        //根据传过来的参数初始化监视器的配置面板并显示
        //console.log(comprehensiveData);
        $("#mointer-simple-modeBtn").addClass("hide");
        initMointorComprehensiveData(comprehensiveData.Monitor);
    };
    //用户点击添加监视器时调用并初始化基本配置信息
    window.zm.showAddMonitorComprehensive=function(simpleData){
        //根据传过来的参数初始化监视器的配置面板并显示
        //console.log(simpleData);
        $("#operateType").val("add");
        $("#mointer-simple-modeBtn").removeClass("hide");
        initMointorSimpleData(simpleData);
    };

    //获取当前所在页面名称
    window.zm.getCurrentPage = getCurrentPage;
    function getCurrentPage(){
        // console.log($(".left-tab.active").data('ref'))
        return $(".left-tab.active").data('ref');
    }


    //翻译函数，翻译优先级url-config-cookie
    window.zm.languageTranslation=languageTranslation;
    function languageTranslation(){
        var paramLanguage = getParameterURL("language");
        if(paramLanguage){
            //如果跳转URL中带语言参数，则设置为对应语言
            // console.log(paramLanguage);
            if (paramLanguage == "cn") {
                window.unasTranslation('简体中文');
            } else if (paramLanguage == "kr") {
                window.unasTranslation('한국어');
            } else if (paramLanguage == "jp") {
                window.unasTranslation('日本語');
            } else {
                window.unasTranslation('English');
            }
            //设置配置选项中语言的值
            window.zm.setConfigLanguage(myUNAS.CurrentLanguage);
        }
        else{

            //设置为 当前配置选项中语言的值
            var configLanguage = window.zm.getConfigLanguage();
            window.unasTranslation(configLanguage);
        }
    }

    //注销，跳转到登录页
    function logout(){
        setCookie("username","");
        setCookie("credentials","");
        setCookie("access_token","");
        setCookie("access_token_expires","");
        setCookie("refresh_token","");
        setCookie("refresh_token_expires","");

        window.location.href="login.html"+location.search;
    }

    //刷新access_token
    window.zm.refreshToken = refreshToken;
    function refreshToken(){
        if(_tokenCheckInterval){
            clearInterval(_tokenCheckInterval);
        }

        $.ajax({
            url: "/zm/api/host/login.json?token="+window.zm.refresh_token,
            type: "GET",
            dataType: "json",
            async: true,
            success: function(data){
                //console.log(data);
                if(data && data.access_token){
                    setCookie("access_token",data.access_token,data.access_token_expires);
                    setCookie("credentials",data.credentials,data.access_token_expires);
                    setCookie("access_token_expires",data.access_token_expires,data.access_token_expires);

                    window.zm.auth = data.credentials;
                    window.zm.access_token = data.access_token;
                    window.zm.access_token_expires = data.access_token_expires;

                    //重新计算access_token超时时间（预留5分钟）
                    _tokenExpiresTime = new Date().getTime()+window.zm.access_token_expires*1000-5*60*1000;
                    //重新计算refresh_token超时时间（预留5分钟）
                    _tokenRefreshExpiresTime = new Date().getTime()+window.zm.refresh_token_expires*1000-5*60*1000;

                    startTokenCheck();
                    //获取到新的access_token后，刷新当前页面
                    window.zm.update[getCurrentPage()]();
                }else{
                    //console.log('Refresh token failed. Redirected to login page.');
                    window.location.href="login.html"+location.search;
                }
            },
            error:function(xhr, ajaxOptions, thrownError){
                //console.log('Refresh token error. Redirected to login page.');
                window.location.href="login.html"+location.search;
            }
        });
    };


    var _tokenCheckInterval;
    //计算access_token超时时间（预留5分钟）
    var _tokenExpiresTime = new Date().getTime()+window.zm.access_token_expires*1000-5*60*1000;
    //计算refresh_token超时时间（预留5分钟）
    var _tokenRefreshExpiresTime = new Date().getTime()+window.zm.refresh_token_expires*1000-5*60*1000;
    function startTokenCheck(){
        _tokenCheckInterval = setInterval(function(){
            tokenCheckInterval();
        },1000 * 60);
    }
    function tokenCheckInterval(){
        if(!window.zm.access_token || !window.zm.refresh_token){
            logout();
            return;
        }

        var currentTime = new Date().getTime();

        if(currentTime > _tokenRefreshExpiresTime){
            //refresh_token超时，重新登录
            window.location.href="login.html"+location.search;
        }else{
            if(currentTime > _tokenExpiresTime){
                //access_token超时，刷新access_token
                refreshToken();
            }
        }
    }

    //首先检查token
    function tokenCheckFirst(){
        if(!window.zm.access_token || !window.zm.refresh_token){
            logout();
            return;
        }

        var currentTime = new Date().getTime();
        if(currentTime >= _tokenRefreshExpiresTime){
            //refresh_token超时，重新登录
            window.location.href="login.html"+location.search;
        }else{
            if(currentTime >= _tokenExpiresTime){
                //access_token超时，刷新access_token
                $.ajax({
                    url: "/zm/api/host/login.json?token="+window.zm.refresh_token,
                    type: "GET",
                    dataType: "json",
                    async: true,
                    success: function(data){
                        //console.log(data);
                        if(data && data.access_token){
                            setCookie("access_token",data.access_token,data.access_token_expires);
                            setCookie("credentials",data.credentials,data.access_token_expires);
                            setCookie("access_token_expires",data.access_token_expires,data.access_token_expires);

                            window.zm.auth = data.credentials;
                            window.zm.access_token = data.access_token;
                            window.zm.access_token_expires = data.access_token_expires;

                            //重新计算access_token超时时间（预留5分钟）
                            _tokenExpiresTime = new Date().getTime()+window.zm.access_token_expires*1000-5*60*1000;

                            //获取到新的access_token后，获取配置信息
                            getConfig();
                        }else{
                            //console.log('Refresh token failed. Redirected to login page.');
                            window.location.href="login.html"+location.search;
                        }
                    },
                    error: function(xhr, ajaxOptions, thrownError){
                        //console.log('Refresh token error. Redirected to login page.');
                        window.location.href="login.html"+location.search;
                    }
                });
            }else{
                //获取配置信息
                getConfig();
            }
        }
    }

    //获取配置信息
    function getConfig(){
        $.ajax({
            url: "/zm/api/configs.json?token="+getCookie("access_token"),
            type: "GET",
            dataType: "json",
            async: true,
            success: function(data){
                //console.log(data);
                if(data && data.configs){
                    window.zm.configs = data.configs;

                    //获取到配置信息后，加载翻译文件
                    loadTranslation();
                }
            },
            error: function(xhr, ajaxOptions, thrownError){
                //加载翻译文件
                loadTranslation();
            }
        });
    }

    //加载翻译文件
    function loadTranslation(){
        myUNAS.LoadTranslation("./languages/Translation.json",function(){
            //翻译优先级：url-config-cookie
            var paramLanguage = getParameterURL("language");
            if(paramLanguage){
                //如果跳转URL中带语言参数，则设置为对应语言
                if (paramLanguage == "cn") {
                    window.unasTranslation('简体中文');
                } else if (paramLanguage == "kr") {
                    window.unasTranslation('한국어');
                } else if (paramLanguage == "jp") {
                    window.unasTranslation('日本語');
                } else {
                    window.unasTranslation('English');
                }
                //设置配置选项中语言的值
                window.zm.setConfigLanguage(myUNAS.CurrentLanguage);
            }else{
                //读取配置选项和cookie中语言的值
                var configLanguage = window.zm.getConfigLanguage();
                var cookieLanguage = getCookie("language");
                if (configLanguage) {
                    window.unasTranslation(configLanguage);
                } else if (cookieLanguage) {
                    //如果cookie中获取到语言参数，则设置为对应语言
                    if (cookieLanguage == "cn") {
                        window.unasTranslation('简体中文');
                    } else if (cookieLanguage == "kr") {
                        window.unasTranslation('한국어');
                    } else if (cookieLanguage == "jp") {
                        window.unasTranslation('日本語');
                    } else {
                        window.unasTranslation('English');
                    }
                } else {
                    //默认显示英文
                    window.unasTranslation('English');
                }
            }

            startTokenCheck();

            $("body").show();

            $mainContainer.load('monitor.html', function(response, status, xhr){
                window.zm.init['monitor']();
            });
        });
    }

    //在login的图片下方显示当前登录人的名称
    $("#username").text(window.zm.username);

    var $mainContainer = $('#main_container');

    tokenCheckFirst();

    // ****************************************************************
    // 事件
    // ****************************************************************
    //index页面左侧状态栏点击事件
    $(".left-tab").on("click",function(){
        if($(this).hasClass('active')) return;

        var lastPage = $(".left-tab.active").data('ref');
        // console.log(lastPage)
        window.zm.destroy[lastPage]();

        //执行前重置所有图片为正常状态,移除active样式，方便后面切换
        $(".left-tab").find("img").attr("src",function(index,value){
            return value.replace("_pressed.","_normal.");
        });
        $(".left-tab").removeClass("active");

        //为被点击的元素添加active样式
        $(this).addClass("active");
        //将点击的元素图片设置成激活状态的图片
        $(this).find("img").attr("src",function(index,value){
            return value.replace("_normal.","_pressed.");
        });

        var page = $(this).data('ref');
        // console.log(page)
        //console.log('load page:'+page);
        $mainContainer.load(page+'.html', function(response, status, xhr){
            window.zm.init[page]();
        });
    });


    //点击监视器配置面板的选项卡执行的事件,用于切换选项卡对应的内容
    $(".monitor-config-content-ul li").on("click",function(){
        $(".monitor-config-content-ul li").removeClass("active");
        $(this).addClass("active");

        var sourceType=$("[id='newMonitor[Type]']").val();
        sourceType=sourceType.replace(sourceType[0],sourceType[0].toLowerCase());
        //切换选项卡对应的内容
        //Source选项卡内容比较特殊，会受到General内容中Source Type项影响,这里特殊处理
        //显示前,先隐藏所有选项卡内容
        $(".monitor-config-content-table").addClass("hide");
        if(this.id=="monitor-config-content-ul-source"){
            $("#monitor-config-content-table-"+sourceType+"-source").removeClass("hide");
        }
        else{
            $("table[ref="+this.id+"]").removeClass("hide");
        }


        //Source面板中Source Type项选择Ffmpeg对其他选项卡内容的影响
        if(sourceType=="ffmpeg"){
            $("[id='newMonitor[RecordAudio]']").removeClass("hide");
            $("[id='newMonitor[RecordAudio]Description']").addClass("hide");
        }
        else{
            $("[id='newMonitor[RecordAudio]']").addClass("hide");
            $("[id='newMonitor[RecordAudio]Description']").removeClass("hide");
        }
    });
    //监视器配置面板设置滚动条
    $(".monitor-config-content-table-srcoll").mCustomScrollbar({
        autoHideScrollbar:false,
        theme:"minimal-dark",
        scrollInertia: 200
    });
    //监视器配置面板选项卡为Source中的Capture Resolution (pixels)项的change事件
    //将所有newMonitor获取到一起注册事件,根据前缀区分操作对象
    //local-newMonitor[Width]
    //remote-newMonitor[Width]
    //file-newMonitor[Width]
    //ffmpeg-newMonitor[Width]
    //libvlc-newMonitor[Width]
    //cUrl-newMonitor[Width]
    $("[id$='newMonitor[Width]'],[id$='newMonitor[Height]']").on("input",function(e){
        var value="";
        //获取当前id前缀表明当前操作的面板
        var pre=this.id.split("-")[0];
        if(this.id.indexOf("newMonitor[Width]")>0){
            value=this.value+"x"+$("[id='"+pre+"-newMonitor[Height]']").val();
        }else{
            value=$("[id='"+pre+"-newMonitor[Width]']").val()+"x"+this.value;
        }

        if($("#"+pre+"-dimensions_select option[value="+value+"]").length>0){
            $("#"+pre+"-dimensions_select").val(value);
        }
        else{
            $("#"+pre+"-dimensions_select").val("");
        }
    });
    $("[id$='dimensions_select']").on("change",function(e){
        //获取当前id前缀表明当前操作的面板
        var pre=this.id.split("-")[0];
        var strArr=this.value.split("x");
        $("[id='"+pre+"-newMonitor[Width]']").val(strArr[0]);
        $("[id='"+pre+"-newMonitor[Height]']").val(strArr[1]);
    });

    //监视器配置面板选项卡为Misc, Signal Check Colour项与Web Colour项变化事件
    $("input[name='newMonitor[SignalCheckColour]']").on("input",function(e){
        $('#SignalCheckSwatch').css('background-color', e.target.value);
    });
    $("input[name='newMonitor[WebColour]']").on("input",function(e){
        $('#WebSwatch').css('background-color', event.target.value);
    });
    //web colour最右侧图标事件（随机颜色）
    $("#randomColorIcon").on("click",function(){
        var letters = '0123456789ABCDEF';
        var colour = '#';
        for (var i = 0; i < 6; i++) {
            colour += letters[Math.floor(Math.random() * 16)];
        }
        $('input[name="newMonitor[WebColour]"]').val(colour);
        $('#WebSwatch').css(
          'backgroundColor', colour
        );
    });

    $("[id='newMonitor[Type]']").on("change",function(){
        if(this.value=="Ffmpeg"){
            $("[id='newMonitor[VideoWriter]'] option[value='2']").removeAttr("disabled");
        }
        else{
            $("[id='newMonitor[VideoWriter]'] option[value='2']").prop("disabled","true");
            $("[id='newMonitor[VideoWriter]']").val("0");
        }
    });

    //为所有按钮注册按下抬起事件变化样式
    $(document).on("mousedown","button",function(){
        $(this).addClass("pressed");
    }).on("mouseup","button",function(){
        $(this).removeClass("pressed");
    }).on("mouseout","button",function(){
        $(this).removeClass("pressed");
    });

    //点击'注销'按钮显示退出确认界面
    $("#btn_logout").on("click",function(){
        $("#popup_logout").show();
    });
    //退出确认界面的2个按钮事件
    $("#confirmBtn").on("click",function(){
        logout();
    });
    $("#cancelBtn").on("click",function(){
        $('#popup_logout').hide();
    });
    $(".logout-container-div4 button").mousedown(function(){
        $(this).addClass("pressed");
    }).mouseup(function(){
        $(this).removeClass("pressed");
    });

    //点击监视器高级选项中的保存按钮
    $("#mointer-saveBtn").on("click",function(){
        var Name=$("[id='newMonitor[Name]']").val();
        if(Name.indexOf(" ")>=0){
            // promptShow("Monitor name cannot have spaces");
            Message.error(myUNAS._('Monitor name cannot have spaces'));
            return;
        }

        saveMonitorData();
    });
    //点击监视器高级选项中的简单模式
    $("#mointer-simple-modeBtn").on("click",function(){
        $("#popup_monitor").hide();
        $("#popup_monitor_simple").show();
    });

    $("#mointer-simple-modeBtn,#mointer-saveBtn,#monitor-close-btn").mousedown(function(){
        $(this).addClass("pressed");
    }).mouseup(function(){
        $(this).removeClass("pressed");
    });

    //监视器配置面板中，高级选项的数据初始化
    function initMointorComprehensiveData(comprehensiveData){
        // console.log(comprehensiveData)
        //单选框，复选框操作方式与文本框下拉框有所不同

        //赋监视器id
        $("[id='newMonitor[Id]']").val(comprehensiveData.Id);

        //设置左上角标题
        $("#monitorTitle").text(comprehensiveData.Name);
        //General面板
        $("[id='newMonitor[Name]']").val(comprehensiveData.Name);
        $("[id='newMonitor[Notes]']").val(comprehensiveData.Notes);
        $("[id='newMonitor[Server]']").val(comprehensiveData.ServerId);
        //$("[id='newMonitor[Server]']").select2("val",[comprehensiveData.ServerId]);
        $("[id='newMonitor[Type]']").val(comprehensiveData.Type);
        //$("[id='newMonitor[Type]']").select2("val",[comprehensiveData.Type]);
        $("[id='newMonitor[Type]']").trigger("change");
        $("[id='newMonitor[Function]']").val(comprehensiveData.Function);
        //$("[id='newMonitor[Function]']").select2("val",[comprehensiveData.Function]);
        if(comprehensiveData.Enabled=="1"){
            $("[id='newMonitor[Enabled]']").attr("checked",true);
        }
        $("[id='newMonitor[LinkedMonitors][]']").val(comprehensiveData.LinkedMonitors);
        //$("[id='newMonitor[GroupIds][]']").val(comprehensiveData.GroupIds);
        $("[id='newMonitor[AnalysisFPSLimit]']").val(comprehensiveData.AnalysisFPSLimit);
        $("[id='newMonitor[MaxFPS]']").val(comprehensiveData.MaxFPS);
        $("[id='newMonitor[AlarmMaxFPS]']").val(comprehensiveData.AlarmMaxFPS);
        $("[id='newMonitor[RefBlendPerc]']").val(comprehensiveData.RefBlendPerc);
        //$("[id='newMonitor[RefBlendPerc]']").select2("val",[comprehensiveData.RefBlendPerc]);
        $("[id='newMonitor[AlarmRefBlendPerc]']").val(comprehensiveData.AlarmRefBlendPerc);
        //$("[id='newMonitor[AlarmRefBlendPerc]']").select2("val",[comprehensiveData.AlarmRefBlendPerc]);
        //Source面板中的元素id获取需要加上General面板的Source Type值作为前缀
        var type=$("[id='newMonitor[Type]']").val();
        type=type.replace(type[0],type[0].toLowerCase());
        $("[id='"+type+"-newMonitor[Device]']").val(comprehensiveData.Device);
        $("[id='"+type+"-newMonitor[Method]']").val(comprehensiveData.Method);
        //$("[id='"+type+"-newMonitor[Method]']").select2("val",[comprehensiveData.Method]);
        $("[id='"+type+"-newMonitor[Channel]']").val(comprehensiveData.Channel);
        //$("[id='"+type+"-newMonitor[Channel]']").select2("val",[comprehensiveData.Channel]);
        $("[id='"+type+"-newMonitor[Format]']").val(comprehensiveData.Format);
        //$("[id='"+type+"-newMonitor[Format]']").select2("val",[comprehensiveData.Format]);
        $("[id='"+type+"-newMonitor[Palette]']").val(comprehensiveData.Palette);
        //$("[id='"+type+"-newMonitor[Palette]']").select2("val",[comprehensiveData.Palette]);
        $("input[name='"+type+"-newMonitor[V4LMultiBuffer]'][value='"+comprehensiveData.V4LMultiBuffer+"']").attr("checked",true);
        $("[id='"+type+"-newMonitor[V4LCapturesPerFrame]']").val(comprehensiveData.V4LCapturesPerFrame);
        $("[id='"+type+"-newMonitor[Colours]']").val(comprehensiveData.Colours);
        $("[id='"+type+"-newMonitor[Width]']").val(comprehensiveData.Width);
        $("[id='"+type+"-newMonitor[Height]']").val(comprehensiveData.Height);
        //$("[id='"+type+"-dimensions_select']").val(comprehensiveData.dimensions_select);
        //触发其input事件为dimensions_select元素赋值
        $("[id='"+type+"-newMonitor[Height]']").trigger("input");
        if(comprehensiveData.preserveAspectRatio=="1"){
            $("[id='"+type+"-newMonitor[preserveAspectRatio]']").attr("checked",true);
        }
        $("[id='"+type+"-newMonitor[Orientation]']").val(comprehensiveData.Orientation);
        //$("[id='"+type+"-newMonitor[Orientation]']").select2("val",[comprehensiveData.Orientation]);
        $("[id='"+type+"-newMonitor[Deinterlacing]']").val(comprehensiveData.Deinterlacing);
        //$("[id='"+type+"-newMonitor[Deinterlacing]']").select2("val",[comprehensiveData.Deinterlacing]);
        $("[id='"+type+"-newMonitor[Protocol]']").val(comprehensiveData.Protocol);
        //$("[id='"+type+"-newMonitor[Protocol]']").select2("val",[comprehensiveData.Protocol]);
        $("[id='"+type+"-newMonitor[Host]']").val(comprehensiveData.Host);
        $("[id='"+type+"-newMonitor[Port]']").val(comprehensiveData.Port);
        $("[id='"+type+"-newMonitor[Path]']").val(comprehensiveData.Path);
        if(comprehensiveData.RTSPDescribe=="1"){
            $("[id='"+type+"-newMonitor[RTSPDescribe]']").attr("checked",true);
        }
        $("[id='"+type+"-newMonitor[Options]']").val(comprehensiveData.Options);
        $("[id='"+type+"-newMonitor[DecoderHWAccelName]']").val(comprehensiveData.DecoderHWAccelName);
        $("[id='"+type+"-newMonitor[DecoderHWAccelDevice]']").val(comprehensiveData.DecoderHWAccelDevice);
        $("[id='"+type+"-newMonitor[User]']").val(comprehensiveData.User);
        $("[id='"+type+"-newMonitor[Pass]']").val(comprehensiveData.Pass);
        $("[id='"+type+"-newMonitor[Refresh]']").val(comprehensiveData.Refresh);

        //Storage面板
        $("[id='newMonitor[StorageId]']").val(comprehensiveData.StorageId);
        //$("[id='newMonitor[StorageId]']").select2("val",[comprehensiveData.StorageId]);
        // $("[id='newMonitor[SaveJPEGs]']").val(comprehensiveData.SaveJPEGs);
        //$("[id='newMonitor[SaveJPEGs]']").select2("val",[comprehensiveData.SaveJPEGs]);
        $("[id='newMonitor[VideoWriter]']").val(comprehensiveData.VideoWriter);
        //$("[id='newMonitor[VideoWriter]']").select2("val",[comprehensiveData.VideoWriter]);
        $("[id='newMonitor[EncoderParameters]']").val(comprehensiveData.EncoderParameters);
        $("[id='newMonitor[RecordAudio]']").val(comprehensiveData.RecordAudio);

        //Timestamp面板
        if(comprehensiveData.LabelFormat!=""){
            $("[id='newMonitor[LabelFormat]']").val(comprehensiveData.LabelFormat);
        }
        $("[id='newMonitor[LabelX]']").val(comprehensiveData.LabelX);
        $("[id='newMonitor[LabelY]']").val(comprehensiveData.LabelY);
        $("[id='newMonitor[LabelSize]']").val(comprehensiveData.LabelSize);

        //controller面板
        if(comprehensiveData.Controllable=="1"){
            $("[id='newMonitor[Controllable]']").attr("checked",true);
        }
        $("[id='newMonitor[ControlId]']").val(comprehensiveData.ControlId);
        $("[id='newMonitor[ControlDevice]']").val(comprehensiveData.ControlDevice);
        $("[id='newMonitor[ControlAddress]']").val(comprehensiveData.ControlAddress);
        $("[id='newMonitor[AutoStopTimeout]']").val(comprehensiveData.AutoStopTimeout);
        $("[id='newMonitor[TrackMotion]']").val(comprehensiveData.TrackMotion);
        $("[id='newMonitor[TrackDelay]']").val(comprehensiveData.TrackDelay);
        $("[id='newMonitor[ReturnLocation]']").val(comprehensiveData.ReturnLocation);
        $("[id='newMonitor[ReturnDelay]']").val(comprehensiveData.ReturnDelay);

        //buffer面板
        $("[id='newMonitor[ImageBufferCount]']").val(comprehensiveData.ImageBufferCount);
        $("[id='newMonitor[WarmupCount]']").val(comprehensiveData.WarmupCount);
        $("[id='newMonitor[PreEventCount]']").val(comprehensiveData.PreEventCount);
        $("[id='newMonitor[PostEventCount]']").val(comprehensiveData.PostEventCount);
        $("[id='newMonitor[StreamReplayBuffer]']").val(comprehensiveData.StreamReplayBuffer);
        $("[id='newMonitor[AlarmFrameCount]']").val(comprehensiveData.AlarmFrameCount);


        //Misc面板
        $("[id='newMonitor[EventPrefix]']").val(comprehensiveData.EventPrefix);
        $("[id='newMonitor[SectionLength]']").val(comprehensiveData.SectionLength);
        $("[id='newMonitor[MinSectionLength]']").val(comprehensiveData.MinSectionLength);
        $("[id='newMonitor[FrameSkip]']").val(comprehensiveData.FrameSkip);
        $("[id='newMonitor[MotionFrameSkip]']").val(comprehensiveData.MotionFrameSkip);
        $("[id='newMonitor[AnalysisUpdateDelay]']").val(comprehensiveData.AnalysisUpdateDelay);
        $("[id='newMonitor[FPSReportInterval]']").val(comprehensiveData.FPSReportInterval);
        $("[id='newMonitor[DefaultRate]']").val(comprehensiveData.DefaultRate);
        $("[id='newMonitor[DefaultScale]']").val(comprehensiveData.DefaultScale);
        $("[id='newMonitor[DefaultCodec]']").val(comprehensiveData.DefaultCodec);
        $("[id='newMonitor[SignalCheckPoints]']").val(comprehensiveData.SignalCheckPoints);
        $("[id='newMonitor[SignalCheckColour]']").val(comprehensiveData.SignalCheckColour);
        $("[id='newMonitor[WebColour]']").val(comprehensiveData.WebColour);
        if(comprehensiveData.Exif=="1"){
            $("[id='newMonitor[Exif]']").attr("checked",true);
        }

        popupMonitorShow();
    }

    //监视器高级选项显示，显示前重置样式和数据（由于关闭打开功能是用隐藏和显示实现的，所以用户第一次操作后关闭，第二次打开会保留上次的操作痕迹）
    function popupMonitorShow(){
        //初始显示默认到General选项卡
        $(".monitor-config-content-table").addClass("hide");
        $("#monitor-config-content-table-general").removeClass("hide");
        $(".monitor-config-content-ul li").removeClass("active");
        $("#monitor-config-content-ul-general").addClass("active");
        //重置数据，实际打开页面后会初始化数据，可以不考虑重置数据的问题

        $("#popup_monitor").show();
    }

    function initMointorSimpleData(simpleData){
        //console.log(simpleData);
        //设置左上角标题
        $("#monitorTitle").text(simpleData.Name);
        //General面板
        $("[id='newMonitor[Name]']").val(simpleData.Name);
        $("[id='newMonitor[Type]']").val(simpleData.Type);

        //$("[id='newMonitor[Type]']").select2("val",[simpleData.Type]);

        //Source面板中的元素id获取需要加上General面板的Source Type值作为前缀
        var type=simpleData.Type;
        type=type.replace(type[0],type[0].toLowerCase());
        $("[id='"+type+"-newMonitor[Protocol]']").val(simpleData.Protocol);
        $("[id='"+type+"-newMonitor[Method]']").val(simpleData.Method);
        $("[id='"+type+"-newMonitor[User]']").val(simpleData.User);
        $("[id='"+type+"-newMonitor[Pass]']").val(simpleData.Pass);
        $("[id='"+type+"-newMonitor[Host]']").val(simpleData.IP);
        $("[id='"+type+"-newMonitor[Port]']").val(simpleData.Port);
        $("[id='"+type+"-newMonitor[Height]']").val(simpleData.Height||"1080");
        $("[id='"+type+"-newMonitor[Width]']").val(simpleData.Width||"1920");

        $("[id='"+type+"-newMonitor[Height]']").trigger("input");

        $("[id='"+type+"-newMonitor[Port]']").val(simpleData.Port);
        var path=simpleData.Protocol+"://"+simpleData.User+":"+simpleData.Pass+"@"+simpleData.IP+(simpleData.Port?":"+simpleData.Port:"")+"/onvif";
        if(simpleData.Path){
            $("[id='"+type+"-newMonitor[Path]']").val(simpleData.Path);
        }
        else{
            $("[id='"+type+"-newMonitor[Path]']").val(path);
        }

        if (simpleData.Type == 'Ffmpeg') {
            $("[id='newMonitor[VideoWriter]'] option[value='2']").removeAttr("disabled");
        }

        popupMonitorShow();

        document.querySelectorAll('select[name="newMonitor[Function]"]').forEach(function(el) {
            el.onchange = function() {
                //   $j('#function_help div').hide();
                //   $j('#'+this.value+'Help').show();
                if ( this.value == 'Monitor' || this.value == 'None' ) {
                    $('#FunctionEnabled').hide();
                } else {
                    $('#FunctionEnabled').show();
                }
                if ( this.value == 'Record' || this.value == 'Nodect' ) {
                    $('#FunctionDecodingEnabled').show();
                } else {
                    $('#FunctionDecodingEnabled').hide();
                }
            };
            el.onchange();
        });

    }


    function updateMethods(element) {
        var form = element.form;

        var origMethod = form.elements['origMethod'];
        var methodSelector = form.elements['newMonitor[Method]'];
        methodSelector.options.length = 0;
        switch ( element.value ) {
        case 'http' :
                      methodSelector.options[methodSelector.options.length] = new Option("Simple", "simple");
              if ( origMethod.value == "simple" )
                methodSelector.selectedIndex = methodSelector.options.length-1;
                          methodSelector.options[methodSelector.options.length] = new Option("Regexp", "regexp");
              if ( origMethod.value == "regexp" )
                methodSelector.selectedIndex = methodSelector.options.length-1;
                        break;
        case 'rtsp' :
                      methodSelector.options[methodSelector.options.length] = new Option( "RTP/Unicast", "rtpUni" );
              if ( origMethod.value == "rtpUni" )
                methodSelector.selectedIndex = form.elements['newMonitor[Method]'].options.length-1;
                          methodSelector.options[methodSelector.options.length] = new Option( "RTP/Multicast", "rtpMulti" );
              if ( origMethod.value == "rtpMulti" )
                methodSelector.selectedIndex = form.elements['newMonitor[Method]'].options.length-1;
                          methodSelector.options[methodSelector.options.length] = new Option( "RTP/RTSP", "rtpRtsp" );
              if ( origMethod.value == "rtpRtsp" )
                methodSelector.selectedIndex = form.elements['newMonitor[Method]'].options.length-1;
                          methodSelector.options[methodSelector.options.length] = new Option( "RTP/RTSP/HTTP", "rtpRtspHttp" );
              if ( origMethod.value == "rtpRtspHttp" )
                methodSelector.selectedIndex = form.elements['newMonitor[Method]'].options.length-1;
                  break;
        }
        return true;
    }

    //保存监视器高级选项的配置数据
    function saveMonitorData(){

        //数据校验
        if($("[id='newMonitor[Type]']").val()=="Local"){
            if(!$("[id='local-newMonitor[Format]']").val()){
                // promptShow("信号源类型选择本地，则必须填写设备格式");
                Message.error(myUNAS._('If you select local as the signal source type, you must fill in the device format'));
                return;
            }
        }

        var monitor={};
        //判断监视器是编辑操作还是新增操作，编辑操作则带上监视器Id
        var url="";
        var methodType="";
        if($("#operateType").val()=="edit"){
            monitor.Id=$("[id='newMonitor[Id]']").val();
            url="/zm/api/monitors/"+$("[id='newMonitor[Id]']").val()+".json?token="+window.zm.access_token;
            methodType="PUT";
        }
        else{
            url="/zm/api/monitors.json?token="+window.zm.access_token;
            methodType="POST";
        }


        //general面板数据
        monitor.Name=$("[id='newMonitor[Name]']").val();
        monitor.Notes=$("[id='newMonitor[Notes]']").val();
        monitor.ServerId=$("[id='newMonitor[ServerId]']").val();
        monitor.Type=$("[id='newMonitor[Type]']").val();
        monitor.Function=$("[id='newMonitor[Function]']").val();
        if($("[id='newMonitor[Enabled]']").prop("checked")){
            monitor.Enabled="1";
        }
        else{
            monitor.Enabled="0";
        }
        monitor.LinkedMonitors=$("[id='newMonitor[LinkedMonitors][]']").val();
        //monitor.GroupIds=$("[id='newMonitor[GroupIds][]']").val();
        monitor.AnalysisFPSLimit=$("[id='newMonitor[AnalysisFPSLimit]']").val();
        monitor.MaxFPS=$("[id='newMonitor[MaxFPS]']").val();
        monitor.AlarmMaxFPS=$("[id='newMonitor[AlarmMaxFPS]']").val();
        monitor.RefBlendPerc=$("[id='newMonitor[RefBlendPerc]']").val();
        monitor.AlarmRefBlendPerc=$("[id='newMonitor[AlarmRefBlendPerc]']").val();
        //Source面板中的元素id获取需要加上General面板的Source Type值作为前缀
        var type=$("[id='newMonitor[Type]']").val();
        type=type.replace(type[0],type[0].toLowerCase());
        monitor.Device=$("[id='"+type+"-newMonitor[Device]']").val();
        monitor.Method=$("[id='"+type+"-newMonitor[Method]']").val();
        monitor.Channel=$("[id='"+type+"-newMonitor[Channel]']").val();
        monitor.Format=$("[id='"+type+"-newMonitor[Format]']").val();
        monitor.Palette=$("[id='"+type+"-newMonitor[Palette]']").val();
        monitor.V4LMultiBuffer=$("input[name='"+type+"-newMonitor[V4LMultiBuffer]']:checked").val();
        monitor.V4LCapturesPerFrame=$("[id='"+type+"-newMonitor[V4LCapturesPerFrame]']").val();
        monitor.Colours=$("[id='"+type+"-newMonitor[Colours]']").val();
        monitor.Width=$("[id='"+type+"-newMonitor[Width]']").val();
        monitor.Height=$("[id='"+type+"-newMonitor[Height]']").val();
        monitor.dimensions_select=$("[id='"+type+"-dimensions_select']").val();
        if($("[id='"+type+"-newMonitor[preserveAspectRatio]']").prop("checked")){
            monitor.preserveAspectRatio="1";
        }
        else{
            monitor.preserveAspectRatio="0";
        }
        monitor.Orientation=$("[id='"+type+"-newMonitor[Orientation]']").val();
        monitor.Deinterlacing=$("[id='"+type+"-newMonitor[Deinterlacing]']").val();
        monitor.Protocol=$("[id='"+type+"-newMonitor[Protocol]']").val();
        monitor.Host=$("[id='"+type+"-newMonitor[Host]']").val();
        monitor.Port=$("[id='"+type+"-newMonitor[Port]']").val();
        monitor.Path=$("[id='"+type+"-newMonitor[Path]']").val();
        if($("[id='"+type+"-newMonitor[RTSPDescribe]']").prop("checked")){
            monitor.RTSPDescribe="1";
        }
        else{
            monitor.RTSPDescribe="0";
        }
        monitor.Options=$("[id='"+type+"-newMonitor[Options]']").val();
        monitor.DecoderHWAccelName=$("[id='"+type+"-newMonitor[DecoderHWAccelName]']").val();
        monitor.DecoderHWAccelDevice=$("[id='"+type+"-newMonitor[DecoderHWAccelDevice]']").val();
        monitor.User=$("[id='"+type+"-newMonitor[User]']").val();
        monitor.Pass=$("[id='"+type+"-newMonitor[Pass]']").val();
        monitor.Refresh=$("[id='"+type+"-newMonitor[Refresh]']").val();
        //Storage面板
        monitor.StorageId=$("[id='newMonitor[StorageId]']").val();
        // monitor.SaveJPEGs=$("[id='newMonitor[SaveJPEGs]']").val();
        monitor.SaveJPEGs=0;
        monitor.VideoWriter=$("[id='newMonitor[VideoWriter]']").val();
        monitor.EncoderParameters=$("[id='newMonitor[EncoderParameters]']").val();
        monitor.RecordAudio=$("[id='newMonitor[RecordAudio]']").val();
        monitor.LabelFormat=$("[id='newMonitor[LabelFormat]']").val();
        monitor.LabelX=$("[id='newMonitor[LabelX]']").val();
        monitor.LabelY=$("[id='newMonitor[LabelY]']").val();
        monitor.ImageBufferCount=$("[id='newMonitor[ImageBufferCount]']").val();
        monitor.WarmupCount=$("[id='newMonitor[WarmupCount]']").val();
        monitor.PreEventCount=$("[id='newMonitor[PreEventCount]']").val();
        monitor.PostEventCount=$("[id='newMonitor[PostEventCount]']").val();
        monitor.StreamReplayBuffer=$("[id='newMonitor[StreamReplayBuffer]']").val();
        monitor.AlarmFrameCount=$("[id='newMonitor[AlarmFrameCount]']").val();
        //Timestamp面板
        if($("[id='newMonitor[Controllable]']").prop("checked")){
            monitor.Controllable="1";
        }
        else{
            monitor.Controllable="0";
        }
        monitor.ControlId=$("[id='newMonitor[ControlId]']").val();
        monitor.ControlDevice=$("[id='newMonitor[ControlDevice]']").val();
        monitor.ControlAddress=$("[id='newMonitor[ControlAddress]']").val();
        monitor.AutoStopTimeout=$("[id='newMonitor[AutoStopTimeout]']").val();
        monitor.TrackMotion=$("[id='newMonitor[TrackMotion]']").val();
        monitor.TrackDelay=$("[id='newMonitor[TrackDelay]']").val();
        monitor.ReturnLocation=$("[id='newMonitor[ReturnLocation]']").val();
        monitor.ReturnDelay=$("[id='newMonitor[ReturnDelay]']").val();
        //Misc面板
        monitor.EventPrefix=$("[id='newMonitor[EventPrefix]']").val();
        monitor.SectionLength=$("[id='newMonitor[SectionLength]']").val();
        monitor.MinSectionLength=$("[id='newMonitor[MinSectionLength]']").val();
        monitor.FrameSkip=$("[id='newMonitor[FrameSkip]']").val();
        monitor.MotionFrameSkip=$("[id='newMonitor[MotionFrameSkip]']").val();
        monitor.AnalysisUpdateDelay=$("[id='newMonitor[AnalysisUpdateDelay]']").val();
        monitor.FPSReportInterval=$("[id='newMonitor[FPSReportInterval]']").val();
        monitor.DefaultRate=$("[id='newMonitor[DefaultRate]']").val();
        monitor.DefaultScale=$("[id='newMonitor[DefaultScale]']").val();
        monitor.DefaultCodec=$("[id='newMonitor[DefaultCodec]']").val();
        monitor.SignalCheckPoints=$("[id='newMonitor[SignalCheckPoints]']").val();
        monitor.SignalCheckColour=$("[id='newMonitor[SignalCheckColour]']").val();
        monitor.WebColour=$("[id='newMonitor[WebColour]']").val();
        if($("[id='newMonitor[Exif]']").prop("checked")){
            monitor.Exif="1";
        }
        else{
            monitor.Exif="0";
        }

        if (monitor.VideoWriter == 1) {
            monitor.Encoder = 'libx264'; //默认libx264
        } else if (monitor.VideoWriter == 2) {
            monitor.OutputCodec = 0; //重置为Auto
        }

        //组织请求参数
        var _data = monitor;
        // console.log(_data);
        // return false;
        //console.log(url);
        //console.log(methodType);

        $("#popup_log").show();
        $.ajax({
            url: url,
            type: methodType,
            dataType: "json",
            async: true,
            data: _data,
            timeout: 30000,
            beforeSend:function(){
                // $("#popup_log").show();
            },
            complete:function(){
                // $("#popup_log").hide();
            },
            success: function(data){
                $("#popup_monitor").hide();
                Message.success(myUNAS._('Saved'), function() {
                    setTimeout(function() {
                        $("#popup_log").hide();
                        window.zm.init['monitor']();
                    }, 2000)
                });
            },
            error:function(xhr, ajaxOptions, thrownError){
                //console.log(xhr);
                // promptShow(xhr.responseJSON.data.exception.message);
                Message.error(xhr.responseJSON.data.exception.message);
            }
        });
    }

    // var keepMonitorAliveTimer;
    //
    // keepMonitorAlive();
    //
    // function keepMonitorAlive() {
    //     $.ajax({
    //         url: "/apps/surveillance/includes/services_surveillance.php",
    //         type: "POST",
    //         async: true,
    //         data: {"action": "keepalive"},
    //         timeout: 20000,
    //         complete: function () {
    //             setTimeout(function () {
    //                 keepMonitorAlive();
    //             }, 1000 * 10); //10s
    //         }
    //     });
    // }
})();


//获取监视器列表
function getMonitorList(callback){
    var _data={};
    jQuery.ajax({
        url: "/zm/api/monitors.json?token="+window.zm.access_token,
        type: "GET",
        async: true,
        dataType: 'json',
        contentType: "application/json;charset=utf-8",
        data: _data,
        success: function (data) {
            if(data.monitors.length>0){
                callback(data.monitors);
            }else{
                callback([]);
            }
        },
        error: function(XMLHttpRequest, textStatus, errorThrown){
            //console.log('get monitor_list error textStatus:' + textStatus);
            callback([]);
        }
    });
}

//删除确认弹框
$('#dc_btn_cancel').click(function(e){
    hideConfirmDelete();
});
$('#popup_delete_confirm_close').click(function(e){
    hideConfirmDelete();
});
function hideConfirmDelete(){
    $('#dc_btn_confirm').off();
    $('#popup_delete_confirm').hide();
}
function showConfirmDelete(callback){
    $('#popup_delete_confirm').show();

    $('#dc_btn_confirm').click(function(e){
        hideConfirmDelete();
        if(typeof callback=="function"){
            callback();
        }
    });
}


/*提示框的显示
    参数说明
        content
            若传入的是字符串，则直接作为提示的内容
            若传入的是对象，则根据对象属性提供各种各样的功能
            {
                text:"提示内容",
                height:"64px",              //提示框的高度
                width:"340px",              //提示框的宽度
                icon:"url",                 //图片地址，若设置后将会出现在文字的正上方
                iconWidth:"80px",           //图片大小
                iconTop:"100px",            //图片距离顶部的位置
                textLineHeight:"100px"      //文字行高,若不设置icon，则使用height作为行高
            }

    参数callback为提示内容隐藏后需要一些其他处理的回调函数，如数据更新成功后需要有刷新页面的动作来即时的显示最新的数据
*/
function promptShow(content, callback){
    $(".popup_notice_container").children("img").remove();

    var option={
        text:"test",
        height:"64px",
        width:"340px",
        icon:"",
        iconWidth:"80px",
        iconTop:"49px",
        textLineHeight:"64px"
    };

    //显示页面时初始化高宽行高
    $(".popup_notice_container").css("width",option.width);
    $(".popup_notice_container").css("height",option.height);
    $(".popup_notice_container").css("line-height",option.height);

    if(typeof content=="string"){
        $("#popup_notice_text").text(myUNAS._(content));
    }
    else if(typeof content=="object"){
        $.extend(option,content);
        $("#popup_notice_text").text(myUNAS._(option.text));
        $(".popup_notice_container").css("width",option.width);
        $(".popup_notice_container").css("height",option.height);

        if(option.icon){
            $(".popup_notice_container").append("<img src='"+option.icon+"' style='width:"+option.iconWidth+";top:"+option.iconTop+"' />");
            $(".popup_notice_container").css("line-height",option.textLineHeight);
        }
    }

    //注册提示框背景处的点击事件，用户点击后提前关闭提示框并执行回调
    var time;
    $("#popup_notice").on("click",function(){
        clearTimeout(time);
        $("#popup_notice").hide();
        if(typeof callback=="function"){
            callback();
        }
    });
    $("#popup_notice").fadeIn(200,function(){
        time=setTimeout(function(){
            $("#popup_notice").fadeOut(200,function(){
                if(typeof callback=="function"){
                    callback();
                }
            });
        },2000);
    });
}
