(function () {
    var _isLocalDebug = getParameterURL('localDebug');
    var _monitorsOriginal = [];
    var _monitors = [];
    var _iptSearchFocus = false; //光标是否停留在搜索框中

    var _monitorsLan = []; //局域网内搜索到的监视器列表

    var _startGetStatusTimer;
    var REFRESH_INTERVAL = 2000; //获取监视器状态 轮询请求间隔（单位：毫秒）
    var _forceStopStatusTimer = false;

    var _currentView = 'page'; //默认初始显示表格页

    //表格页视图
    var _num_per_line = 2; //每行显示的监视器个数
    //var MARGIN_RIGHT_WIDTH = 20; //监视器元素的右边距
    var MARGIN_RIGHT_WIDTH = 0; //监视器元素的右边距
    var _monitorThumbWidth; //表格页视图中的thumb宽度
    var _monitorThumbHeight; //表格页视图中的thumb高度
    var _monitorMarginLeft;     //表格页视图中的左margin距离
    var _monitorMarginRight;    //表格页视图中的右margin距离
    var _monitorMargin;
    //slider视图
    var _monitor_ratio = 16 / 9; //监视器宽高比
    var _monitorSlider;
    var _monitorIndex = -1; //此处不是slider的index，而是slider在_monitor数组中的索引值（因为用户操作，可能会删除_monitor列表中的监视器，所以slider的index和_monitor的index并不总是一一对应的）
    var _monitorThumbSlideHeight = 140; //slider视图中底部slider中的thumb宽度
    var _monitorThumbSlideWidth; //slider视图中底部slider中的thumb高度
    var _monitorThumbBigsizeWidth;
    var _monitorThumbBigsizeHeight;

    function destroy() {
        console.log('destroy monitor');

        stopGetStatus();

        if (isPageView()) {
            clearPageView();
        } else {
            clearSliderView();
        }
    }

    //token过期并重新获取后,且当前选项卡处于预览页面时调用，一般用于刷新数据
    function update() {
        //console.log('update monitor');

        stopGetStatus();

        if (isPageView()) {
            clearPageView();
        } else {
            clearSliderView();
        }

        $("#monitor_ipt_search").val('');
        $("#monitor_ipt_search").data('lastValue', '');

        _currentView = 'page';
        _monitorIndex = -1;

        doGetMonitorList();
    }

    function init() {
        //console.log('init monitor');

        _iptSearchFocus = false;
        _currentView = 'page';
        var ZM_Monitor_List_Type = localStorage.getItem('ZM_Monitor_List_Type');
        _num_per_line = ZM_Monitor_List_Type == undefined ? 2 : ZM_Monitor_List_Type;
        _monitorIndex = -1;

        _monitor_ratio = 16 / 9;
        _monitorThumbSlideWidth = Math.round(_monitorThumbSlideHeight * _monitor_ratio);


        //配置上方2个按钮的鼠标按下和抬起样式
        // $(".zm-btn-with-icon").mousedown(function(){
        //  $(this).addClass("active");
        // }).mouseup(function(){
        //  $(this).removeClass("active");
        // })

        //'添加监视器'按钮
        $('#monitor_btn_add').click(function (e) {
            showAddMonitorSimple();
        });
        $('#popup_monitor_simple_close').click(function (e) {
            hideAddMonitorSimple();
        });

        $('#monitor-close-btn').off('click').on('click', function() {
            window.location.reload();
        })
        //简单配置项 弹窗底部'高级模式'按钮
        $('#monitor_btn_advance').click(function (e) {
            var Name = $("[id='simple-newMonitor[Name]']").val();
            if (Name.indexOf(" ") >= 0) {
                // promptShow("Monitor name cannot have spaces");
                Message.error('Monitor name cannot have spaces');
                return;
            }

            if (window.zm.showAddMonitorComprehensive) {
                window.zm.showAddMonitorComprehensive(getMonitorDataSimple());
                hideAddMonitorSimple();
            }
        });
        //简单配置项 弹窗底部'保存'按钮
        $('#mointer-simple-saveBtn').click(function (e) {
            var Name = $("[id='simple-newMonitor[Name]']").val();
            if (Name.indexOf(" ") >= 0) {
                // promptShow("Monitor name cannot have spaces");
                Message.error('Monitor name cannot have spaces');
                return;
            }
            addSimpleMonitor();
        });
        // $("#mointer-simple-saveBtn,#monitor_btn_advance,#mointer-simple-cancelBtn,#monitor-prob-add-button-next,#monitor-prob-add-button-pre,#monitor-prob-add-button-close,#monitor-prob-add-button-save").mousedown(function(){
        //     $(this).addClass("pressed");
        // }).mouseup(function(){
        //     $(this).removeClass("pressed");
        // });


        //'局域网搜索'按钮
        $('#monitor_btn_prob').click(function (e) {
            showMonitorProb();
        });
        $('#popup_monitor_prob_close').click(function (e) {
            hideMonitorProb();
        });
        $("#popup_monitor_prob_add_close").click(function (e) {
            $("#popup_monitor_prob_add_mointor").hide();
        });
        //局域网搜索中的'重新搜索'按钮
        $('#monitor_prob_btn_reprob').click(function (e) {
            doGetMonitorLanList(true);
        });
        //局域网搜索-列表项右侧图标-下一步按钮事件
        $("#monitor-prob-add-button-next").click(function (e) {
            //console.log("monitor-prob-add-button-next");
            //输入账号密码点击下一步校验,传入点击的图标DOM参数，获取绑定在元素上摄像机的key
            doLanMonitorInputUserPass();
        });
        //局域网搜索-列表项右侧图标-上一步按钮事件
        $("#monitor-prob-add-button-pre").click(function (e) {
            $("#monitor_lan_add_probe2_-2").show();
            $("#monitor_lan_add_probe2_-1").show();
            $("#monitor_lan_add_probe2_0").show();
            $("#monitor_lan_add_probe2_1").hide();
            $("#monitor_lan_add_probe2_2").hide();

            $("#monitor-prob-add-button-next").show();
            $("#monitor-prob-add-button-pre").hide();
            $("#monitor-prob-add-button-save").hide();
        });
        $("#monitor-prob-add-button-save").click(function (e) {
            //console.log("monitor-prob-add-button-save");
            //账号密码通过校验后的第二步流程
            // console.log(lanMonitorArr);
            var monitorData = {};
            monitorData.Name = $("#moniter-prob-add-name").val();
            monitorData.User = $("#moniter-prob-add-username").val();
            monitorData.Pass = $("#moniter-prob-add-password").val();
            monitorData.IP = $("#moniter-prob-add-host").val();
            monitorData.Protocol = $("#moniter-prob-add-protocol").val();

            var lanIndex = $("#moniter-prob-add-detected-profiles").val() * 1;
            delete lanMonitorArr[lanIndex].Name;
            $.extend(monitorData, lanMonitorArr[lanIndex]);
            showAddMonitorSimpleFromProb(monitorData);
            $("#popup_monitor_prob").hide();
            $("#popup_monitor_prob_add_mointor").hide();

            $("#monitor-prob-add-button-next").show();
            $("#monitor-prob-add-button-save").hide();
            $("#monitor_lan_add_probe2_1").hide();
            $("#monitor_lan_add_probe2_2").hide();
        });
        // $(document).on("click","#monitor-prob-add-button-next",function(){
        //  //输入账号密码点击下一步校验,传入点击的图标DOM参数，获取绑定在元素上摄像机的key
        //  doLanMonitorInputUserPass();
        // });
        // $(document).on("click","#monitor-prob-add-button-save",function(){
        //  //账号密码通过校验后的第二步流程
        //  //console.log(lanMonitorArr);
        //  var monitorData={};
        //  monitorData.Name=$("#moniter-prob-add-name").val();
        //  monitorData.User=$("#moniter-prob-add-username").val();
        //  monitorData.Pass=$("#moniter-prob-add-password").val();
        //  monitorData.IP=$("#moniter-prob-add-host").val();
        //  monitorData.Protocol=$("#moniter-prob-add-protocol").val();

        //  var lanIndex=$("#moniter-prob-add-detected-profiles").val()*1;
        //  delete lanMonitorArr[lanIndex].Name;
        //  $.extend(monitorData,lanMonitorArr[lanIndex]);
        //  showAddMonitorSimpleFromProb(monitorData);
        //  $("#popup_monitor_prob").hide();
        //  $("#popup_monitor_prob_add_mointor").hide();

        //  $("#monitor-prob-add-button-next").show();
        //  $("#monitor-prob-add-button-save").hide();
        //  $("#monitor_lan_add_probe2_1").hide();
        //  $("#monitor_lan_add_probe2_2").hide();
        // });

        //'添加'按钮
        $('#monitor_prob_btn_addprob').click(function (e) {
            showAddMonitorSimple();
            hideMonitorProb();
        });
        jQuery("#monitor_table_scroll_container").mCustomScrollbar({
            autoHideScrollbar: true,
            theme: "minimal-dark",
            scrollInertia: 200
        });

        //点击添加监视器出现弹框中，对远程协议，远程主机用户名，远程主机密码，远程主机IP，远程主机端口注册input事件，填充到远程路径中
        $("[id='simple-newMonitor[Protocol]'],[id='simple-newMonitor[User]'],[id='simple-newMonitor[Pass]'],[id='simple-newMonitor[IP]'],[id='simple-newMonitor[Port]']").on("input", function () {
            var Protocol = $("[id='simple-newMonitor[Protocol]']").val();
            var User = $("[id='simple-newMonitor[User]']").val();
            var Pass = $("[id='simple-newMonitor[Pass]']").val();
            var IP = $("[id='simple-newMonitor[IP]']").val();
            var Port = $("[id='simple-newMonitor[Port]']").val();
            if (Protocol && User && Pass && IP) {
                $("[id='simple-newMonitor[Path]']").val(Protocol + "://" + User + ":" + Pass + "@" + IP + (Port ? ":" + Port : ""));
            } else {
                $("[id='simple-newMonitor[Path]']").val("");
            }
        });


        //'搜索'输入框
        $("#monitor_ipt_search").focus(function () {
            _iptSearchFocus = true;
        });
        $("#monitor_ipt_search").blur(function () {
            _iptSearchFocus = false;
        });
        // $('#monitor_ipt_search').keyup(function(){
        // if(_monitorsOriginal.length == 0){
        // return;
        // }
        // filterMonitors(true);
        // });

        //键盘回车
        $('#wrapper_monitor').on('keydown', function (e) {
            if (!_iptSearchFocus) return;

            if (13 == e.which) { //enter
                $('#monitor_btn_search').trigger('click');
            }
        });
        //'搜索'按钮
        $('#monitor_btn_search').click(function (e) {
            e.stopPropagation();

            filterMonitors(true);
        });
        //局域网的'搜索'按钮
        $('#monitor-prob-inner-search-input').on("input", function (e) {
            //填充监控器
            //console.log(e.target.value);
            var monitorTableTr = $("#monitor_table tr");
            if (e.target.value) {
                monitorTableTr.hide();
                monitorTableTr.each(function () {
                    if ($(this).data("name").indexOf(e.target.value) >= 0) {
                        $(this).show();
                    }
                });
            } else {
                monitorTableTr.show();
            }

        });


        //右上方表格视图排版按钮
        $('.zm-btn-vm').off('click').on('click', function (e) {
            var $that = $(this);
            if ($that.hasClass('active')) return;

            $('.zm-btn-vm').removeClass('active');
            $that.addClass('active');

            _num_per_line = $that.data('ref');

            localStorage.setItem('ZM_Monitor_List_Type', _num_per_line);
            triggerMonitorListDisPlay();

            updateMonitorControllBtn(_num_per_line);

            updateMonitorSize();
        });


        // $(window).on('resize', function () {
        //     updateMonitorSize();
        // });


        //右上方slider视图视频宽高比选择
        $('#monitor_sel_ratio').on('change', function () {
            var value = $(this).val();
            if (value == '16/9') {
                _monitor_ratio = 16 / 9;
            } else if (value == '4/3') {
                _monitor_ratio = 4 / 3;
            } else if (value == '1/1') {
                _monitor_ratio = 1;
            }

            _monitorThumbSlideWidth = Math.round(_monitorThumbSlideHeight * _monitor_ratio);

            updateMonitorSize();
        });

        //右上方slider视图清晰度选择
        $('#monitor_sel_scale').on('change', function () {
            _monitors[_monitorIndex].Monitor.scale = $(this).val();
            var streamMjpegSrc = window.zm.cgiBinUrl + '?width=100%25&height=auto&mode=jpeg&maxfps=30'
                + '&scale=' + _monitors[_monitorIndex].Monitor.scale
                + '&monitor=' + _monitors[_monitorIndex].Monitor.Id
                + '&token=' + window.zm.access_token
                + '&connkey=' + _monitors[_monitorIndex].Monitor.connkey
                + '&rand=' + Math.random()
                + '&wid=' + window.zm.windowId
                + '&rnd=' + Math.random().toString(36).slice(-6);
            $('#screen_mjpeg_bigsize_' + _monitorIndex).attr('src', streamMjpegSrc);
        });


        //右上slider视图方尺寸选择
        $('#monitor_sel_size').on('change', function () {
            var value = Number($(this).val());

            updateMonitorSize();
            attachBigsizeMonitor(_monitorIndex);
        });


        doGetMonitorList(); //获取监视器列表


        /*
        ***********************************************************************
                                    翻译
        ***********************************************************************
         */
        //注册页面翻译函数
        window.addTranslationEvent(function () {
            var monitor_ipt_search_placeholder = $("#monitor_ipt_search").attr("placeholder");
            $("#monitor_ipt_search").attr("placeholder", myUNAS._(monitor_ipt_search_placeholder));

            //局域网搜索弹框 input placeholder 翻译
            var $input = $("#monitor-prob-inner-search-input");
            var placeholder2 = $input.attr("placeholder");
            $input.attr("placeholder", myUNAS._(placeholder2));

            if (myUNAS.CurrentLanguage == 'English') {
                $('.wrapper-monitor').removeClass('en').addClass('en');
                $('#monitor_btn_advance').css("width", "150px");
                $('#mointer-simple-modeBtn').css("width", "150px");
                $('#record_sel_scale').css("width", "180px");
                $('#record_sel_size').css("width", "120px");
                $('#monitor_sel_scale').css("width", "180px");

                $('.js-example-basic-single').select2({
                    minimumResultsForSearch: -1,             //移除下拉选项中的搜索框
                    dropdownCssClass: "select2OptionCss"
                });
            } else {
                $('.wrapper-monitor').removeClass('en');
            }
        });

        //执行翻译
        window.unasTranslation(myUNAS.CurrentLanguage);

        //初始化下拉框控件
        $('.js-example-basic-single').select2({
            minimumResultsForSearch: -1,             //移除下拉选项中的搜索框
            dropdownCssClass: "select2OptionCss"
        });
    }


    //编辑监视器后，更新对应的监视器
    function updateMonitorEdited(monitorObj) {
        var monitorData = {'Monitor': monitorObj, 'Monitor_Status': {}};
        for (var i = 0, len = _monitorsOriginal.length; i < len; ++i) {
            if (_monitorsOriginal[i].Monitor.Id == monitorObj.Id) {

                monitorData.Monitor.connkey = parseInt(Math.random() * 1000000);
                monitorData.Monitor.scale = _monitorsOriginal[i].Monitor.scale;
                monitorData.Monitor.isRemovedFromScreen = false;
                monitorData.Monitor.isStreamWaiting = false;
                monitorData.Monitor.lastGetStatusStartTime = 0;
                monitorData.Monitor.lastGetStatusTimer = null;

                _monitorsOriginal[i] = monitorData;
                break;
            }
        }
        _monitors[_monitorIndex] = monitorData;

        var streamMjpegSrc = window.zm.cgiBinUrl + '?width=100%25&height=auto&mode=jpeg&maxfps=30'
            + '&scale=' + monitorData.Monitor.scale
            + '&monitor=' + monitorData.Monitor.Id
            + '&token=' + window.zm.access_token
            + '&connkey=' + monitorData.Monitor.connkey
            + '&rand=' + Math.random()
            + '&wid=' + window.zm.windowId
            + '&rnd=' + Math.random().toString(36).slice(-6);
        $('#screen_mjpeg_normal_' + _monitorIndex).attr('src', streamMjpegSrc);

        //当监视器的功能选择无时，隐藏ajax转圈圈的gif和左上角图片
        if (monitorData.Monitor.Function == "None") {
            $('#screen_mjpeg_normal_' + _monitorIndex).css('display', "none");
            $('#loading-icon_' + _monitorIndex).css('display', "none");
        } else {
            $('#screen_mjpeg_normal_' + _monitorIndex).css('display', "");
            $('#loading-icon_' + _monitorIndex).css('display', "");
        }
        $('#monitor_name_' + _monitorIndex).text(monitorData.Monitor.Name);
    }


    //获取监视器列表
    function doGetMonitorList() {
        showWaiting();

        //本地调试
        /*if(_isLocalDebug){
            setTimeout(function(){
                _monitorsOriginal = generateTestMonitors(1);
                addUniqueConnkey(_monitorsOriginal);

                showListContainer();
                filterMonitors(false);
                hideWaiting();

            },1000);
            return;
        }*/


        jQuery.ajax({
            url: "/zm/api/monitors.json?token=" + window.zm.access_token,
            type: "GET",
            async: true,
            dataType: 'json',
            success: function (data) {
                if (data && data.monitors && data.monitors.length > 0) {
                    _monitorsOriginal = data.monitors;
                    addUniqueConnkey(_monitorsOriginal);
                    showListContainer();
                    filterMonitors(false);
                    window.zm._monitorsOriginal = _monitorsOriginal;
                } else {
                    showNoticeEmpty();
                }
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                showNoticeEmpty();
                console.log('monitor monitor_list error textStatus:' + textStatus);
            },
            complete: function () {
                hideWaiting();
            }
        });
    }

    function getNextMonitorIndex() {
        return _monitorsOriginal.length + 1;
    }

    //添加监视器（简单添加）
    function addSimpleMonitor() {
        var _data = JSON.stringify({
            "Name": $("[id='simple-newMonitor[Name]']").val(),
            "Protocol": $("[id='simple-newMonitor[Protocol]']").val(),
            "Method": $("[id='simple-newMonitor[Method]']").val(),
            "Type": $("[id='simple-newMonitor[Type]']").val(),
            "Host": $("[id='simple-newMonitor[User]']").val() + ":" + $("[id='simple-newMonitor[Pass]']").val() + "@" + $("[id='simple-newMonitor[IP]']").val(),
            "Port": $("[id='simple-newMonitor[Port]']").val(),
            "Path": $("[id='simple-newMonitor[Path]']").val(),
            "Width": $("[id='simple-newMonitor[Width]']").val() || 1280,
            "Height": $("[id='simple-newMonitor[Height]']").val() || 960,
            "Colours": 4,
            //默认录制视频
            "SaveJPEGs": 0,
            "VideoWriter": 2,
        });
        // console.log(_data);
        // return false;


        $.ajax({
            url: "/zm/api/monitors.json?token=" + window.zm.access_token,
            type: "POST",
            dataType: "json",
            contentType: "application/json",
            async: true,
            data: _data,
            timeout: 30000,
            success: function (data) {
                //console.log(data);

                if (data.message == "Saved") {
                    // promptShow({
                    //     text:"添加成功",                        //提示文字
                    //     width:"390px",                          //提示框宽度
                    //     height:"246px",                         //提示框高度
                    //     icon:"images/icon_success.png",         //提示图标
                    //     iconWidth:"80px",                       //提示图标的大小
                    //     iconTop:"49px",                         //提示图标距离顶部的距离
                    //     textLineHeight:"360px"                  //提示文字的行高
                    // },function(){
                    //     hideAddMonitorSimple();
                    //     update();
                    // });

                    Message.success(myUNAS._('Add Success'));
                    hideAddMonitorSimple();
                    update();
                } else {
                    // promptShow("添加失败");
                    Message.error(myUNAS._(data.message));
                }
            },
            error: function (xhr, ajaxOptions, thrownError) {
                //console.log(xhr);
                // promptShow(xhr.responseJSON.data.message);
                Message.error(xhr.responseJSON.data.message);
            }
        });
    }


    //以下函数的请求结果做一个保存
    var lanMonitorArr = [];

    //局域网搜索-操作-输入账号密码-点击下一步执行该函数
    function doLanMonitorInputUserPass() {
        var _data = {
            probe: $("#moniter-prob-add-probe").val(),
            Username: $("#moniter-prob-add-username").val(),
            Password: $("#moniter-prob-add-password").val()
        };
        $.ajax({
            url: "/zm/api/monitors/probe2.json?token=" + window.zm.access_token,
            type: "GET",
            dataType: "json",
            contentType: "application/json",
            async: true,
            data: _data,
            timeout: 30000,
            beforeSend: function () {
                $("#popup_log").show();
            },
            complete: function () {
                $("#popup_log").hide();
            },
            success: function (data) {
                //console.log(data);
                //console.log(obj);
                lanMonitorArr = [];
                if (data.length == 0) {
                    // promptShow("获取摄像头可用的流媒体失败",function(){
                    //     //$('#popup_monitor_prob_add_mointor').hide();
                    //     //$("#popup_monitor_prob").hide();
                    // });
                    Message.error(myUNAS._('Get existing stream profiles of the selected camera failed'));
                    return;
                }
                $("#monitor-prob-add-button-next").hide();
                $("#monitor-prob-add-button-pre").show();
                $("#monitor-prob-add-button-save").show();
                $("#monitor_lan_add_probe2_-2").hide();
                $("#monitor_lan_add_probe2_-1").hide();
                $("#monitor_lan_add_probe2_0").hide();
                $("#monitor_lan_add_probe2_1").show();
                $("#monitor_lan_add_probe2_2").show();

                var maxNameLength = 0;
                for (var item of Object.keys(data)) {
                    lanMonitorArr.push(data[item]);

                    //获取Name的最长值
                    if (maxNameLength < data[item].Name.length) {
                        maxNameLength = data[item].Name.length;
                    }
                }

                var selectOptions = "";

                for (var i = 0; i < lanMonitorArr.length; i++) {
                    var temp = "<tt>";
                    if (lanMonitorArr[i].Name) {
                        // temp+="["+complement("after",lanMonitorArr[i].Name,maxNameLength,"&nbsp;&nbsp;")+"]";
                        temp += "[" + lanMonitorArr[i].Name + "]";
                    }
                    if (lanMonitorArr[i].Encoding) {
                        temp += "：" + lanMonitorArr[i].Encoding + "&nbsp;&nbsp;";
                    }
                    if (lanMonitorArr[i].Width && lanMonitorArr[i].Height) {
                        // temp+="("+complement("pre",lanMonitorArr[i].Width,4,"&nbsp;&nbsp;")+"x"+complement("pre",lanMonitorArr[i].Height,4,"&nbsp;&nbsp;")+")&nbsp;&nbsp;";
                        temp += "(" + lanMonitorArr[i].Width + "x" + lanMonitorArr[i].Height + ")&nbsp;&nbsp;";
                    }
                    if (lanMonitorArr[i].MaxFPS) {
                        temp += "@" + lanMonitorArr[i].MaxFPS + " fps</tt>";
                    }
                    temp += "</tt>";
                    selectOptions += "<option value='" + i + "'>" + temp + "</option>";
                }
                $("#moniter-prob-add-detected-profiles").empty();
                $("#moniter-prob-add-detected-profiles").append(selectOptions);


            },
            error: function (xhr, ajaxOptions, thrownError) {
                //console.log(xhr);
                //console.log(ajaxOptions);
                //console.log(thrownError);
                //promptShow(xhr.responseJSON.data.message);
            }
        });
    }

    //当前是否处于表格页视图
    function isPageView() {
        return _currentView == 'page';
    }

    function updateMonitorSize() {
        getMonitorSize();
        if (isPageView()) {
            $('.monitor-thumb-page').css({'width': _monitorThumbWidth, 'height': _monitorThumbHeight, 'margin': _monitorMargin});

            //删除所有空白thumb
            //$('.monitor-thumb-empty').remove();
            //用空白thumb补全每行显示的监视器
            //attachThumbEmpty();
        } else {
            $('.monitor-thumb-slide').css({'width': _monitorThumbSlideWidth, 'height': _monitorThumbSlideHeight});
            $('.monitor-slider-view .swiper-slide').css({
                'width': _monitorThumbSlideWidth,
                'height': _monitorThumbSlideHeight
            });

            $('.monitor-thumb-bigsize').css({'width': _monitorThumbBigsizeWidth, 'height': _monitorThumbBigsizeHeight});
        }
    }

    function getMonitorSize() {
        //console.log("test");
        if (isPageView()) {
            var _width = $('.monitor-main-container').width() - 60;
            var _height = $('.monitor-main-container').height();
            //_num_per_line
            var _width2 = _width / _num_per_line;
            var _height2 = _width / _num_per_line;
            //_monitor_ratio

            // console.log(_monitor_ratio)
            // console.log(_num_per_line)
            //
            // if(_width2>=_height2){
            //     // _monitorThumbWidth=_width2;
            //     _monitorThumbHeight=_width2/_monitor_ratio;
            // }
            // else{
            //     // _monitorThumbWidth=_height2;
            //     _monitorThumbHeight=_height2/_monitor_ratio;
            //     onsole.log(_monitorThumbHeight)
            // }

            if (_num_per_line == 2) {
                _monitorThumbWidth = 'calc(50% - 2px)';
                // _monitorMargin = '1%';
                _monitorMargin = '1px';

                _monitorThumbHeight = _width * 0.48 / _monitor_ratio;
            }
            if (_num_per_line == 3) {
                _monitorThumbWidth = 'calc(33.3% - 2px)';
                // _monitorMargin = '1%';
                _monitorMargin = '1px';

                _monitorThumbHeight = _width * 0.313 / _monitor_ratio;
            }
            if (_num_per_line == 4) {
                _monitorThumbWidth = 'calc(14.28% - 2px)';
                // _monitorMargin = '1%';
                _monitorMargin = '1px';

                _monitorThumbHeight = _width * 0.1228 / _monitor_ratio;
            }

            // console.log(_monitorThumbWidth)
            var marginRight = ($('.monitor-main-container').width() - (_monitorThumbWidth * _num_per_line)) / (_num_per_line + 1) / 2;
            _monitorMarginRight = marginRight - 20;
            _monitorMarginLeft = marginRight;
            // var _width = $('.monitor-main-container').width();
            // $('#monitor_page_view').width(_width+MARGIN_RIGHT_WIDTH);
            // _monitorThumbWidth = Math.round((_width-(MARGIN_RIGHT_WIDTH*(_num_per_line-1)))/_num_per_line);
            // _monitorThumbHeight = Math.round(_monitorThumbWidth/_monitor_ratio);


        } else {
            var value = Number($('#monitor_sel_size').val());
            if (value == 0) {
                var _widthBigsize = $('#monitor_thumb_bigsize_view').width();
                var _heightBigsize = $('#monitor_thumb_bigsize_view').height();
                if (_widthBigsize / _heightBigsize >= _monitor_ratio) {
                    _monitorThumbBigsizeHeight = _heightBigsize;
                    _monitorThumbBigsizeWidth = _heightBigsize * _monitor_ratio;
                } else {
                    _monitorThumbBigsizeWidth = _widthBigsize;
                    _monitorThumbBigsizeHeight = _widthBigsize / _monitor_ratio;
                }
            } else {
                var monitorData = _monitors[_monitorIndex];
                if (monitorData) {
                    _monitorThumbBigsizeWidth = parseInt(monitorData.Monitor.Width) * value / 100;
                    _monitorThumbBigsizeHeight = parseInt(monitorData.Monitor.Height) * value / 100;
                } else {
                    var _widthBigsize = $('#monitor_thumb_bigsize_view').width();
                    var _heightBigsize = $('#monitor_thumb_bigsize_view').height();
                    if (_widthBigsize / _heightBigsize >= _monitor_ratio) {
                        _monitorThumbBigsizeHeight = _heightBigsize;
                        _monitorThumbBigsizeWidth = _heightBigsize * _monitor_ratio;
                    } else {
                        _monitorThumbBigsizeWidth = _widthBigsize;
                        _monitorThumbBigsizeHeight = _widthBigsize / _monitor_ratio;
                    }
                }
            }
        }
    }

    function filterMonitors(checkLastValue) {
        // console.log('filterMonitors')
        var value = getTrimValue('#monitor_ipt_search');
        if (checkLastValue && $("#monitor_ipt_search").data('lastValue') === value) {
            return;
        }

        //停止所有监视器的状态轮询请求
        stopGetStatus();

        if (value) {
            var arr = [];
            for (var i = 0, len = _monitorsOriginal.length; i < len; ++i) {
                if (_monitorsOriginal[i].Monitor.Name.indexOf(value) != -1) {
                    arr.push(_monitorsOriginal[i]);
                }
            }
            _monitors = arr; //用于显示的列表数据
        } else {
            _monitors = _monitorsOriginal; //用于显示的列表数据
        }

        $("#monitor_ipt_search").data('lastValue', value);

        // rnd 用于后台 kill 掉当前不显示的视频流
        var rnd = Math.random().toString(36).slice(-6);
        //根据当前所处的视图，填充对应的监视器列表
        if (isPageView()) {
            attachMonitors(_monitors, rnd);
        } else {
            attachSlideMonitors(_monitors);
        }
    }


    function showListContainer() {
        $('#monitor_page_view').show();
        $('#monitor_slider_view').hide();
        $('#monitor_notice_empty').hide();
        $('#wrapper_monitor').show();
    }

    function showNoticeEmpty() {
        $('#monitor_page_view').hide();
        $('#monitor_slider_view').hide();
        $('#monitor_notice_empty').show();
        $('#wrapper_monitor').fadeIn(400);

        //点击'添加'文本
        $('.monitor-notice-text .strong').click(function () {
            showAddMonitorSimple();
        });
    }

    //选择4宫格，9宫格16宫格后对应缩小控制面板按钮的比例
    function updateMonitorControllBtn(_num_per_line) {
        $(".control-panel-container").removeClass("control-panel-container1-9 control-panel-container1-16");
        $(".control-panel-container button").removeClass("zm-btn-media1-9 zm-btn-media1-16");
        $(".monitor-thumb .control-panel-status").removeClass("control-panel-status1-9 control-panel-status1-16");
        $(".monitor-thumb .name-container").removeClass("name-container1-9");
        $(".monitor-thumb .control-container").removeClass("control-container1-9");

        if (_num_per_line == 3) {
            $(".control-panel-container").addClass("control-panel-container1-9");
            $(".control-panel-container button").addClass("zm-btn-media1-9");
            $(".monitor-thumb .control-panel-status").addClass("control-panel-status1-9");
            $(".monitor-thumb .name-container").addClass("name-container1-9");
            $(".monitor-thumb .control-container").addClass("control-container1-9");
        } else if (_num_per_line == 4) {
            $(".control-panel-container").addClass("control-panel-container1-16");
            $(".control-panel-container button").addClass("zm-btn-media1-16");
            $(".monitor-thumb .control-panel-status").addClass("control-panel-status1-16");
            $(".monitor-thumb .name-container").addClass("name-container1-9");
            $(".monitor-thumb .control-container").addClass("control-container1-9");
        }
    }

    //===================================================================================
    //监视器表格页视图
    //===================================================================================
    //显示监视器表格页视图
    function showMonitorPageView() {
        clearSliderView();

        $('#monitor_page_view').show();
        $('#monitor_slider_view').hide();
        $('#monitor_notice_empty').hide();

        $('.monitor-view-model-container').show();
        $('.monitor-stream-setting-container').hide();

        _currentView = 'page';

        filterMonitors(false);
    }

    function clearPageView() {
        //停止所有监视器的状态轮询请求
        stopGetStatus();

        removeEvents();
        $('#monitor_list').empty();
    }

    function attachMonitors(monitors, rnd) {
        // console.log('attachMonitors')
        getMonitorSize();

        var $monitorList = $('#monitor_list');
        var $monitorListGrid = $('#monitor_list_grid');

        removeEvents();
        $monitorList.empty();
        $monitorListGrid.empty();


        var str = '';
        for (var i = 0; i < monitors.length; i++) {
            var item = monitors[i];
            // console.log(item)
            if (monitors[i].Monitor.isRemovedFromScreen) continue;

            var func = myUNAS._('Fn' + item.Monitor.Function);
            var status = item.Monitor_Status.Status ? myUNAS._('Status' + item.Monitor_Status.Status) : myUNAS._('StatusUnknown');

            var statusInfo = item.Monitor_Status.Status == 'Connected' ? 'infoText' : 'warningText'

            var fps_string = '';
            if (item.Monitor_Status.CaptureFPS) {
                fps_string += item.Monitor_Status.CaptureFPS;
            }
            if (item.Monitor_Status.AnalysisFPS && (item.Monitor.Function == 'Mocord' || item.Monitor.Function == 'Modect')) {
                fps_string += '/' / item.Monitor_Status.AnalysisFPS;
            }
            if (fps_string != '') {
                fps_string += ' fps';
            }

            fps_string += ' ' + humanFilesize(item.Monitor_Status.CaptureBandwidth) + '/s';

            var img = '';
            if (item.Monitor.SrcInfo != undefined) {
                var SrcInfo = item.Monitor.SrcInfo;
                var src = SrcInfo.src + '&token=' + window.zm.access_token + '&connkey=' + monitors[i].Monitor.connkey;
                img = '<img data-id="'+ item.Monitor.Id +'" class="item-img" src="' + src + '" still_src="' + SrcInfo.still_src + '" stream_src="' + SrcInfo.stream_src + '" loading="lazy">';
            } else {
                img = '<img data-id="'+ item.Monitor.Id +'" class="item-img" src="" loading="lazy">';
            }

            str += '<div class="monitor-item monitor-thumb-stuffed" id="monitor_thumb_page_' + i + '">' +
                        '<div class="item-li">' +
                            '' + img + '' +
                            '<div class="item-info">' +
                                '<span>' + item.Monitor.Name + '</span>' +
                                '<span>' + item.Monitor.Source + '</span>' +
                            '</div>' +
                                '</div>' +
                            '<div class="item-li">'+myUNAS._('Status：')+'' + status + ' | Mode：' + func + ' </div>' +
                            '<div class="item-li">' +
                                '<div class="status">' +
                                    '<div class="status-li"><span class="dot ' + statusInfo + '"></span>'+myUNAS._('Status：')+'' + status + '</div>' +
                                    '<div class="status-li">' + fps_string + '</div>' +
                                '</div>' +
                                '<div class="handle">' +
                                    '<img class="edit control-item-edit" data-ref="' + i + '" src="img/edit_icon.png" alt="">' +
                                    '<img class="delete control-item-remove" data-ref="' + i + '" src="img/delete_icon.png" alt="">' +
                            '</div>' +
                        '</div>' +
                    '</div>';
        }


        var str1 = '';
        var strEdit = myUNAS._('Edit');
        var strBigsize = myUNAS._('Preview');
        var strRemove = myUNAS._('Delete');
        var strStatus = myUNAS._('Status：');
        //console.log(strStatus);
        for (var i = 0, len = monitors.length; i < len; ++i) {
            // console.log(monitors[i])
            //不显示已经删除的monitor
            if (monitors[i].Monitor.isRemovedFromScreen) continue;

            str1 += '<div class="monitor-thumb monitor-thumb-page monitor-thumb-stuffed" id="monitor_thumb_page_' + i + '" style="width:' + _monitorThumbWidth + '; height:' + _monitorThumbHeight + 'px;margin:' + _monitorMargin + '">';
            str1 += '<div class="placeholder-container hide" data-ref="' + i + '">';
            str1 += '<div class="rect"></div>';
            str1 += '<div class="rect rect-vert"></div>';
            str1 += '</div>';

            str1 += '<div class="monitor-container">';
            if (monitors[i].Monitor.Function == "None") {
                str1 += '<img class="loading-icon" id="loading-icon_' + i + '" src="./images/ajax-loader.gif?v=6.0.30&" style="display:none">';
            } else {
                str1 += '<img class="loading-icon" id="loading-icon_' + i + '" src="./images/ajax-loader.gif?v=6.0.30&">';
            }
            str1 += '<div class="screen-container flex-center">';
            // /zm/cgi-bin/nph-zms?width=100%25&height=auto&mode=jpeg&maxfps=30&monitor=1&token=dd4c003b31a766ed544c077620f2d0c2&connkey=923920&rand=1626659658
            var streamMjpegSrc = window.zm.cgiBinUrl + '?width=' + monitors[i].Monitor.Width + '&height=' + monitors[i].Monitor.Height + '&mode=single&maxfps=30'
                + '&scale=100&monitor=' + monitors[i].Monitor.Id
                + '&token=' + window.zm.access_token
                + '&connkey=' + monitors[i].Monitor.connkey
                + '&rand=' + Math.random()
                + '&wid=' + window.zm.windowId
                + '&rnd=' + rnd;
            if (monitors[i].Monitor.Function == "None") {
                str1 += '<img class="screen-mjpeg" id="screen_mjpeg_normal_' + i + '" data-ref="' + i + '" src="' + streamMjpegSrc + '" style="display:none" />';
            } else {
                str1 += '<img class="screen-mjpeg" id="screen_mjpeg_normal_' + i + '" data-ref="' + i + '" src="' + streamMjpegSrc + '" />';
            }

            str1 += '</div>';

            str1 += '<div class="name-container hide" id="monitor_name_' + i + '">' + monitors[i].Monitor.Name + '</div>';

            str1 += '<div class="control-container hide">';
            str1 += '<div class="icon-control-list"></div>';
            str1 += '<div class="control-list hide">';
            str1 += '<div class="control-item control-item-edit" data-ref="' + i + '" id="control_item_edit_' + i + '">' + strEdit + '</div>';
            str1 += '<div class="control-item control-item-bigsize" data-id="'+_monitors[i].Monitor.Id+'" data-ref="' + i + '" id="control_item_bigsize_' + i + '">' + strBigsize + '</div>';
            str1 += '<div class="control-item control-item-remove" data-ref="' + i + '" id="control_item_remove_' + i + '">' + strRemove + '</div>';
            str1 += '</div>';
            str1 += '</div>';

            // str1 += '<div class="control-panel-container hide">';
            // str1 += '<div class="control-panel">';
            // str1 += '<button title="快退" class="zm-btn-media zm-btn-media-back inactive" id="zm_btn_media_back_'+i+'" data-ref="'+i+'"></button>';
            // str1 += '<button title="单步后退" class="zm-btn-media zm-btn-media-last inactive" id="zm_btn_media_last_'+i+'" data-ref="'+i+'"></button>';
            // str1 += '<button title="暂停" class="zm-btn-media zm-btn-media-pause inactive" id="zm_btn_media_pause_'+i+'" data-ref="'+i+'"></button>';
            // str1 += '<button title="停止" class="zm-btn-media zm-btn-media-stop inactive" id="zm_btn_media_stop_'+i+'" data-ref="'+i+'"></button>';
            // str1 += '<button title="播放" class="zm-btn-media zm-btn-media-play inactive" id="zm_btn_media_play_'+i+'" data-ref="'+i+'"></button>';
            // str1 += '<button title="单步前进" class="zm-btn-media zm-btn-media-next inactive" id="zm_btn_media_next_'+i+'" data-ref="'+i+'"></button>';
            // str1 += '<button title="快进" class="zm-btn-media zm-btn-media-fastforward inactive" id="zm_btn_media_fastforward_'+i+'" data-ref="'+i+'"></button>';
            // str1 += '<button title="缩小" class="zm-btn-media zm-btn-media-zoomout inactive" id="zm_btn_media_zoomout_'+i+'" data-ref="'+i+'"></button>';
            // str1 += '</div>';
            // str1 += '<div class="control-panel-status" id="cp_status_'+i+'">'+strStatus+'</div>';
            // str1 += '</div>';
            str1 += '</div>';
            str1 += '</div>';
        }

        $monitorList.append(str);
        $monitorListGrid.append(str1);

        // console.log($('.monitor-thumb-page').width());

        triggerMonitorListDisPlay();

        addEvents('.monitor-thumb-stuffed');

        updateMonitorControllBtn($(".zm-btn-vm.active").data("ref"));

        //用空白thumb补全每行显示的监视器
        //attachThumbEmpty();

        //开始所有监视器的状态轮询请求
        // startGetStatus();
    }

    function triggerMonitorListDisPlay() {
        var $monitorList = $('#monitor_list');
        var $monitorListGrid = $('#monitor_list_grid');

        var list_type = localStorage.getItem('ZM_Monitor_List_Type');
        var type;
        if (list_type == 1 || list_type == undefined) {
            $monitorList.show();
            $monitorListGrid.hide();
            type = 1;
        } else {
            $monitorList.hide();
            $monitorListGrid.show();
            type = list_type;
        }

        //设置选中
        $('.zm-btn-vm').removeClass('active');
        $('.zm-btn-vm').each(function (k, v) {
            if ($(v).data('ref') == type) {
                $(v).addClass('active');
            }
        })
    }

    function humanFilesize(size, precision = 2) {
        var units = Array('B', 'kB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB');
        var step = 1024;
        var i = 0;
        while ((size / step) > 0.9) {
            size = size / step;
            i++;
        }
        return (Math.round(size * (10 ^ precision)) / (10 ^ precision)) + units[i];
    }

    //用空白thumb补全每行显示的监视器
    function attachThumbEmpty() {
        var str = '';
        var strEdit = myUNAS._('编辑');
        var strBigsize = myUNAS._('预览');
        var strRemove = myUNAS._('删除');
        var strStatus = myUNAS._('状态：');

        var index = _monitors.length;
        str += '<div class="monitor-thumb monitor-thumb-page monitor-thumb-empty" id="monitor_thumb_page_' + index + '" style="width:' + _monitorThumbWidth + 'px; height:' + _monitorThumbHeight + 'px">';
        str += '<div class="placeholder-container" data-ref="' + index + '">';
        str += '<div class="rect"></div>';
        str += '<div class="rect rect-vert"></div>';
        str += '</div>';

        str += '<div class="monitor-container hide">';
        str += '<img class="loading-icon" src="./images/ajax-loader.gif?v=6.0.30&">';
        str += '<div class="screen-container flex-center">';
        str += '<img class="screen-mjpeg" data-ref="' + index + '" />';
        str += '</div>';
        str += '<div class="control-container hide">';
        str += '<div class="icon-control-list"></div>';
        str += '<div class="control-list hide">';
        str += '<div class="control-item control-item-edit" data-ref="' + index + '" id="control_item_edit_' + index + '">' + strEdit + '</div>';
        str += '<div class="control-item control-item-bigsize" data-id="'+_monitors[i].Monitor.Id+'" data-ref="' + index + '" id="control_item_bigsize_' + index + '">' + strBigsize + '</div>';
        str += '<div class="control-item control-item-remove" data-ref="' + index + '" id="control_item_remove_' + index + '">' + strRemove + '</div>';
        str += '</div>';
        str += '</div>';
        str += '<div class="control-panel-container hide">';
        str += '<div class="control-panel">';
        str += '<button title="快退" class="zm-btn-media zm-btn-media-back inactive" id="zm_btn_media_back_' + i + '" data-ref="' + i + '"></button>';
        str += '<button title="单步后退" class="zm-btn-media zm-btn-media-last inactive" id="zm_btn_media_last_' + i + '" data-ref="' + i + '"></button>';
        str += '<button title="暂停" class="zm-btn-media zm-btn-media-pause inactive" id="zm_btn_media_pause_' + i + '" data-ref="' + i + '"></button>';
        str += '<button title="停止" class="zm-btn-media zm-btn-media-stop inactive" id="zm_btn_media_stop_' + i + '" data-ref="' + i + '"></button>';
        str += '<button title="播放" class="zm-btn-media zm-btn-media-play inactive" id="zm_btn_media_play_' + i + '" data-ref="' + i + '"></button>';
        str += '<button title="单步前进" class="zm-btn-media zm-btn-media-next inactive" id="zm_btn_media_next_' + i + '" data-ref="' + i + '"></button>';
        str += '<button title="快进" class="zm-btn-media zm-btn-media-fastforward inactive" id="zm_btn_media_fastforward_' + i + '" data-ref="' + i + '"></button>';
        str += '<button title="缩小" class="zm-btn-media zm-btn-media-zoomout inactive" id="zm_btn_media_zoomout_' + index + '" data-ref="' + index + '"></button>';
        str += '</div>';
        str += '<div class="control-panel-status" id="cp_status_' + index + '">' + strStatus + '</div>';
        str += '</div>';
        str += '</div>';
        str += '</div>';

        // $('#monitor_list').append(str);
        addEvents('.monitor-thumb-empty');
    }

    //===================================================================================


    function addEvents(cssSelecter) {
        $(cssSelecter).mouseenter(function () {
            $(this).find('.name-container').show();
            $(this).find('.control-container').show();
            $(this).find('.control-panel-container').show();
        });
        $(cssSelecter).mouseleave(function () {
            $(this).find('.name-container').hide();
            $(this).find('.control-container').hide();
            $(this).find('.control-list').hide();
            $(this).find('.control-panel-container').hide();
        });

        //空thumb
        $(cssSelecter + ' .placeholder-container').click(function () {
            showAddMonitorSimple();
        });


        //右上方'...'
        $(cssSelecter + ' .icon-control-list').click(function () {
            $(this).siblings('.control-list').toggle();
        });
        //右上方下拉菜单'编辑'
        $(cssSelecter + ' .control-item-edit').click(function () {
            var index = $(this).data('ref');
            //console.log('edit index:'+index);

            _monitorIndex = index;
            var comprehensiveData = _monitors[_monitorIndex];
            showEditMonitorComprehensive(comprehensiveData);
        });
        //右上方下拉菜单'预览'
        $(cssSelecter + ' .control-item-bigsize').click(function () {
            var id = $(this).data('id');
            previewMonitor(id)
        });

        $('.item-img').off('click').on('click', function() {
            var id = $(this).data('id');
            previewMonitor(id)
        })

        //右上方下拉菜单'返回'
        $(cssSelecter + ' .control-item-back').click(function () {
            var index = $(this).data('ref');
            //console.log('back index:'+index);

            _monitorIndex = -1;
            showMonitorPageView();
        });
        //右上方下拉菜单'删除'
        $(cssSelecter + ' .control-item-remove').click(function () {
            var index = $(this).data('ref');
            //console.log('remove index:'+index);

            //发起删除监视器请求
            //console.log(_monitors[index].Monitor.Id);
            showConfirmDelete(function () {
                var monitorId = _monitors[index].Monitor.Id;
                deleteMointor(monitorId, function () {
                    if (_monitors[index].Monitor.lastGetStatusTimer) {
                        clearTimeout(_monitors[index].Monitor.lastGetStatusTimer);
                        _monitors[index].Monitor.lastGetStatusTimer = null;
                    }
                    _monitors[index].Monitor.isRemovedFromScreen = true;


                    if (isPageView()) {
                        $('#monitor_list').find('#monitor_thumb_page_' + index).remove();
                        $('#monitor_list_grid').find('#monitor_thumb_page_' + index).remove();

                        if ($('#monitor_list').children().length == 0 || $('#monitor_list_grid').children().length == 0) {
                            setTimeout(function() {
                                window.location.reload();
                            }, 1000)
                        }
                        //删除所有空白thumb
                        //$('.monitor-thumb-empty').remove();

                        //用空白thumb补全每行显示的监视器
                        //attachThumbEmpty();
                    } else {
                        showMonitorPageView();
                    }
                });
            });

        });


        //zoomin'流静帧'（点击'流静帧'，在点击处zoomin）
        $(cssSelecter + ' .screen-mjpeg').click(function (e) {
            var index = $(this).data('ref');
            //console.log('zoomin mjpeg index:'+index);
            //console.log('e.offsetX:'+e.offsetX+' e.offsetY:'+e.offsetY);
            doZoominStreamMjpeg(index, e.offsetX, e.offsetY);
        });
        //zoomout'流静帧'
        $(cssSelecter + ' .zm-btn-media-zoomout').click(function (e) {
            var $that = $(this);
            if ($that.hasClass('active') || $that.hasClass('inactive')) return;

            var index = $that.data('ref');
            //console.log('zoomout mjpeg index:'+index);
            doZoomoutStreamMjpeg(index);
        });

        //pause'流静帧'
        $(cssSelecter + ' .zm-btn-media-pause').click(function (e) {
            var $that = $(this);
            if ($that.hasClass('active') || $that.hasClass('inactive')) return;

            var index = $that.data('ref');
            //console.log('pause mjpeg index:'+index);
            doPauseStreamMjpeg(index);
        });

        //stop'流静帧',停止（功能暂时与暂停一致）
        $(cssSelecter + ' .zm-btn-media-stop').click(function (e) {
            var $that = $(this);
            if ($that.hasClass('active') || $that.hasClass('inactive')) return;

            var index = $that.data('ref');
            //console.log('pause mjpeg index:'+index);
            doPauseStreamMjpeg(index);
        });

        //play'流静帧'
        $(cssSelecter + ' .zm-btn-media-play').click(function (e) {
            var $that = $(this);
            if ($that.hasClass('active') || $that.hasClass('inactive')) return;

            var index = $that.data('ref');
            //console.log('play mjpeg index:'+index);
            doPlayStreamMjpeg(index);
        });

        //back'流静帧',快退
        $(cssSelecter + ' .zm-btn-media-back').click(function (e) {
            var $that = $(this);
            if ($that.hasClass('inactive')) return;

            var index = $that.data('ref');
            //console.log('play mjpeg index:'+index);
            doBackStreamMjpeg(index);
        });

        //last'流静帧',单步后退
        $(cssSelecter + ' .zm-btn-media-last').click(function (e) {
            var $that = $(this);
            if ($that.hasClass('inactive')) return;

            var index = $that.data('ref');
            //console.log('play mjpeg index:'+index);
            doLastStreamMjpeg(index);
        });

        //next'流静帧',单步前进
        $(cssSelecter + ' .zm-btn-media-next').click(function (e) {
            var $that = $(this);
            if ($that.hasClass('inactive')) return;

            var index = $that.data('ref');
            //console.log('play mjpeg index:'+index);
            doNextStreamMjpeg(index);
        });

        //fastforward'流静帧',快进
        $(cssSelecter + ' .zm-btn-media-fastforward').click(function (e) {
            var $that = $(this);
            if ($that.hasClass('inactive')) return;

            var index = $that.data('ref');
            //console.log('play mjpeg index:'+index);
            doFastForwardStreamMjpeg(index);
        });

        //上一个下一个
        var currMonitor = $();
        $(cssSelecter + ' .zm-btn-media-previous-event').click(function (e) {
            $(".monitor-thumb.monitor-thumb-slide").each(function () {
                if ($(this).hasClass("active")) {
                    currMonitor.trigger("click");
                    return false;
                }
                currMonitor = $(this);
            })
        });
        $(cssSelecter + ' .zm-btn-media-next-event').click(function (e) {
            $(".monitor-thumb.monitor-thumb-slide").each(function (index) {
                if ($(this).hasClass("active")) {
                    $($(".monitor-thumb.monitor-thumb-slide")[index + 1]).trigger("click");
                    return false;
                }
            })
        });
    }

    function previewMonitor(id)
    {
        localStorage.setItem('ZM_Monitor_Select_Monitor_Id', id);
        var $mainContainer = $('#main_container');

        var page = 'event';
        var $leftTabs = $(".left-tab");
        $leftTabs.removeClass('active');
        $leftTabs.filter("[data-ref='"+page+"']").addClass('active');

        $mainContainer.load(page+'.html', function(response, status, xhr){
            window.zm.init[page]();
        });
    }

    function removeEvents() {
        $('.zm-btn-media-pause').off();
        $('.zm-btn-media-play').off();
        $('.zm-btn-media-zoomout').off();
        $('.screen-mjpeg').off();

        $('.icon-control-list').off();
        $('.control-item-edit').off();
        $('.control-item-bigsize').off();
        $('.control-item-back').off();
        $('.control-item-remove').off();

        $('.monitor-thumb').off();
        $('.placeholder-container').off();
    }

    // play'流静帧'（command=2）
    // /zm/index.php?view=request&request=stream&connkey=153831&token=f0a3a89dbc50b6bb5d709c231117f036&command=2
    function doPlayStreamMjpeg(dataIndex) {
        var monitorData = _monitors[dataIndex];
        if (monitorData.Monitor.isStreamWaiting) return;

        //console.log('command-2 connkey:'+monitorData.Monitor.connkey);

        monitorData.Monitor.isStreamWaiting = true;
        var reqUrl = window.zm.streamUrl + '?view=request&request=stream' +
            '&connkey=' + monitorData.Monitor.connkey +
            '&token=' + window.zm.access_token +
            '&command=2';
        jQuery.ajax({
            url: reqUrl,
            type: "GET",
            async: true,
            dataType: 'json',
            success: function (data) {
                if (data.result && data.result.toLowerCase() == 'ok') {
                    if (data.status) {
                        updateMonitorStatus(dataIndex, data.status);
                    }
                } else {
                    //console.log('monitor stream_mjpeg play failed');
                }
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                //console.log('monitor stream_mjpeg play error textStatus:' + textStatus);
            },
            complete: function () {
                monitorData.Monitor.isStreamWaiting = false;
            }
        });
    }

    // pause'流静帧'（command=1）
    // /zm/index.php?view=request&request=stream&connkey=153831&token=f0a3a89dbc50b6bb5d709c231117f036&command=1
    function doPauseStreamMjpeg(dataIndex) {
        var monitorData = _monitors[dataIndex];
        if (monitorData.Monitor.isStreamWaiting) return;

        //console.log('command-1 connkey:'+monitorData.Monitor.connkey);

        monitorData.Monitor.isStreamWaiting = true;
        var reqUrl = window.zm.streamUrl + '?view=request&request=stream' +
            '&connkey=' + monitorData.Monitor.connkey +
            '&token=' + window.zm.access_token +
            '&command=1';
        jQuery.ajax({
            url: reqUrl,
            type: "GET",
            async: true,
            dataType: 'json',
            success: function (data) {
                if (data.result && data.result.toLowerCase() == 'ok') {
                    if (data.status) {
                        updateMonitorStatus(dataIndex, data.status);
                    }
                } else {
                    //console.log('monitor stream_mjpeg pause failed');
                }
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                //console.log('monitor stream_mjpeg pause error textStatus:' + textStatus);
            },
            complete: function () {
                monitorData.Monitor.isStreamWaiting = false;
            }
        });
    }


    // zoomout'流静帧'（command=9）
    // /zm/index.php?view=request&request=stream&connkey=153831&token=f0a3a89dbc50b6bb5d709c231117&command=9
    function doZoomoutStreamMjpeg(dataIndex) {
        var monitorData = _monitors[dataIndex];
        if (monitorData.Monitor.isStreamWaiting) return;

        monitorData.Monitor.isStreamWaiting = true;
        var reqUrl = window.zm.streamUrl + '?view=request&request=stream' +
            '&connkey=' + monitorData.Monitor.connkey +
            '&token=' + window.zm.access_token +
            '&command=9';
        jQuery.ajax({
            url: reqUrl,
            type: "GET",
            async: true,
            dataType: 'json',
            success: function (data) {
                if (data.result && data.result.toLowerCase() == 'ok') {
                    if (data.status) {
                        updateMonitorStatus(dataIndex, data.status);
                    }
                } else {
                    //console.log('monitor stream_mjpeg zoomout failed');
                }
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                //console.log('monitor stream_mjpeg zoomout error textStatus:' + textStatus);
            },
            complete: function () {
                monitorData.Monitor.isStreamWaiting = false;
            }
        });
    }

    function doBackStreamMjpeg(dataIndex) {
        var monitorData = _monitors[dataIndex];
        if (monitorData.Monitor.isStreamWaiting) return;

        //console.log('command-2 connkey:'+monitorData.Monitor.connkey);

        monitorData.Monitor.isStreamWaiting = true;
        var reqUrl = window.zm.streamUrl + '?view=request&request=stream' +
            '&connkey=' + monitorData.Monitor.connkey +
            '&token=' + window.zm.access_token +
            '&command=7';
        jQuery.ajax({
            url: reqUrl,
            type: "GET",
            async: true,
            dataType: 'json',
            success: function (data) {
                if (data.result && data.result.toLowerCase() == 'ok') {
                    if (data.status) {
                        updateMonitorStatus(dataIndex, data.status);
                    }
                } else {
                    //console.log('monitor stream_mjpeg play failed');
                }
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                //console.log('monitor stream_mjpeg play error textStatus:' + textStatus);
            },
            complete: function () {
                monitorData.Monitor.isStreamWaiting = false;
            }
        });
    }

    function doLastStreamMjpeg(dataIndex) {
        var monitorData = _monitors[dataIndex];
        if (monitorData.Monitor.isStreamWaiting) return;

        //console.log('command-2 connkey:'+monitorData.Monitor.connkey);

        monitorData.Monitor.isStreamWaiting = true;
        var reqUrl = window.zm.streamUrl + '?view=request&request=stream' +
            '&connkey=' + monitorData.Monitor.connkey +
            '&token=' + window.zm.access_token +
            '&command=6';
        jQuery.ajax({
            url: reqUrl,
            type: "GET",
            async: true,
            dataType: 'json',
            success: function (data) {
                //console.log(data);
                if (data.result && data.result.toLowerCase() == 'ok') {
                    if (data.status) {
                        updateMonitorStatus(dataIndex, data.status);
                    }
                } else {
                    //console.log('monitor stream_mjpeg play failed');
                }
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                //console.log('monitor stream_mjpeg play error textStatus:' + textStatus);
            },
            complete: function () {
                monitorData.Monitor.isStreamWaiting = false;
            }
        });
    }

    function doNextStreamMjpeg(dataIndex) {
        var monitorData = _monitors[dataIndex];
        if (monitorData.Monitor.isStreamWaiting) return;

        //console.log('command-2 connkey:'+monitorData.Monitor.connkey);

        monitorData.Monitor.isStreamWaiting = true;
        var reqUrl = window.zm.streamUrl + '?view=request&request=stream' +
            '&connkey=' + monitorData.Monitor.connkey +
            '&token=' + window.zm.access_token +
            '&command=5';
        jQuery.ajax({
            url: reqUrl,
            type: "GET",
            async: true,
            dataType: 'json',
            success: function (data) {
                if (data.result && data.result.toLowerCase() == 'ok') {
                    if (data.status) {
                        updateMonitorStatus(dataIndex, data.status);
                    }
                } else {
                    //console.log('monitor stream_mjpeg play failed');
                }
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                //console.log('monitor stream_mjpeg play error textStatus:' + textStatus);
            },
            complete: function () {
                monitorData.Monitor.isStreamWaiting = false;
            }
        });
    }

    function doFastForwardStreamMjpeg(dataIndex) {
        var monitorData = _monitors[dataIndex];
        if (monitorData.Monitor.isStreamWaiting) return;

        //console.log('command-2 connkey:'+monitorData.Monitor.connkey);

        monitorData.Monitor.isStreamWaiting = true;
        var reqUrl = window.zm.streamUrl + '?view=request&request=stream' +
            '&connkey=' + monitorData.Monitor.connkey +
            '&token=' + window.zm.access_token +
            '&command=4';
        jQuery.ajax({
            url: reqUrl,
            type: "GET",
            async: true,
            dataType: 'json',
            success: function (data) {
                if (data.result && data.result.toLowerCase() == 'ok') {
                    if (data.status) {
                        updateMonitorStatus(dataIndex, data.status);
                    }
                } else {
                    //console.log('monitor stream_mjpeg play failed');
                }
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                //console.log('monitor stream_mjpeg play error textStatus:' + textStatus);
            },
            complete: function () {
                monitorData.Monitor.isStreamWaiting = false;
            }
        });
    }


    // zoomin'流静帧'（command=8）
    // /zm/index.php?view=request&request=stream&connkey=153831&token=f0a3a89dbc50b6bb5d709c231117f036&command=8&x=182&y=149
    function doZoominStreamMjpeg(dataIndex, offsetX, offsetY) {
        var monitorData = _monitors[dataIndex];
        if (monitorData.Monitor.isStreamWaiting) return;

        monitorData.Monitor.isStreamWaiting = true;
        var reqUrl = window.zm.streamUrl + '?view=request&request=stream' +
            '&connkey=' + monitorData.Monitor.connkey +
            '&token=' + window.zm.access_token +
            '&command=8&x=' + offsetX + '&y=' + offsetY;
        jQuery.ajax({
            url: reqUrl,
            type: "GET",
            async: true,
            dataType: 'json',
            success: function (data) {
                if (data.result && data.result.toLowerCase() == 'ok') {
                    if (data.status) {
                        updateMonitorStatus(dataIndex, data.status);
                    }
                } else {
                    //console.log('monitor stream_mjpeg zoomin failed');
                }
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                //console.log('monitor stream_mjpeg zoomin error textStatus:' + textStatus);
            },
            complete: function () {
                monitorData.Monitor.isStreamWaiting = false;
            }
        });
    }


    //停止所有监视器的状态轮询请求
    function stopGetStatus() {
        _forceStopStatusTimer = true;
        if (_startGetStatusTimer) {
            clearTimeout(_startGetStatusTimer);
        }

        for (var i = 0, len = _monitors.length; i < len; ++i) {
            clearTimeout(_monitors[i].Monitor.lastGetStatusTimer);
            _monitors[i].Monitor.lastGetStatusTimer = null;
        }
    }

    //开始所有监视器的状态轮询请求
    function startGetStatus() {
        _startGetStatusTimer = setTimeout(function () {
            _forceStopStatusTimer = false;

            for (var i = 0, len = _monitors.length; i < len; ++i) {
                doGetStatusMjpeg(i);
            }
        }, REFRESH_INTERVAL);
    }

    // get_status'流静帧'（command=99）
    // /zm/index.php?view=request&request=stream&connkey=153831&token=f0a3a89dbc50b6bb5d709c231117f036&command=99
    function doGetStatusMjpeg(dataIndex) {
        var monitorData = _monitors[dataIndex];
        if (monitorData.Monitor.isRemovedFromScreen) return; //已被删除的monitor，不再继续更新状态显示

        //console.log('command-99 connkey:'+monitorData.Monitor.connkey);

        //记录请求发起事件
        monitorData.Monitor.lastGetStatusStartTime = new Date().getTime();
        var reqUrl = window.zm.streamUrl + '?view=request&request=stream' +
            '&connkey=' + monitorData.Monitor.connkey +
            '&token=' + window.zm.access_token +
            '&command=99';
        jQuery.ajax({
            url: reqUrl,
            type: "GET",
            async: true,
            timeout: 10000,
            dataType: 'json',
            success: function (data) {
                if (data.result && data.result.toLowerCase() == 'ok') {
                    if (data.status) {
                        updateMonitorStatus(dataIndex, data.status);
                    }
                } else {
                    //console.log('monitor stream_mjpeg get_status failed');
                }
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                //console.log('monitor stream_mjpeg get_status error textStatus:' + textStatus);
            },
            complete: function () {
                if (_forceStopStatusTimer) return;

                var endTime = new Date().getTime();
                var timeout = endTime - monitorData.Monitor.lastGetStatusStartTime;
                if (timeout > REFRESH_INTERVAL) {
                    // doGetStatusMjpeg(dataIndex);
                } else {
                    monitorData.Monitor.lastGetStatusTimer = setTimeout(function () {
                        if (!_forceStopStatusTimer) {
                            // doGetStatusMjpeg(dataIndex);
                        }
                    }, REFRESH_INTERVAL - timeout);
                }
            }
        });
    }

    //{"type":2,"monitor":1,"state":0,"fps":26.71,"level":0,"rate":1,"delay":1414.09,"zoom":1.5,"delayed":0,"paused":1,"enabled":1,"forced":0}
    function updateMonitorStatus(dataIndex, statusData) {
        var str = '';
        str += myUNAS._('状态：') + getStateStr(statusData.state) + '　|　';
        str += statusData.fps + 'fps' + '　|　';
        str += myUNAS._('模式：') + getModeStr(statusData.paused) + '　|　';
        if (statusData.paused) {
            //延迟秒数只在暂停后显示
            str += myUNAS._('延迟：') + getLastTimeStr(statusData.delay) + '　|　';
        }
        str += myUNAS._('缩放：') + statusData.zoom + 'X';


        var key;
        if (isPageView()) {
            key = '';
        } else {
            key = '_bigsize';
        }

        $('#cp_status' + key + '_' + dataIndex).html(str);

        //重置所有底部流操作按钮状态
        $('#zm_btn_media_back' + key + '_' + dataIndex).removeClass('active, inactive');
        $('#zm_btn_media_last' + key + '_' + dataIndex).removeClass('active, inactive');
        $('#zm_btn_media_pause' + key + '_' + dataIndex).removeClass('active, inactive');
        $('#zm_btn_media_stop' + key + '_' + dataIndex).removeClass('active, inactive');
        $('#zm_btn_media_play' + key + '_' + dataIndex).removeClass('active, inactive');
        $('#zm_btn_media_next' + key + '_' + dataIndex).removeClass('active, inactive');
        $('#zm_btn_media_fastforward' + key + '_' + dataIndex).removeClass('active, inactive');
        $('#zm_btn_media_zoomout' + key + '_' + dataIndex).removeClass('active, inactive');

        //如果没有缩放
        if (Number(statusData.zoom) == 1) {
            $('#zm_btn_media_zoomout' + key + '_' + dataIndex).addClass('inactive');
        }
        //如果处于暂停状态
        if (statusData.paused) {
            $('#zm_btn_media_pause' + key + '_' + dataIndex).addClass('inactive');
            $('#zm_btn_media_stop' + key + '_' + dataIndex).addClass('inactive');
        } else {
            $('#zm_btn_media_play' + key + '_' + dataIndex).addClass('inactive');
            $('#zm_btn_media_back' + key + '_' + dataIndex).addClass('inactive');
            $('#zm_btn_media_last' + key + '_' + dataIndex).addClass('inactive');
            $('#zm_btn_media_next' + key + '_' + dataIndex).addClass('inactive');
            $('#zm_btn_media_fastforward' + key + '_' + dataIndex).addClass('inactive');
        }
    }

    //delay：延迟秒数（只在暂停后显示）
    function getLastTimeStr(delay) {
        var HOUR_SECOND = 60 * 60;
        var MINUTE_SECOND = 60;

        var hour = parseInt(delay / HOUR_SECOND);
        var minute = parseInt((delay % HOUR_SECOND) / MINUTE_SECOND);
        var second = ((delay % HOUR_SECOND) % MINUTE_SECOND).toFixed(2);
        return hour + ':' + minute + ':' + second;
    }

    function getModeStr(paused) {
        var intPaused = parseInt(paused);
        var str = '';
        switch (intPaused) {
            case 1:
                str = myUNAS._('暂停');
                break;
            case 0:
                str = myUNAS._('实时');
                break;
        }
        return str;
    }

    function getStateStr(state) {
        var intState = parseInt(state);
        var str = '';
        switch (intState) {
            case 0:
                str = myUNAS._('空闲');
                break;
            case 4:
                str = myUNAS._('录制');
                break;
        }
        return str;
    }


    //===================================================================================
    //监视器slider视图 （底部slider，上部放大当前选中的监视器）
    //===================================================================================
    //显示监视器slider视图
    function showMonitorSliderView() {
        clearPageView();

        $('#monitor_slider_view').show();
        $('#monitor_page_view').hide();
        $('#monitor_notice_empty').hide();

        $('.monitor-view-model-container').hide();
        $('.monitor-stream-setting-container').show();

        _currentView = 'slider';

        filterMonitors(false);

        _monitorSlider = new Swiper('.swiper-container', {
            navigation: {
                nextEl: '.swiper-button-next',
                prevEl: '.swiper-button-prev',
            },
            slidesPerView: 'auto',
            spaceBetween: 20
        });


        //因为用户操作，可能会删除_monitor列表中的监视器，所以slider的index和_monitor的index并不总是一一对应的
        var sliderIndex = _monitorIndex;
        for (var i = 0, lastIndex = _monitorIndex; i < lastIndex; ++i) {
            if (_monitors[i].Monitor.isRemovedFromScreen) {
                sliderIndex -= 1;
            }
        }
        //console.log('sliderIndex:'+sliderIndex);
        _monitorSlider.slideTo(sliderIndex, 0, false); //直接跳转到指定索引
    }

    function clearSliderView() {
        //停止所有监视器的状态轮询请求
        stopGetStatus();

        removeEvents();
        $('#monitor_thumb_bigsize_container').empty();

        if (_monitorSlider) {
            _monitorSlider.destroy();
            _monitorSlider = null;
        }
    }


    function attachBigsizeMonitor(i) {
        var $bigsizeContainer = $('#monitor_thumb_bigsize_container');

        removeEvents();
        $bigsizeContainer.empty();

        var str = '';
        var strEdit = myUNAS._('编辑');
        var strBack = myUNAS._('返回');
        var strRemove = myUNAS._('删除');
        var strStatus = myUNAS._('状态：');
        str += '<div class="monitor-thumb monitor-thumb-bigsize" style="width:' + _monitorThumbBigsizeWidth + 'px; height:' + _monitorThumbBigsizeHeight + 'px">';
        str += '<div class="monitor-container">';
        str += '<img class="loading-icon" src="./images/ajax-loader.gif?v=6.0.30&">';
        str += '<div class="screen-container flex-center">';
        // /zm/cgi-bin/nph-zms?width=100%25&height=auto&mode=jpeg&maxfps=30&monitor=1&token=dd4c003b31a766ed544c077620f2d0c2&connkey=923920&rand=1626659658
        var streamMjpegSrc = window.zm.cgiBinUrl + '?width=100%25&height=auto&mode=jpeg&maxfps=30'
            + '&scale=' + _monitors[i].Monitor.scale
            + '&monitor=' + _monitors[i].Monitor.Id
            + '&token=' + window.zm.access_token
            + '&connkey=' + _monitors[i].Monitor.connkey
            + '&rand=' + Math.random()
            + '&wid=' + window.zm.windowId
            + '&rnd=' + Math.random().toString(36).slice(-6);
        str += '<img class="screen-mjpeg" id="screen_mjpeg_bigsize_' + i + '" data-ref="' + i + '" src="' + streamMjpegSrc + '" />';
        str += '</div>';

        str += '<div class="name-container hide">' + _monitors[i].Monitor.Name + '</div>';

        str += '<div class="control-container hide">';
        str += '<div class="icon-control-list"></div>';
        str += '<div class="control-list hide">';
        str += '<div class="control-item control-item-edit" data-ref="' + i + '" id="control_item_edit_bigsize_' + i + '">' + strEdit + '</div>';
        str += '<div class="control-item control-item-back" data-id="'+_monitors[i].Monitor.Id+'" data-ref="' + i + '" id="control_item_back_bigsize_' + i + '">' + strBack + '</div>';
        str += '<div class="control-item control-item-remove" data-ref="' + i + '" id="control_item_remove_bigsize_' + i + '">' + strRemove + '</div>';
        str += '</div>';
        str += '</div>';

        str += '<div class="control-panel-container hide">';
        str += '<div class="control-panel">';
        if (i == 0) {
            str += '<button title="上一个" class="zm-btn-media zm-btn-media-previous-event inactive" id="zm_btn_media_previous_event_' + i + '" data-ref="' + i + '"></button>';
        } else {
            str += '<button title="上一个" class="zm-btn-media zm-btn-media-previous-event" id="zm_btn_media_previous_event_' + i + '" data-ref="' + i + '"></button>';
        }
        str += '<button title="快退" class="zm-btn-media zm-btn-media-back inactive" id="zm_btn_media_back_' + i + '" data-ref="' + i + '"></button>';
        str += '<button title="单步后退" class="zm-btn-media zm-btn-media-last inactive" id="zm_btn_media_last_' + i + '" data-ref="' + i + '"></button>';
        str += '<button title="暂停" class="zm-btn-media zm-btn-media-pause inactive" id="zm_btn_media_pause_' + i + '" data-ref="' + i + '"></button>';
        str += '<button title="停止" class="zm-btn-media zm-btn-media-stop inactive" id="zm_btn_media_stop_' + i + '" data-ref="' + i + '"></button>';
        str += '<button title="播放" class="zm-btn-media zm-btn-media-play inactive" id="zm_btn_media_play_' + i + '" data-ref="' + i + '"></button>';
        str += '<button title="单步前进" class="zm-btn-media zm-btn-media-next inactive" id="zm_btn_media_next_' + i + '" data-ref="' + i + '"></button>';
        str += '<button title="快进" class="zm-btn-media zm-btn-media-fastforward inactive" id="zm_btn_media_fastforward_' + i + '" data-ref="' + i + '"></button>';
        if (i == _monitors.length - 1) {
            str += '<button title="下一个" class="zm-btn-media zm-btn-media-next-event inactive" id="zm_btn_media_next_event_' + i + '" data-ref="' + i + '"></button>';
        } else {
            str += '<button title="下一个" class="zm-btn-media zm-btn-media-next-event" id="zm_btn_media_next_event_' + i + '" data-ref="' + i + '"></button>';
        }

        str += '<button title="缩小" class="zm-btn-media zm-btn-media-zoomout inactive" id="zm_btn_media_zoomout_bigsize_' + i + '" data-ref="' + i + '"></button>';


        str += '</div>';
        str += '<div class="control-panel-status" id="cp_status_bigsize_' + i + '">' + strStatus + '</div>';
        str += '</div>';
        str += '</div>';
        str += '</div>';

        $bigsizeContainer.append(str);
        addEvents('.monitor-thumb-bigsize');

        //开始所有监视器的状态轮询请求
        // startGetStatus();


        var value = Number($('#monitor_sel_size').val());
        if (value == 0) {
            $('#monitor_thumb_bigsize_container').css('overflow', 'hidden');
            $('.monitor-thumb-bigsize').removeClass('rel');
        } else {
            $('#monitor_thumb_bigsize_container').css('overflow', 'scroll');
            $('.monitor-thumb-bigsize').addClass('rel');
        }
    }

    function attachSlideMonitors(monitors) {
        getMonitorSize();

        var $swiperWrapper = $('#swiper_wrapper_monitor');

        removeSlideEvents();
        $swiperWrapper.empty();

        var str = '';
        for (var i = 0, len = _monitors.length; i < len; ++i) {
            //不显示已经删除的monitor
            if (_monitors[i].Monitor.isRemovedFromScreen) continue;

            str += '<div class="swiper-slide monitor-swiper-slide" data-ref="' + i + '" style="margin-left:0px; width:' + _monitorThumbSlideWidth + 'px; height:' + _monitorThumbSlideHeight + 'px">';
            str += '<div class="monitor-thumb monitor-thumb-slide" id="monitor_thumb_slide_' + i + '" style="width:' + _monitorThumbSlideWidth + 'px; height:' + _monitorThumbSlideHeight + 'px">';
            str += '<div class="monitor-container">';
            str += '<img class="loading-icon" src="./images/ajax-loader.gif?v=6.0.30&">';
            str += '<div class="screen-container flex-center">';
            var streamMjpegSrc = window.zm.cgiBinUrl + '?width=100%25&height=auto&mode=jpeg&maxfps=30'
                + '&scale=' + _monitors[i].Monitor.scale
                + '&monitor=' + _monitors[i].Monitor.Id
                + '&token=' + window.zm.access_token
                + '&connkey=' + parseInt(Math.random() * 1000000)
                + '&rand=' + Math.random()
                + '&wid=' + window.zm.windowId
                + '&rnd=' + Math.random().toString(36).slice(-6);
            str += '<img class="screen-mjpeg" src="' + streamMjpegSrc + '" />';
            //str += '<img class="screen-mjpeg" src="./images/1920x1080.jpg?v=6.0.30&" />';
            str += '</div>';

            str += '<div class="name-container">' + _monitors[i].Monitor.Name + '</div>';
            str += '</div>';
            str += '</div>';
            str += '</div>';
        }

        $swiperWrapper.append(str);

        addSlideEvents();

        //为当前选中的thumb添加active样式
        $('#monitor_thumb_slide_' + _monitorIndex).addClass('active');
        attachBigsizeMonitor(_monitorIndex);
    }

    function addSlideEvents() {
        $('.monitor-swiper-slide').on('click', function () {
            var $that = $(this);
            if ($that.hasClass('active')) return;

            var index = $that.data('ref');
            _monitorIndex = index;
            $('.monitor-thumb-slide').removeClass('active');
            $('#monitor_thumb_slide_' + index).addClass('active');
            attachBigsizeMonitor(_monitorIndex);
        });
    }

    function removeSlideEvents() {
        $('.monitor-thumb-slide').off();
    }

    //===================================================================================


    //===================================================================================
    //'局域网搜索'弹窗
    //===================================================================================
    //显示'局域网搜索'弹窗
    function showMonitorProb() {
        $("#monitor-prob-inner-search-input").val();
        $('#popup_monitor_prob').show();

        doGetMonitorLanList();
    }

    function hideMonitorProb() {
        $('#popup_monitor_prob').hide();
    }

    //获取局域网内可用监视器列表
    //flg参数用于区分刚进入列表时与进入列表后点击重新搜索的流程
    //若刚进入列表，flg参数未传
    function doGetMonitorLanList(flg) {
        if (flg) {
            $("#monitor-prob-ajax-popup").show();
        } else {
            $('#loading_monitor_prob').show();
        }


        //本地调试
        if (_isLocalDebug) {
            setTimeout(function () {
                _monitorsLan = generateTestMonitorsLan(10);
                $('#monitor_prob_list_view').show();
                $('#monitor_prob_notice_empty').hide();
                attachMonitorsLan(_monitorsLan);

                //$('#monitor_prob_list_view').hide();
                //$('#monitor_prob_notice_empty').show();

                //$('#loading_monitor_prob').hide();
                //$("#monitor-prob-ajax-popup").hide();
                if (flg) {
                    $("#monitor-prob-ajax-popup").hide();
                } else {
                    $('#loading_monitor_prob').hide();
                }
            }, 1000);
            return;
        }

        jQuery.ajax({
            url: "/zm/api/monitors/probe.json?token=" + window.zm.access_token,
            type: "GET",
            async: true,
            dataType: 'json',
            contentType: "application/json;charset=utf-8",
            data: {},
            success: function (data) {
                //console.log(data);


                $('#monitor_prob_list_view').show();
                $('#monitor_prob_notice_empty').hide();
                attachMonitorsLan(data);

                // if(data && parseInt(data.err) === 0){
                //  if(data.results.monitors && data.results.monitors>0){
                //      _monitorsLan = data.results.monitors;
                //      $('#monitor_prob_list_view').show();
                //      $('#monitor_prob_notice_empty').hide();
                //      attachMonitorsLan(_monitorsLan);
                //  }else{
                //      $('#monitor_prob_list_view').hide();
                //      $('#monitor_prob_notice_empty').show();
                //  }
                // }else{
                //  //console.log('monitor monitor_lan_list failed');
                // }
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                //console.log('monitor monitor_lan_list error textStatus:' + textStatus);
            },
            complete: function () {
                //$('#loading_monitor_prob').hide();
                //$("#monitor-prob-ajax-popup").hide();
                if (flg) {
                    $("#monitor-prob-ajax-popup").hide();
                } else {
                    $('#loading_monitor_prob').hide();
                }
            }
        });
    }

    function attachMonitorsLan(monitorsLan) {
        var $monitorTable = $('#monitor_table');

        removeEventsLab();
        $monitorTable.empty();

        var str = '';

        for (item of Object.keys(monitorsLan)) {
            let temp = monitorsLan[item];
            str += '<tr data-name="' + temp.model + '">';//这里保存一下监控名称，方便做检索功能
            str += '<td class="td_monitor_name">' + temp.model + '</td>';
            str += '<td class="td_monitor_ip">' + temp.host + '</td>';
            str += '<td class="td_monitor_protocol">' + temp.protocol + '</td>';
            str += '<td class="td_monitor_version">' + temp.version + '</td>';
            str += '<td class="td_monitor_operation">';
            str += '<div class="td_icon td_icon_add_monitor" data-ref="' + i + '" data-key="' + item + '" data-name="' + temp.model + '" data-host="' + temp.host + '" data-protocol="' + temp.protocol + '"></div>';
            str += '</td>';
            str += '</tr>';
        }
        // for(var i=0,len=monitorsLan.length; i<len; ++i){
        //  str += '<tr>';
        //      str += '<td class="td_monitor_name">'+monitorsLan[i].Name+'</td>';
        //      str += '<td class="td_monitor_ip">'+monitorsLan[i].Ip+'</td>';
        //      str += '<td class="td_monitor_protocol">'+monitorsLan[i].Protocol+'</td>';
        //      str += '<td class="td_monitor_operation">';
        //          str += '<div class="td_icon td_icon_add_monitor" data-ref="'+i+'"></div>';
        //      str += '</td>';
        //  str += '</tr>';
        // }

        $monitorTable.append(str);
        addEventsLan();
    }

    function addEventsLan() {
        $('.td_icon_add_monitor').on('click', function () {
            var index = $(this).data('ref');
            //showAddMonitorSimpleFromProb(_monitorsLan[index]);

            //显示前清空上次的相关操作
            $("#moniter-prob-add-username").val("");
            $("#moniter-prob-add-password").val("");
            $("#moniter-prob-add-detected-profiles").empty();
            $("#monitor_lan_add_probe2_-2").show();
            $("#monitor_lan_add_probe2_-1").show();
            $("#monitor_lan_add_probe2_0").show();
            $("#monitor_lan_add_probe2_1").hide();
            $("#monitor_lan_add_probe2_2").hide();
            $("#monitor-prob-add-button-next").show();
            $("#monitor-prob-add-button-save").hide();
            $("#monitor-prob-add-button-pre").hide();
            $("#popup_monitor_prob_add_mointor").show();

            $("#moniter-prob-add-probe").val($(this).data('key'));
            $("#moniter-prob-add-name").val($(this).data('name'));
            $("#moniter-prob-add-host").val($(this).data('host'));
            $("#moniter-prob-add-protocol").val($(this).data('protocol'));
        });
    }

    function removeEventsLab() {
        $('.td_icon_add_monitor').off();
    }

    //===================================================================================


    //===================================================================================
    //'监视器配置项'弹窗
    //===================================================================================
    function showAddMonitorSimpleFromProb(monitorsLan) {
        var simpleData = getDefaultMonitorSimpleData(getNextMonitorIndex());
        $.extend(simpleData, monitorsLan);
        initMonitorDataSimple(simpleData);
    }

    //显示'简单配置项'弹窗
    function showAddMonitorSimple() {

        var simpleData = getDefaultMonitorSimpleData(getNextMonitorIndex());
        initMonitorDataSimple(simpleData);
    }

    //填充表单数据
    function initMonitorDataSimple(simpleData) {
        //... = simpleData.xxx
        //console.log(simpleData);
        //设置监视器Id
        $("[id='simple-newMonitor[Id]']").val(simpleData.Id);
        //设置左上角标题
        $("#popup_monitor_simple_title").text(simpleData.Name);
        //General面板
        $("[id='simple-newMonitor[Name]']").val(simpleData.Name);
        $("[id='simple-newMonitor[Type]']").val(simpleData.Type);
        //$("[id='simple-newMonitor[Type]']").select2("val",[simpleData.Type]);
        $("[id='simple-newMonitor[Protocol]']").val(simpleData.Protocol);
        //$("[id='simple-newMonitor[Protocol]']").select2("val",[simpleData.Protocol]);
        $("[id='simple-newMonitor[Method]']").val(simpleData.Method);
        //$("[id='simple-newMonitor[Method]']").select2("val",[simpleData.Method]);
        $("[id='simple-newMonitor[User]']").val(simpleData.User);
        $("[id='simple-newMonitor[Pass]']").val(simpleData.Pass);
        $("[id='simple-newMonitor[IP]']").val(simpleData.IP);
        $("[id='simple-newMonitor[Port]']").val(simpleData.Port);
        $("[id='simple-newMonitor[Path]']").val(simpleData.Path);
        $("[id='simple-newMonitor[Width]']").val(simpleData.Width);
        $("[id='simple-newMonitor[Height]']").val(simpleData.Height);
        $("[id='simple-newMonitor[MaxFPS]']").val(simpleData.MaxFPS);
        //若simpleData.Path的值存在则移除拼接path的相关事件,不存在则前面的值赋好后手动触发进行path的拼接
        if (!simpleData.Path) {
            $("[id='simple-newMonitor[Protocol]'],[id='simple-newMonitor[Name]'],[id='simple-newMonitor[User]'],[id='simple-newMonitor[Pass]'],[id='simple-newMonitor[IP]'],[id='simple-newMonitor[Port]']").on("input", function () {
                var Protocol = $("[id='simple-newMonitor[Protocol]']").val();
                var User = $("[id='simple-newMonitor[User]']").val();
                var Pass = $("[id='simple-newMonitor[Pass]']").val();
                var IP = $("[id='simple-newMonitor[IP]']").val();
                var Port = $("[id='simple-newMonitor[Port]']").val();
                if (Protocol && User && Pass && IP) {
                    $("[id='simple-newMonitor[Path]']").val(Protocol + "://" + User + ":" + Pass + "@" + IP + (Port ? ":" + Port : ""));
                } else {
                    $("[id='simple-newMonitor[Path]']").val("");
                }
            });
            $("[id='simple-newMonitor[Protocol]']").trigger("input");
        } else {
            $("[id='simple-newMonitor[Protocol]'],[id='simple-newMonitor[Name]'],[id='simple-newMonitor[User]'],[id='simple-newMonitor[Pass]'],[id='simple-newMonitor[IP]'],[id='simple-newMonitor[Port]']").off("input");
        }


        $("#popup_monitor_prob").hide();
        $('#popup_monitor_simple').show();
    }

    //获取表单数据
    function getMonitorDataSimple() {
        var simpleData = {};
        //simpleData.xxx = ...
        simpleData.Id = $("[id='simple-newMonitor[Id]']").val();
        simpleData.Name = $("[id='simple-newMonitor[Name]']").val();
        simpleData.Type = $("[id='simple-newMonitor[Type]']").val();
        simpleData.Protocol = $("[id='simple-newMonitor[Protocol]']").val();
        simpleData.Method = $("[id='simple-newMonitor[Method]']").val();
        simpleData.User = $("[id='simple-newMonitor[User]']").val();
        simpleData.Pass = $("[id='simple-newMonitor[Pass]']").val();
        simpleData.IP = $("[id='simple-newMonitor[IP]']").val();
        simpleData.Port = $("[id='simple-newMonitor[Port]']").val();
        simpleData.Path = $("[id='simple-newMonitor[Path]']").val();
        simpleData.Width = $("[id='simple-newMonitor[Width]']").val();
        simpleData.Height = $("[id='simple-newMonitor[Height]']").val();
        simpleData.MaxFPS = $("[id='simple-newMonitor[MaxFPS]']").val();


        return simpleData;
    }

    function hideAddMonitorSimple() {
        $('#popup_monitor_simple').hide();
    }


    //显示'复杂配置项'弹窗
    function showEditMonitorComprehensive(comprehensiveData) {
        //console.log('showEditMonitorComprehensive');

        if (window.zm.showEditMonitorComprehensive) {
            window.zm.showEditMonitorComprehensive(comprehensiveData);
        }
    }

    //删除监视器,回调在删除监视器请求成功后发生，一般是在前端做移除监视器的功能
    function deleteMointor(monitorId, callback) {
        //console.log(monitorId);
        $.ajax({
            url: "/zm/api/monitors/" + monitorId + ".json?token=" + window.zm.access_token,
            type: "DELETE",
            dataType: "json",
            async: true,
            success: function (data) {
                if (data.status == "ok") {
                    Message.success(myUNAS._('Delete Success'));
                } else {
                    Message.error(myUNAS._('Delete Failed'));
                }
                callback();
            },
            error: function (xhr, ajaxOptions, thrownError) {
                //console.log(xhr);
                // promptShow(xhr.responseJSON.message);
                Message.error(xhr.responseJSON.message);
            }
        });
    }

    //===================================================================================


    function showWaiting() {
        $('#loading_monitor').show();
    }

    function hideWaiting() {
        $('#loading_monitor').hide();
    }

    function getTrimValue(id) {
        return $.trim($(id).val());
    }

    window.zm = window.zm || {};
    window.zm.updateMonitorList = update;
    window.zm.updateMonitorEdited = updateMonitorEdited;

    window.zm.init = window.zm.init || [];
    window.zm.init['monitor'] = init;
    window.zm.destroy = window.zm.destroy || [];
    window.zm.destroy['monitor'] = destroy;
    window.zm.update = window.zm.update || [];
    window.zm.update['monitor'] = update;


})();


function addUniqueConnkey(arr) {
    for (var i = 0, len = arr.length; i < len; ++i) {
        arr[i].Monitor.connkey = parseInt(Math.random() * 1000000);
        arr[i].Monitor.scale = 60; //默认60%的显示质量
    }
}


function generateTestMonitorsLan(num) {
    var arr = [];
    var obj;
    for (var i = 1; i <= num; ++i) {
        obj = {};
        obj.Name = myUNAS._("##$@@$##Monitor##$@@$##") + "-" + i;                        //名称
        obj.Ip = "192.168.0.230";                   //远程主机IP
        obj.Protocol = "rtsp";                      //远程协议

        arr.push(obj);
    }

    return arr;
}

function getDefaultMonitorSimpleData(index) {
    var obj = {};
    obj.Name = myUNAS._("##$@@$##Monitor##$@@$##") + "-" + index;                         //名称
    obj.Id = "" + index;                              //监视器ID
    obj.Function = "Monitor";                       //功能
    obj.Host = "";  //远程主机名（远程主机用户名:远程主机密码@远程主机IP）
    obj.Method = "rtpRtsp";                             //远程方法
    obj.Pass = "";                                  //远程主机密码
    obj.Ip = "";                                    //远程主机IP
    obj.Path = "";                                  //信号源路径
    obj.Port = "";                                  //远程主机端口
    obj.Protocol = "http";                              //远程协议
    obj.Type = "Ffmpeg";                            //信号源类型
    obj.User = "";                                  //远程主机用户名

    return obj;
}


function generateTestMonitors(num) {
    var arr = [];
    var obj;
    for (var i = 1; i <= num; ++i) {
        obj = {'Monitor': {}, 'Monitor_Status': {}};
        obj.Monitor.Name = "hik-0" + i;                           //名称
        obj.Monitor.Id = "" + i;                                  //监视器ID
        obj.Monitor.Function = "Monitor";                       //功能
        obj.Monitor.Host = "admin:fzj19981018@192.168.0.230";   //远程主机名（远程主机用户名:远程主机密码@远程主机IP）
        obj.Monitor.Method = "rtpRtsp";                         //远程方法
        obj.Monitor.Pass = "fzj19981018";                       //远程主机密码
        obj.Monitor.Ip = "192.168.0.230";                       //远程主机IP
        obj.Monitor.Path = "rtsp://admin:fzj19981018@192.168.0.230/onvif";    //信号源路径
        obj.Monitor.Port = "554";                               //远程主机端口
        obj.Monitor.Protocol = "rtsp";                          //远程协议
        obj.Monitor.Type = "Ffmpeg";                            //信号源类型
        obj.Monitor.User = "admin";                             //远程主机用户名
        arr.push(obj);
    }

    return arr;
}

function getDefaultMonitorData(index) {
    var obj = {};
    obj.AlarmFrameCount = "1";
    obj.AlarmMaxFPS = null;
    obj.AlarmRefBlendPerc = "6";
    obj.AnalysisFPSLimit = null;
    obj.AnalysisUpdateDelay = "0";
    obj.ArchivedEventDiskSpace = "28426251";
    obj.ArchivedEvents = "1";
    obj.AutoStopTimeout = null;
    obj.Brightness = "-1";
    obj.Channel = "0";
    obj.Colour = "-1";
    obj.Colours = "4";
    obj.Contrast = "-1";
    obj.ControlAddress = null;
    obj.ControlDevice = null;
    obj.ControlId = "27";
    obj.Controllable = "0";
    obj.DayEventDiskSpace = "933077886";
    obj.DayEvents = "5";
    obj.DecoderHWAccelDevice = null;
    obj.DecoderHWAccelName = null;
    obj.DefaultCodec = "auto";
    obj.DefaultRate = "100";
    obj.DefaultScale = "0";
    obj.Deinterlacing = "0";
    obj.Device = "";
    obj.Enabled = "1";
    obj.EncoderParameters = "# Lines beginning with # are a comment \r\n# For changing quality, use the crf option\r\n# 1 is best, 51 is worst quality\r\n#crf=23";
    obj.EventPrefix = "Event-";
    obj.Exif = false;
    obj.FPSReportInterval = "100";
    obj.Format = "255";
    obj.FrameSkip = "0";
    obj.Function = "None";                      //功能
    obj.Height = "";
    obj.Host = "";                              //远程主机名（远程主机用户名:远程主机密码@远程主机IP）
    obj.HourEventDiskSpace = "0";
    obj.HourEvents = "0";
    obj.Hue = "-1";
    obj.Id = "";                                //监视器ID
    obj.ImageBufferCount = "20";
    obj.LabelFormat = "%N - %d/%m/%y %H:%M:%S";
    obj.LabelSize = "1";
    obj.LabelX = "0";
    obj.LabelY = "0";
    obj.LinkedMonitors = null;
    obj.MaxFPS = null;
    obj.Method = "TCP";                         //远程方法
    obj.MinSectionLength = "10";
    obj.MonthEventDiskSpace = "933077886";
    obj.MonthEvents = "5";
    obj.MotionFrameSkip = "0";
    obj.Name = myUNAS._('##$@@$##Monitor##$@@$##') + "-" + index;        //名称
    obj.Notes = "";
    obj.Options = null;
    obj.Orientation = "ROTATE_0";
    obj.OutputCodec = null;
    obj.OutputContainer = null;
    obj.Palette = "0";
    obj.Pass = null;                            //远程主机密码
    obj.Path = "";                              //信号源路径
    obj.Port = "";                              //远程主机端口
    obj.PostEventCount = "5";
    obj.PreEventCount = "5";
    obj.Protocol = "rtsp";                      //远程协议
    obj.RTSPDescribe = false;
    obj.RecordAudio = "1";
    obj.RefBlendPerc = "6";
    obj.Refresh = null;
    obj.ReturnDelay = null;
    obj.ReturnLocation = "-1";
    obj.SaveJPEGs = "0";
    obj.SectionLength = "600";
    obj.Sequence = "1";
    obj.ServerId = "0";
    obj.SignalCheckColour = "#0000be";
    obj.SignalCheckPoints = "0";
    obj.StorageId = "0";
    obj.StreamReplayBuffer = "0";
    obj.SubPath = "";
    obj.TotalEventDiskSpace = "933077886";
    obj.TotalEvents = "5";
    obj.TrackDelay = null;
    obj.TrackMotion = "0";
    obj.Triggers = "";
    obj.Type = "Ffmpeg";                          //信号源类型
    obj.User = null;                              //远程主机用户名
    obj.V4LCapturesPerFrame = "1";
    obj.V4LMultiBuffer = null;
    obj.VideoWriter = "2";
    obj.WarmupCount = "0";
    obj.WebColour = "#b08465";
    obj.WeekEventDiskSpace = "933077886";
    obj.WeekEvents = "5";
    obj.Width = "";
    obj.ZoneCount = "1";

    //以下是前端维护的属性
    obj.connkey = '';               //a random number which uniquely identifies a stream generated by ZM
                                    //can use connkey to “control” the stream (pause/resume etc.)
    obj.scale = 60;                 //监视器显示质量
    obj.isRemovedFromScreen = false;//是否已被删除（前端删除操作时标记）
    obj.isStreamWaiting = false;    //是否正在进行视频流操作
    obj.lastGetStatusStartTime = 0; //上一次发出getStatus请求时的时间戳（单位：毫秒）
    obj.lastGetStatusTimer = null;  //上一次发出getStatus请求的timer（用于后续调用clearTimeout）

    return obj;
}
