Date.prototype.format = function (fmt) {
    let o = {
        "M+": this.getMonth() + 1, //月份
        "d+": this.getDate(), //日
        "h+": this.getHours(), //小时
        "m+": this.getMinutes(), //分
        "s+": this.getSeconds(), //秒
        "q+": Math.floor((this.getMonth() + 3) / 3), //季度
        S: this.getMilliseconds() //毫秒
    };
    if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    for (let k in o)
        if (new RegExp("(" + k + ")").test(fmt))
            fmt = fmt.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
    return fmt;
};

const TimeLine = class TimeLine {
    constructor(
        canvasId,
        currentTime = new Date().getTime(),
        timeParts = [],
        isMove = false,
        changeCallback = date => {
        },
        mousedownupCallback = date => {
        },
        mouseoverCallback = date => {
        },
        mouseleaveCallback = date => {
        },
        mouseupCallback = date => {
        },
        width,
        height,
        canvasId2 = ''
    ) {
        this.canvas = document.getElementById(canvasId);
        if (this.canvas == undefined) {
            return;
        }
        this.ctx = this.canvas.getContext("2d");
        this.canvas.width = width;
        this.canvas.height = height;


        this.canvas2 = document.getElementById(canvasId2);
        this.ctx2 = this.canvas2.getContext("2d");
        this.canvas2.width = width;
        this.canvas2.height = 12;


        // 可选的每个间隔代表多少分钟
        this.minutePerStep = [1, 2, 5, 10, 15, 20, 30, 60, 120, 180, 240, 360, 720, 1440];
        // 最小刻度间距
        this.minScaleSpacing = 40;
        // 整个时间轴表示的时间长度
        this.totalRulerHours = 4;
        // this.totalRulerHours = 0.25;
        // 允许的最小大格长度px值 如果调小 大格会变密集
        this.minLargeScaleSpacing = 80;
        // 缩放层级 默认4小时
        this.zoom = 4;
        // this.zoom = 0.25;

        this.cursorX = this.canvas.width / 2;

        this.currentTime = currentTime;
        this.timeParts = timeParts;
        this.isMove = false;
        this.moveTimer = null;
        this.changeCallback = changeCallback;
        this.mousedownupCallback = mousedownupCallback;
        this.mouseoverCallback = mouseoverCallback;
        this.mouseleaveCallback = mouseleaveCallback;
        this.mouseupCallback = mouseupCallback;
        this.displayTime = 0;
        this.speed = 1;

        this.init();
        // this.setIsMove(isMove);


        const _this = this;
        var clickHandler = function (e) {
            _this.clickEvent(e);
        };
        dragElement(document.getElementById("canvas-bar"), clickHandler);

        function dragElement(elmnt, clickCallback) {
            var isDragged = false;

            if (document.getElementById(elmnt.id + "header")) {
                document.getElementById(elmnt.id + "header").onmousedown = dragMouseDown;
            } else {
                elmnt.onmousedown = dragMouseDown;
                elmnt.onmouseenter = elementMouseEnter;
                elmnt.onmouseleave = elementMouseLeave;
                elmnt.onwheel = elementMouseWheel;
            }

            if (clickCallback) {
                elmnt.onclick = function (e) {
                    // Only call if no dragging occured
                    if (!isDragged) clickCallback(e);
                };
            }

            function elementMouseMove(e) {
                // console.log('elementMouseMove')
                _this.mousedownX = e.clientX;
                _this.mouseover(e);
            }

            function dragMouseDown(e) {
                isDragged = false; // No dragging since now

                e = e || window.event;
                e.preventDefault();

                // _this.mousedownX = e.clientX;

                _this.mousedownX = _this.getMouseXRelativePos(e);
                // console.log(_this.mousedownX)
                document.onmouseup = closeDragElement;
                document.onmousemove = elementDrag;
            }

            function elementDrag(e) {
                isDragged = true; // Dragging occured

                _this.dragMove(e);
            }

            function elementMouseEnter(e) {
                document.onmouseup = closeDragElement;
                document.onmousemove = elementMouseMove;
            }

            function closeDragElement(e) {
                document.onmouseup = null;
                document.onmousemove = null;

                let posX = _this.getMouseXRelativePos(e);
                // let diffX = posX - this.mousedownX;
                let onePxsMS = _this.canvas.width / (_this.totalRulerHours * 60 * 60 * 1000);

                // this.mousedownX = posX;
                let time = _this.getMousePosTime(event);

                _this.mouseoverCallback(_this.canvas.width, _this.zoom, posX, time);
                _this.mouseupCallback();

                document.onmousemove = elementMouseMove;
            }

            function elementMouseLeave(e) {
                document.onmouseup = null;
                document.onmousemove = null;

                _this.mouseleaveCallback();
            }

            function elementMouseWheel(e) {
                _this.wheelEvent(e);
            }
        }

        /* *****************
            ## 事件处理
        ***************** */
        // this.g_isMousedown = false;//拖动mousedown标记
        // this.g_isMousemove = false;//拖动mousemove标记
        //
        // const _this = this;
        // this.eventListener = {
        //     wheel(event) {
        //         // 事件this指向DOM元素
        //         _this.wheelEvent(event);
        //         // _this.hoverMove(event);
        //     },
        //     mousedown(event) {
        //         _this.g_isMousedown = true;
        //         _this.clientX = event.clientX;
        //         _this.mousedownX = _this.getMouseXRelativePos(event);
        //
        //         _this.canvas.removeEventListener("mouseup", _this.eventListener.mousemove);
        //         _this.canvas2.removeEventListener("mousemove", _this.eventListener.mousemove);
        //         _this.canvas.removeEventListener("mouseup", _this.eventListener.mousemove);
        //         _this.canvas2.removeEventListener("mousemove", _this.eventListener.mousemove);
        //
        //         _this.canvas.addEventListener("mousemove", _this.eventListener.mousemove);
        //         _this.canvas2.addEventListener("mousemove", _this.eventListener.mousemove);
        //     },
        //     mousemove(event) {
        //         _this.g_isMousemove = true;
        //         if (_this.g_isMousedown) {
        //             console.log('dragMove')
        //             _this.dragMove(event);
        //         } else {
        //             _this.mouseover(event);
        //         }
        //     },
        //     mouseleave(event) {
        //         // console.log('======================================mouseleave')
        //         // _this.init();
        //         _this.g_isMousedown = false;
        //         _this.g_isMousemove = false;
        //         _this.isDragFlag = false;
        //         _this.clientX = 0;
        //         _this.mouseleaveCallback();
        //     },
        //     mouseclick(event) {
        //         _this.clickEvent(event);
        //     }
        // };
        //
        //
        // this.canvas.addEventListener("wheel", this.eventListener.wheel);
        // // this.canvas.addEventListener("mousemove", this.eventListener.mousemove);
        // this.canvas.addEventListener("mousedown", this.eventListener.mousedown);
        // // this.canvas.addEventListener("mouseup", this.eventListener.mouseup);
        // this.canvas.addEventListener("mouseleave", this.eventListener.mouseleave);
        // this.canvas.addEventListener("click", this.eventListener.mouseclick);
        //
        // this.canvas2.addEventListener("wheel", this.eventListener.wheel);
        // this.canvas2.addEventListener("mousedown", this.eventListener.mousedown);
        // // this.canvas2.addEventListener("mousemove", this.eventListener.mousemove);
        // // this.canvas2.addEventListener("mouseup", this.eventListener.mouseup);
        // this.canvas2.addEventListener("mouseleave", this.eventListener.mouseleave);
    }

    init() {
        this.refreshStartTimestamp();
        // 清空画布
        this.clearCanvas();
        // 画刻度处背景
        this.fillScaleBg();
        // 画刻度
        this.drawScale();
        // 画游标
        // this.drawCursor();
        if (this.timeParts) {
            this.timeParts.forEach(element => {
                this.fillTimeParts(element);
            });
        }
    }

    fillScaleBg() {
        if (!this.ctx2) {
            return;
        }
        this.ctx2.fillStyle = "#25292E";
        // console.log(this.canvas2.width)
        this.ctx2.fillRect(0, 0, this.canvas2.width, 12);
    }

    fillTimeParts(part) {
        // 一个像素多少毫秒
        let onePxsMS = this.canvas.width / (this.totalRulerHours * 60 * 60 * 1000);
        let beginX = (part.start - this.startTimestamp) * onePxsMS;
        let partWidth = (part.end - part.start) * onePxsMS;
        if (part.style && part.style.background) {
            this.ctx2.fillStyle = part.style.background;
        } else {
            this.ctx2.fillStyle = "rgba(109, 153, 254, 0.6)";
        }
        this.ctx2.fillRect(beginX, 0, partWidth, 12);
    }

    drawScale() {
        if (!this.canvas) {
            return;
        }
        // 一分钟多少像素
        let oneMinutePx = this.canvas.width / (this.totalRulerHours * 60);
        // 一毫秒多少像素
        let oneMSPx = oneMinutePx / (60 * 1000);
        // 刻度间隔 默认20px
        let scaleSpacing = this.minScaleSpacing;
        // 每格代表多少分钟
        let scaleUnit = scaleSpacing / oneMinutePx;

        let len = this.minutePerStep.length;
        for (let i = 0; i < len; i += 1) {
            if (scaleUnit < this.minutePerStep[i]) {
                // 选择正确的刻度单位分钟
                scaleUnit = this.minutePerStep[i];
                // 每刻度之间的距离 = 一分钟多少像素 * 刻度单位
                // 即 scaleUnit = scaleSpacing / oneMinutePx 的变形
                // 主要是 this.totalRulerHours 会变化 需要根据这个的变化来计算...
                scaleSpacing = oneMinutePx * scaleUnit;
                break;
            }
        }

        // 有刻度文字的大格相当于多少分钟 相当于直尺上的1cm
        let mediumStep = 30;
        for (let i = 0; i < len; i++) {
            if (this.minLargeScaleSpacing / oneMinutePx <= this.minutePerStep[i]) {
                mediumStep = this.minutePerStep[i];
                break;
            }
        }

        let totalScales = this.canvas.width / scaleSpacing;
        // 某个刻度距离最左端得距离
        let graduationLeft;
        // 某个刻度得时间
        let graduationTime;
        let lineHeight;
        // 开始时间 = 中间时间 - 一半得整条时间
        // let startTimestamp = this.currentTime - (this.totalRulerHours * 60 * 60 * 1000) / 2;

        let startTimestamp = this.currentTime - (this.totalRulerHours * 60 * 60 * 1000);

        // 因为中间点是currentTime是固定的 最右边不一定在某个刻度上 会有一定的偏移量
        let leftOffsetMs = scaleUnit * 60 * 1000 - (startTimestamp % (scaleUnit * 60 * 1000));

        // 开始时间偏移距离(px)
        let leftOffsetPx = leftOffsetMs * oneMSPx;
        // console.log('开始时间偏移距离:' + leftOffsetPx);

        // 一刻度多少毫秒
        let oneScalesMS = scaleSpacing / oneMSPx;
        // console.log('一刻度'+oneScalesMS+'毫秒,等于'+oneScalesMS/1000 +'秒 等于'+oneScalesMS/1000/60+'分');

        // 文字颜色
        this.ctx.fillStyle = "rgba(151,158,167,1)";
        // 刻度线颜色
        this.ctx.strokeStyle = "#fff";
        this.ctx.beginPath();
        // 画刻度线
        const _this = this;
        let isLong;

        function drawScaleLine(left, height) {
            if (height == 15) {
                _this.ctx.moveTo(left, 13);
                _this.ctx.lineTo(left, 26);
            } else {
                _this.ctx.moveTo(left, 20);
                _this.ctx.lineTo(left, 26);
            }

            _this.ctx.lineWidth = 1;
        }

        for (let i = 0; i < totalScales; i++) {
            // 距离 = 开始得偏移距离 + 格数 * 每格得px;
            graduationLeft = leftOffsetPx + i * scaleSpacing;
            // 时间 = 左侧开始时间 + 偏移时间 + 格数 * 一格多少毫秒
            graduationTime = startTimestamp + leftOffsetMs + i * oneScalesMS;
            let date = new Date(graduationTime);
            // console.log(graduationTime, graduationTime / (60 * 1000), mediumStep);
            if ((graduationTime / (60 * 1000)) % mediumStep == 0) {
                // 大格刻度
                lineHeight = 15;
                let scaleText = this.createScaleText(date);
                this.ctx.font = "bold 14px tahoma,arial,helvetica,sans-serif";
                this.ctx.fillStyle = "#fff"

                this.ctx.fillText(scaleText, scaleText.length == 5 ? graduationLeft - 20 : graduationLeft - 42, 12);
            } else {
                // 小格刻度
                lineHeight = 10;
                // let scaleText = this.createScaleText(date);
                // this.ctx.font = "bold 14px tahoma,arial,helvetica,sans-serif";
                // this.ctx.fillStyle = "rgba(255,255,255,0.6)"
                // this.ctx.fillText(scaleText, graduationLeft - 20, 15);
            }
            drawScaleLine(graduationLeft, lineHeight);
        }
        this.ctx.stroke();
    }

    drawCursor() {
        this.ctx.beginPath();
        this.ctx.moveTo(this.cursorX, 38);
        this.ctx.lineTo(this.cursorX, 50);
        this.ctx.strokeStyle = "#fff";
        this.ctx.lineWidth = 1;
        this.ctx.stroke();
        this.ctx.fillStyle = "rgba(255, 255, 255, 0.7)";
        this.ctx.fillRect(this.cursorX - 80, 0, 190, 37);
        this.ctx.fillStyle = "#333";
        this.ctx.fillText(
            new Date(this.currentTime).format("yyyy-MM-dd hh:mm:ss"),
            this.cursorX - 60,
            this.canvas.height - 25
        );
    }

    refreshStartTimestamp() {
        // 当currentTime改变或者整条时间轴代表的totalHours改变的时候 就刷新左边开始时间
        // this.startTimestamp = this.currentTime - (this.totalRulerHours * 60 * 60 * 1000) / 2;
        this.startTimestamp = this.currentTime - (this.totalRulerHours * 60 * 60 * 1000);
        // console.log(this.currentTime, this.totalRulerHours, this.startTimestamp);
    }

    setCurrentTime(time) {
        let newTime;
        if (typeof time === "string") {
            newTime = new Date(time).getTime();
        } else if (typeof time === "object") {
            newTime = time.getTime && time.getTime();
        } else if (typeof time === "number") {
            newTime = time;
        }
        this.currentTime = newTime;
        this.init();
    }

    setDisplayTime(time) {
        this.displayTime = time;
    }

    getTimeLineInfo() {
        return {'zoom': this.zoom, 'width': this.canvas ? this.canvas.width : 0, 'currentTime': this.currentTime};
    }

    //时间线放大
    mountUpTimeLine(event) {
        var time = this.getMousePosTime(event).getTime();
        var posX = this.getMouseXRelativePos(event);

        //24h 12h 8h 4h 2h 1h 0.5h 0.25h
        this.zoom = this.zoom / 2;
        if (this.zoom <= 15 / 60) {
            this.zoom = 15 / 60;
        }
        this.totalRulerHours = this.zoom;

        var onePxsMS = this.canvas.width / (this.totalRulerHours * 60 * 60 * 1000);
        var totalMs = (this.canvas.width - posX) / onePxsMS;
        this.currentTime = time + totalMs;

        this.mousedownupCallback(this.canvas.width, this.zoom, this.currentTime, this.displayTime);

        this.init();
    }

    //时间线缩小
    mountDownTimeLine(event) {
        var time = this.getMousePosTime(event).getTime();
        var posX = this.getMouseXRelativePos(event);

        //0.25h 0.5h 1h 2h 4h 8h 12h 24h
        this.zoom = this.zoom * 2;
        if (this.zoom >= 24) {
            this.zoom = 24;
        }
        this.totalRulerHours = this.zoom;

        var onePxsMS = this.canvas.width / (this.totalRulerHours * 60 * 60 * 1000);
        var totalMs = (this.canvas.width - posX) / onePxsMS;
        this.currentTime = time + totalMs;

        this.mousedownupCallback(this.canvas.width, this.zoom, this.currentTime, this.displayTime);

        this.mouseupCallback();

        this.init();
    }

    mouseover() {
        let posX = this.getMouseXRelativePos(event);
        // console.log(posX)
        // let diffX = posX - this.mousedownX;
        let onePxsMS = this.canvas.width / (this.totalRulerHours * 60 * 60 * 1000);

        this.mousedownX = posX;
        let time = this.getMousePosTime(event);

        this.mouseoverCallback(this.canvas.width, this.zoom, posX, time);
    }

    setTimeParts(timeParts) {
        this.timeParts = timeParts;
        // this.uniqueTimeParts();
        this.init();
    }

    addTimeParts(timeParts) {
        if (this.timeParts == undefined) {
            return;
        }
        this.setTimeParts(this.timeParts.concat(timeParts));
    }

    setIsMove(isMove, currentSpeed = 1, reverse = false) {
        if (this.isMove === isMove) return;
        this.isMove = isMove;
        const clearTimer = () => {
            if (this.moveTimer) {
                clearInterval(this.moveTimer);
                this.moveTimer = null;
            }
        };
        if (isMove) {
            // 先清除之前得timer 否则会有两个timer通知进行...
            if (this.moveTimer) {
                clearTimer();
            }
            this.speed = currentSpeed;
            this.moveTimer = setInterval(() => {
                if (reverse) {
                    this.currentTime -= 1000;
                } else {
                    this.currentTime += 1000;
                }
                // console.log(this.currentTime)
                this.init();
            }, 1000 / currentSpeed);
        } else {
            clearTimer();
        }
    }

    setChangeCallback(changeCallback) {
        this.changeCallback = changeCallback;
    }

    getCurrentTime() {
        return this.currentTime;
    }

    createScaleText(time) {
        if (time.getHours() === 0 && time.getMinutes() === 0 && time.getMilliseconds() === 0) {
            return time.format("yyyy-MM-dd");
        }
        return time.format("hh:mm");
    }

    dragMove(event) {
        let posX = this.getMouseXRelativePos(event);
        let diffX = posX - this.mousedownX;
        // console.log(posX, this.mousedownX, diffX);
        let onePxsMS = this.canvas.width / (this.totalRulerHours * 60 * 60 * 1000);

        var speed = this.speed;
        var isMove = this.isMove;
        if (isMove) {
            this.setIsMove(false);
        }
        this.currentTime = this.currentTime - Math.round(diffX / onePxsMS);
        this.init();
        if (isMove) {
            this.setIsMove(this, speed);
        }

        // // 👇因为重新设置了currentTime 所以要重新设置鼠标按下位置
        // // 否则偏移时间会进行累加 越拖越快越拖越快...
        this.mousedownX = posX;

        this.mousedownupCallback(this.canvas.width, this.zoom, this.currentTime, this.displayTime);
    }

    hoverMove(event) {
        let posX = this.getMouseXRelativePos(event);
        let time = this.getMousePosTime(event);
        this.init();
        this.ctx.beginPath();
        this.ctx.moveTo(posX + 1, 0);
        this.ctx.lineTo(posX + 1, this.canvas.height);
        this.ctx.strokeStyle = "rgb(194, 202, 215)";
        this.ctx.lineWidth = 1;
        this.ctx.stroke();
        this.ctx.fillStyle = "rgb(194, 202, 215)";
        this.ctx.fillText(time.format("yyyy-MM-dd hh:mm:ss"), posX - 50, this.canvas.height - 15);
    }

    getMousePosTime(event) {
        let posX = this.getMouseXRelativePos(event);
        // 每像素多少毫秒
        let onePxsMS = this.canvas.width / (this.totalRulerHours * 60 * 60 * 1000);
        let time = new Date(this.startTimestamp + posX / onePxsMS);
        return time;
    }

    clickEvent(event) {
        var time = this.getMousePosTime(event).getTime();
        this.mousedownX = this.getMouseXRelativePos(event);

        var onePxsMS = this.canvas.width / (this.totalRulerHours * 60 * 60 * 1000);
        var moveX = onePxsMS / 1000;

        // console.log('clickEvent changeCallback')
        this.changeCallback(time, this.mousedownX, moveX);
    }

    wheelEvent(event) {
        event.preventDefault();
        // 是放大一倍还是缩小一倍
        let delta = Math.max(-1, Math.min(1, event.wheelDelta));
        if (delta > 0) {
            this.mountUpTimeLine(event);
        } else if (delta < 0) {
            this.mountDownTimeLine(event);
        }
        // this.totalRulerHours = this.zoom;
        // this.init();
    }

    getMouseXRelativePos(e) {
        let scrollX = document.documentElement.scrollLeft || document.body.scrollLeft;
        let x = event.pageX || event.clientX + scrollX;
        // canvas元素距离窗口左侧距离
        let baseLeft = this.canvas.getBoundingClientRect().x;
        // console.log('---:'+ (x - baseLeft))
        return x - baseLeft;

        // var posx = 0;
        // if (!e) {
        //     e = window.event;
        // }
        // console.log('pageX:'+e.pageX, 'pageY:'+e.pageY)
        // if (e.pageX || e.pageY) {
        //     posx = e.pageX;
        // } else if (e.clientX || e.clientY) {
        //     posx = e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
        // }
        // return posx;
    }

    clearCanvas() {
        if (this.ctx) {
            this.ctx.clearRect(0, 0, this.canvas.width, this.canvas.height);
        }
        if (this.ctx2) {
            this.ctx2.clearRect(0, 0, this.canvas2.width, this.canvas2.height);
        }
    }

    getRaw() {
        return {
            currentTime: this.currentTime,
            timeParts: this.timeParts,
            isMove: this.isMove,
            changeCallback: this.changeCallback
        };
    }

    // 时间区间去重
    uniqueTimeParts() {
        let len = this.timeParts.length;
        if (len <= 1) return;
        this.timeParts.sort((a, b) => {
            return a.start - b.start;
        });
        for (let i = 1; i < len; i++) {
            const element = this.timeParts[i];
            const preElement = this.timeParts[i - 1];
            if (element.start === preElement.start && element.end === preElement.end) {
                element.isRepeat = true;
            }
        }
        this.timeParts = this.timeParts.filter(item => !item.isRepeat);
    }

    destroy() {
        /* 
            1. 解绑所有事件
            2. 清空画布
            3. 清除timer
        */
        // this.canvas.removeEventListener("wheel", this.eventListener.wheel);
        // this.canvas.removeEventListener("mousedown", this.eventListener.mousedown);
        // this.canvas.removeEventListener("mousemove", this.eventListener.mousemove);
        // this.canvas.removeEventListener("mouseup", this.eventListener.mouseup);
        // this.canvas.removeEventListener("mouseleave", this.eventListener.mouseleave);
        //
        // this.canvas2.removeEventListener("wheel", this.eventListener.wheel);
        // this.canvas2.removeEventListener("mousedown", this.eventListener.mousedown);
        // this.canvas2.removeEventListener("mousemove", this.eventListener.mousemove);
        // this.canvas2.removeEventListener("mouseup", this.eventListener.mouseup);
        // this.canvas2.removeEventListener("mouseleave", this.eventListener.mouseleave);

        document.onmouseup = null;
        document.onmousemove = null;
        document.onmousedown = null;
        document.onmouseleave = null;

        this.clearCanvas();
        if (this.moveTimer) {
            clearInterval(this.moveTimer);
            this.moveTimer = null;
        }
    }
};